local ActionManager = class("ActionManager");
require "sound.ConstEffects"

function ActionManager.create()
    local temp = ActionManager.new();
    
    return temp;
end
-- 创建一个Action (移进 移出)
function ActionManager:createUIAction()
    local uiActionClz = require("engine.action.UIAction");  
    return uiActionClz.create(); 
   
end

-- 创建一个Action (淡入淡出)
function ActionManager:createFadeAction()
    local fadeActionClz = require("engine.action.FadeAction");  
    return fadeActionClz.create(); 
end

-- 创建一个Action (果冻抖动)
function ActionManager:createJellyAction()
    local jellyActionClz = require("engine.action.JellyAction");  
    return jellyActionClz.create(); 
end

-- 创建一个Action(中间弹出 关闭)
function ActionManager:createPopAction()
    local popActionClz = require("engine.action.PopAction");
    return popActionClz.create();
end


return ActionManager;