-- 九宫格工具
ThreeUMDGridTools = class("ThreeUMDGridTools",function ()
    return cc.Layer:create();
end)

function ThreeUMDGridTools:ctor(imgUrl,h,cellSize)
    self.endPic= cc.Layer:create();

    --    根据路径先得到原图
    self.srcimg = cc.Sprite:createWithSpriteFrameName(imgUrl)
    
    local signX = self.srcimg:getTextureRect().x --实际代表大图中的 x方向坐标   !!!!如果打入 plist需要这个修正值
    local signY = self.srcimg:getTextureRect().y --实际代表大图中的y方向 坐标  !!!!如果打入 plist需要这个修正值
    
    self.srcImgWidth = self.srcimg:getContentSize().width
    self.srcImgHeight = self.srcimg:getContentSize().height

    self.srcImgTextures = self.srcimg:getTexture()

    --1
    self.upImg = cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX,signY,self.srcImgWidth,cellSize))

    --2
    self.midImg = cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX,signY + cellSize,self.srcImgWidth,self.srcImgHeight-2*cellSize))
    self.midImg:setScaleY((h-2*cellSize)/(self.srcImgHeight-2*cellSize))    
    --3    
    self.underImg = cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX,signY + self.srcImgHeight-cellSize,self.srcImgWidth,cellSize))

    --1 
    --2
    --3

    --    其实坐标  x为0的应该是   cellSize/2  才是完整的0 0左下角 位置

    --1
    local upImgX = self.srcImgWidth/2
    local upImgY =cellSize/2+ h-cellSize/2
    self.upImg:setPosition(cc.p(upImgX,upImgY))
    self.endPic:addChild(self.upImg)
    --2

    local midImgX= self.srcImgWidth/2 
    local midImgY =cellSize/2+cellSize+ (h-2*cellSize)/2   

    self.midImg:setPosition(cc.p(midImgX,midImgY))
    self.endPic:addChild(self.midImg)
    --3
    local underImgX= self.srcImgWidth/2
    local underImgY= cellSize/2+cellSize/2
    self.underImg:setPosition(cc.p(underImgX,underImgY))
    self.endPic:addChild(self.underImg)
    self.endPic:setPosition(-self.srcImgWidth/2,-h/2)

    self:addChild(self.endPic)
    self.srcImgTextures:release()
    self.srcImgTextures:retain()
    return self
end

function ThreeUMDGridTools.create(imgUrl,h,cellSize)
    local endImg = ThreeUMDGridTools.new(imgUrl,h,cellSize)    
    return endImg
end