FtueCelldata=class("FtueCelldata")

function FtueCelldata:ctor()
    self.id = nil              --出现关卡及顺序标示
    self.level = nil           --:级别
    self.con = nil             --1 当前ftue步骤完成后直接显示下一步ftue
    self.trigger = nil         --0 随便点; 1点指定位置
    self.out = nil             --1 设定为游戏外ftue
    self.layer = nil           --是两个层的属性集合 第一个是上层  第二个是底层控制是否可以点击穿透
    
--    tp：代表第2层的类型(0为什么都不画 1为画圆,2为画矩形,3为椭圆,4为黑色的背景);               
--                arrow:指示箭头      [adir;x,y]                              adir方向(1右,2下,3左,4上)；x坐标,y坐标
--                switchArrow:交换箭头        [adir;x,y]                              adir方向(1右,2下,3左,4上)；x坐标,y坐标
--                speArrow:特殊箭头   [asp;x,y]                               asp(1代表横向,2代表纵向);x坐标,y坐标 
--                text:对话内容       ""                                      字符串
--                
--                circles:圆型组         [x,y,r;x,y,r;x,y,r;x,y,r;....]          x坐标 y坐标 r半径             
--                rects:矩形组       [x,y,w,h;x,y,w,h;x,y,w,h;x,y,w,h;....]  x坐标 y坐标 w宽度 h高度
--                ellipses:椭圆组        [x,y,w,h;x,y,w,h;x,y,w,h;x,y,w,h;....]  x坐标 y坐标 w宽度 h高度
--                pic:额外添加的图片                                          pic方向(1右,2下,3左,4上)
--                other:异形抠空      （x,y；空,非空）左上角坐标。0为空,1为非空
--                dialogue：（角的方向,角相对与00的偏移量；x,y,宽,高）  adir方向(1右,2下,3左,4上)
end

function FtueCelldata:initData(idPar,levelPar,conPar,triggerPar,outPar,layerPar)
    self.id = idPar           
    self.level = levelPar       
    self.con = conPar          
    self.trigger = triggerPar      
    self.out = outPar          
    self.layer = layerPar    
end


function FtueCelldata:getId()
	return self.id
end

function FtueCelldata:getLevel()
    return self.level
end

function FtueCelldata:getCon()
    return self.con
end

function FtueCelldata:getTrigger()
    return self.trigger
end

function FtueCelldata:getOut()
    return self.out
end

function FtueCelldata:getLayer()
    return self.layer
end
-- id="1",
--            level="-1",
--            con="0",
--            trigger="1",
--            out="1",
--            layer={{
--                tp="2",
--                rects="395,485,230,80",
--                dialogue="0,0;38,500",
--                text="Why not try it?",
--                pet="1"},
--            {
--                tp="0"}}

return Ftuedata