require("ftue.ftue.FtueCellData")
Ftuedata = class("Ftuedata")

function Ftuedata:ctor()
    self.ftueDataList={}       --存放用到的 ftue的数据属性
    self.showAlreadyFtueIds={} --已经显示过的ftueids 可能不放在这里用
end

--根据ftueId参数取得 对应ftue 的数据属性 
function Ftuedata:getFtueConfigByFtueId(ftueId)

    local tarFtueCellData = nil    
    if self.ftueDataList ~= nil then
        for i = 1,#(self.ftueDataList) do
            if FtueCelldata(self.ftueDataList[i]):getId()==ftueId then
                tarFtueCellData = self.ftueDataList[i]
                break 
            end
        end        
    end
    
    
    if tarFtueCellData == nil then
        local tmpFtueData = MainValue.infosManager:getObjFtueById(ftueId)  
        if tmpFtueData ~= nil then
                
            local ftueCelldata = FtueCelldata.new()
                        
            ftueCelldata:initData(tmpFtueData['id'],tmpFtueData['level'],tmpFtueData['con'],tmpFtueData['trigger'],tmpFtueData['out'],tmpFtueData['layer'])
            
            table.insert(self.ftueDataList,ftueCelldata)
            
            tarFtueCellData = ftueCelldata
        else
            print("[FtueData]--by id ftue data no exit ")
        end
    end
    return tarFtueCellData
end

--判断是否已经存在过后的 ftueid 中不再显示
function Ftuedata:isExitFtueIds(ftueId)
--	self.showAlreadyFtueIds
end

return Ftuedata