require("ftue.ftue.ftuefactory.FtueAssets")
require("ftue.ftue.ftuefactory.FtueDigHoleCreate")
require("ftue.ftue.ftuefactory.BlurShaderCreate")
require("ftue.ftue.ftuefactory.FtueDigRectCreate")



--private var currentFtue:FtueItem;

local touchTirgger=false
local background=nil
local clickSp=nil

local Game_Width = 0
local Game_Height = 0
local Other_OffsetX = 0
local Other_OffsetY = 0


-- //掏空的形状
local ST_NOTHING = 0  --0 无 
local ST_CIRCLES = 1   --1 圆形 circles=" x坐标 y坐标 r半径 
local ST_RECTS = 2    --2 矩形 rects=" x坐标 y坐标 w宽度 h高度   ing
local ST_BLACK = 4      --4 黑色
local ST_OTHER = 5     --5 奇怪形状  ing

local ftueBackGroundConSpr = nil
FtueBackGround = class("FtueBackGround",function ()    
    ftueBackGroundConSpr = cc.Layer:create()
    return ftueBackGroundConSpr
end)

function FtueBackGround:ctor()
    
end
function FtueBackGround:setGameSize(gameW,gameH)
    Game_Width = gameW
    Game_Height = gameH
end

function FtueBackGround:setOtherOffset(offX,offY)
    Other_OffsetX = offX + 172;
    Other_OffsetY = offY + 108;
end


function FtueBackGround:clear()

    if self.frameTextureOuterContourSprEnd~=nil and self.frameTextureOuterContourSprEnd:getSprite() ~=nil then
        if self.frameTextureOuterContourSprEnd:getSprite():getParent() ~= nil then
            self.frameTextureOuterContourSprEnd:getSprite():getParent():removeChild(self.frameTextureOuterContourSprEnd:getSprite())
            self.frameTextureOuterContourSprEnd = nil
        end
    end
    self.ftueDigHoleCreate = nil
   
--    if (background )
--            {
--                if (background.parent != null)
--                    background.parent.removeChild(background);
--                background.dispose();
--                background = null;
--            }
--            
--            if (clickSp)
--            {
--                if (clickSp.parent != null)
--                    clickSp.parent.removeChild(clickSp);
--                clickSp.dispose();
--                clickSp = null;
--            }
end


function FtueBackGround:setBackGround(currentFuteItemPar,rowNum,colNum)--:FtueItem):void
    
    self.currentFtueItem = currentFuteItemPar
    self:clear()
    local tmpTp = self.currentFtueItem:getFtueShape():getTp()
    if tmpTp == ST_OTHER then
        self:setOtherBg(rowNum,colNum)
    elseif tmpTp == ST_NOTHING then--无背景
        self:setNothingBg()
    elseif tmpTp == ST_BLACK then--黑色背景
        self:setBlackBg()
    elseif tmpTp == ST_RECTS then
        self:setRectBg()
    elseif tmpTp == ST_CIRCLES then--圆圈
        self:setCommonBg()
--                    //绘制 鼠标点击区域
--                    //background.touchable = false;
--                    //setCommonTestBg();
    end
            
            
--            //拦截层

           --[[ clickSp = new Quad(Game_Width,Game_Height);
            clickSp.alpha = 0;
            clickSp.touchable = !currentFtue.trigger;
            this.addChild(clickSp);--]]
end

function FtueBackGround:setRectBg()
    
    local tmpRect = self.currentFtueItem:getFtueShape():getShapeRect()
    
    if tmpRect == nil then return end
    
    local blackTexture =  MainValue.mxFTUEManager:getFtuet():getFtueAssets():getFtueTextureFrame("black");
    
    
   
    self.ftueDigRectCreate= FtueDigRectCreate.new(tmpRect,blackTexture,self.currentFtueItem:getPostp())
    
    local otherShap = self.ftueDigRectCreate:drawRectShap() --返回拼接好的扣空图形 需要取反色
    
    self.digHoleRectAry = self.ftueDigRectCreate:getDigHoleRectAry()
    
    local frameTextureOuterContourSprEndReal = cc.RenderTexture:create(MainValue.winSize.width,MainValue.winSize.height)
    self.frameTextureOuterContourSprEnd = cc.RenderTexture:create(MainValue.winSize.width,MainValue.winSize.height)
        
    self.frameTextureOuterContourSprEnd:begin()    
    otherShap:visit() --要截屏的场景    
    self.frameTextureOuterContourSprEnd:endToLua()
    
    local blurShaderCreate = BlurShaderCreate.new()     
    blurShaderCreate:setBlurShader(self.frameTextureOuterContourSprEnd:getSprite())
  
    self.frameTextureOuterContourSprEnd:getSprite():setPosition(VisibleRect:center()) --MainValue.winSize.width * 0.5,MainValue.winSize.height * 0.5)
    
    
    frameTextureOuterContourSprEndReal:begin()  
    self.frameTextureOuterContourSprEnd:getSprite():visit() --要截屏的场景    
    frameTextureOuterContourSprEndReal:endToLua()
    
    
    frameTextureOuterContourSprEndReal:getSprite():setPosition(VisibleRect:center())
    
    if frameTextureOuterContourSprEndReal:getSprite():getParent() ~= nil then
        frameTextureOuterContourSprEndReal:getSprite():getParent():removeChild(frameTextureOuterContourSprEndReal:getSprite())
    end
    ftueBackGroundConSpr:addChild(frameTextureOuterContourSprEndReal:getSprite());
        
end

function FtueBackGround:setOtherBg(rowNum,colNum)

--    self.blackTexture =  MainValue.mxFTUEManager:getFtuet():getFtueAssets():getFtueTextureFrame("black"); --var blackTexture:Texture = FtueAssets.getFtueTextureFrame("black");
--    self.frameTexture =  MainValue.mxFTUEManager:getFtuet():getFtueAssets():getFtueTextureFrame("frame");--var frameTexture:Texture = FtueAssets.getFtueTextureFrame("frame");
    self.otherData = self.currentFtueItem:getFtueShape():getOtherData() 

    self.operateOtherData = self.currentFtueItem:getFtueShape():getOperateDotsData()--可操作的区域数据
    
    self.canSwapCoordinaAry = self.currentFtueItem:getFtueShape():getCanSwapCoorDinaAryByOperateData()
    
    self.otherStartIndexX = self.currentFtueItem:getFtueShape():getX()
    self.otherStartIndexY = self.currentFtueItem:getFtueShape():getY()

    self.ftueDigHoleCreate = FtueDigHoleCreate.new()

    self.ftueDigHoleCreate:createDrawDigHole(self.otherData,rowNum,colNum,self.otherStartIndexX,self.otherStartIndexY,self.operateOtherData)

    local otherShap = self.ftueDigHoleCreate:drawOtherShap() --返回拼接好的扣空图形 需要取反色

    self.digHoleOtherAry = self.ftueDigHoleCreate:getDigHoleOtherAry()
    local frameTextureOuterContourSprEndReal = cc.RenderTexture:create(MainValue.winSize.width,MainValue.winSize.height)

    local frameTextureOuterContourSprEnd = cc.RenderTexture:create(MainValue.winSize.width,MainValue.winSize.height)

    frameTextureOuterContourSprEnd:begin()    
    otherShap:visit() --要截屏的场景    
    frameTextureOuterContourSprEnd:endToLua()

    local blurShaderCreate= BlurShaderCreate.new()     
    blurShaderCreate:setBlurShader(frameTextureOuterContourSprEnd:getSprite())
    frameTextureOuterContourSprEnd:getSprite():setPosition(MainValue.winSize.width * 0.5 , MainValue.winSize.height * 0.5)
    
    
    frameTextureOuterContourSprEndReal:begin()  
    frameTextureOuterContourSprEnd:getSprite():visit() --要截屏的场景    
    frameTextureOuterContourSprEndReal:endToLua()

    frameTextureOuterContourSprEndReal:getSprite():setPosition(MainValue.winSize.width * 0.5 , MainValue.winSize.height * 0.5)

    if frameTextureOuterContourSprEndReal:getSprite():getParent() ~= nil then
        frameTextureOuterContourSprEndReal:getSprite():getParent():removeChild(frameTextureOuterContourSprEndReal:getSprite())
    end    
    ftueBackGroundConSpr:addChild(frameTextureOuterContourSprEndReal:getSprite());     

end
        
function FtueBackGround:setCommonBg()
    local srcTexture = nil --var srcTexture:Texture;
--            if (currentFtue.ftueShape.tp == FtueItem.ST_RECTS)
--                srcTexture = FtueAssets.getFtueTextureFrame("rect");
--            else
--                srcTexture = FtueAssets.getFtueTextureFrame("circle");
    if self.currentFtueItem:getFtueShape():getTp() == ST_RECTS  then
        srcTexture = FtueAssets:getFtueTextureFrame("rect");
    else
        srcTexture = FtueAssets:getFtueTextureFrame("circle");
    end
            
    if self.currentFtueItem:getFtueShape():getTp() == ST_RECTS then
        background = NineGridSprite:stretchGrid9Image2(srcTexture, cc.rect(1, 1, srcTexture.width - 2, srcTexture.height - 2),
            self.currentFtueItem:getFtueShape():getShapeRect(), cc.rect(0,0,Game_Width,Game_Height));
    else
        background = NineGridSprite.stretchGrid9Image(srcTexture, cc.rect(1, 1, srcTexture.width - 2, srcTexture.height - 2),
            self.currentFtueItem:getFtueShape():getShapeRect(), cc.rect(0,0,Game_Width,Game_Height));
    end            
            
--            if (currentFtue.ftueShape.tp == FtueItem.ST_RECTS)
--            {
--                background = NineGridSprite.stretchGrid9Image2(srcTexture, new Rectangle(1, 1, srcTexture.width - 2, srcTexture.height - 2),
--                    currentFtue.ftueShape.getShapeRect(), new Rectangle(0,0,Game_Width,Game_Height));
--            }
--            else
--            {
--                background = NineGridSprite.stretchGrid9Image(srcTexture, new Rectangle(1, 1, srcTexture.width - 2, srcTexture.height - 2),
--                    currentFtue.ftueShape.getShapeRect(), new Rectangle(0,0,Game_Width,Game_Height));
--            }

--            this.addChild(background);
    ftueBackGroundConSpr:addChild(background);
end
        
function FtueBackGround:setBlackBg()
    local srcTexture = FtueAssets:getFtueTextureFrame("black"); --var srcTexture:Texture = FtueAssets.getFtueTextureFrame("black");
    local bgSpr = cc.Sprite:createWithTexture(srcTexture) 
--            background = new Image(srcTexture);
   local srcTextureW = srcTexture:getContentSize().width
   local srcTextureH = srcTexture:getContentSize().height
    bgSpr:setPosition(MainValue.winSize.width * 0.5,MainValue.winSize.height * 0.5)
    bgSpr:setScaleX(Game_Width/srcTextureW)
    bgSpr:setScaleY(Game_Height/srcTextureH)
    
    ftueBackGroundConSpr:addChild(bgSpr);
            
--            background.width = Game_Width;
--            background.height = Game_Height;
--            this.addChild(background);
end    
        


--返回挖洞的矩形区域数组 other类型的
function FtueBackGround:getDigHoleOtherAry() 
	return self.digHoleOtherAry
end


--返回挖洞的矩形区域数组 other类型的
function FtueBackGround:getEndShapePos()   
    return self.ftueDigHoleCreate:getEndShapePos()
end

--返回挖洞的矩形区域数组 rect正常类型的
function FtueBackGround:getDigHoleRectAry() 
    return self.digHoleRectAry
end



function FtueBackGround:setNothingBg()
--            background = new Quad(Game_Width,Game_Height);
--            background.alpha = 0;
--            this.addChild(background);
end
--@param swapPstAry 根据当前交换的坐标来判断是否允许交换  2015-1-13
function FtueBackGround:isAllowSwapByFtue(swapPstAry)
--    local tempStr = swapPstAry
--    tempStr = loadstring("return "..tempStr)();
    
    local isCanSwap = false
    local tmpTp = self.currentFtueItem:getFtueShape():getTp()
    if tmpTp == ST_OTHER then
        print("--[FtueBackGround]---isAllowSwapByFtue()---::"..self.canSwapCoordinaAry)  -- 等待黄启辉的调用 2015-1-13 坐标从以开始的 
    else
        isCanSwap = true
    end
    return isCanSwap
end


--[[
        
        private function setBlackBg():void
        {
            var srcTexture:Texture = FtueAssets.getFtueTextureFrame("black");
            background = new Image(srcTexture);
            background.width = Game_Width;
            background.height = Game_Height;
            this.addChild(background);
        }
        
        private function setCommonBg():void
        {
            var srcTexture:Texture;
            if (currentFtue.ftueShape.tp == FtueItem.ST_RECTS)
                srcTexture = FtueAssets.getFtueTextureFrame("rect");
            else
                srcTexture = FtueAssets.getFtueTextureFrame("circle");
            
            
            if (currentFtue.ftueShape.tp == FtueItem.ST_RECTS)
            {
                background = NineGridSprite.stretchGrid9Image2(srcTexture, new Rectangle(1, 1, srcTexture.width - 2, srcTexture.height - 2),
                    currentFtue.ftueShape.getShapeRect(), new Rectangle(0,0,Game_Width,Game_Height));
            }
            else
            {
                background = NineGridSprite.stretchGrid9Image(srcTexture, new Rectangle(1, 1, srcTexture.width - 2, srcTexture.height - 2),
                    currentFtue.ftueShape.getShapeRect(), new Rectangle(0,0,Game_Width,Game_Height));
            }

            this.addChild(background);
        }
        
        private function setCommonTestBg():void
        {
            var srcTexture:Texture;
            if (currentFtue.mouseShape.tp == FtueItem.ST_RECTS)
                srcTexture = FtueAssets.getFtueTextureFrame("rect");
            else
                srcTexture = FtueAssets.getFtueTextureFrame("circle");
            
            clickSp = NineGridSprite.stretchGrid9Image(srcTexture, new Rectangle(1, 1, srcTexture.width - 2, srcTexture.height - 2),
                currentFtue.mouseShape.getShapeRect(), new Rectangle(0,0,Game_Width,Game_Height));
            clickSp.alpha = 0;
            this.addChild(clickSp);
        }
        
        private function setOtherTestBg():void
        {
            var srcTexture:Texture = FtueAssets.getFtueTextureFrame("black");
            
            if (currentFtue.mouseShape.tp == FtueItem.ST_OTHER)
            {
                var tempSp:Sprite = new Sprite();
                var otherData:Array = currentFtue.ftueShape.getOtherData();
                for (var line:int=1; line < otherData.length-1; line++)
                {
                    for (var index:int=1; index < otherData[line].length-1; index++)
                    {
                        if (otherData[line][index])
                        {
                            var one:Image = new Image(srcTexture);
                            one.x = (currentFtue.ftueShape.shape.x + index - 2) * srcTexture.width + Other_OffsetX;
                            one.y = (currentFtue.ftueShape.shape.y + line - 2) * srcTexture.height + Other_OffsetY;
                            one.alpha = 0;
                            tempSp.addChild(one);
                        }
                    }
                }
                
                clickSp = tempSp;
                this.addChild(clickSp);
            }
        }
        
       --]]
return FtueBackGround