require("ftue.ftue.ftuefactory.DrawCell")
FtueDigRectCreate = class("FtueDigRectCreate")

-- 外框的尺寸和内框的尺寸
function FtueDigRectCreate:ctor(rectShapeData,blackTexturePar,postpPar)
   
  
    self.otherData = rectShapeData
    self.blackTexture = blackTexturePar
    self.drawRectX = rectShapeData:getX() --绘制Rect X    
    self.drawRectY = rectShapeData:getY() --绘制Rect Y   
    self.drawRectW = rectShapeData:getW() --绘制Rect宽    
    self.drawRectH = rectShapeData:getH() --绘制Rect高
    self.postp = postpPar
    self.digHoleRectAry = {}
    
end



function FtueDigRectCreate:drawRectShap()
    local endShape = cc.Sprite:create()
    
    local rectShapSpr = cc.Sprite:createWithTexture(self.blackTexture,cc.rect(0,0,80,80))  
    
    local xRate = self.drawRectW/80
    local yRate = self.drawRectH/80
    
    rectShapSpr:setScaleX(xRate)
    rectShapSpr:setScaleY(yRate)
        
        
    -- postp: ****新加属性****  表示位置相对于屏幕的基准处理   0-bottom  1-left  2-right  3-top 4-center ！！！！！！！！！！！
        
--        postp: ****新加属性****  表示位置相对于屏幕的基准处理   0-bottom  1-left  2-right  3-top 4-center ！！！！！！！！！！！ 
    local offsetX
    local offsetY
    local pstX
    local pstY
    
    if self.postp == 4 then --如果是以center为参照 还需要处理
        pstX = VisibleRect:center().x + self.drawRectX + xRate * 80 * 0.5
        pstY = VisibleRect:center().y + self.drawRectY  + yRate * 80 * 0.5 
    elseif self.postp == 0 then -- bottom        
        pstX = VisibleRect:bottom().x + self.drawRectX + xRate * 80 * 0.5  
        pstY = VisibleRect:bottom().y+ self.drawRectY + yRate * 80 * 0.5
    elseif self.postp == 1 then -- left 
        pstX = VisibleRect:left().x + self.drawRectX + xRate * 80 * 0.5
        pstY = self.drawRectY + yRate * 80 * 0.5
    elseif self.postp == 3 then -- top
        pstX = VisibleRect:top().x + self.drawRectX + xRate * 80 * 0.5  
        pstY = VisibleRect:top().y + self.drawRectY + yRate * 80 * 0.5
--    else 
--        offsetX = tonumber(self.drawRectX) - 684 * 0.5  --如果是以其他为参照 还需要处理
--        offsetY = tonumber(self.drawRectY) - 1024 * 0.5      
--        pstX = VisibleRect:center().x + offsetX + xRate * 80 * 0.5
--        pstY = VisibleRect:center().y + offsetY + yRate * 80 * 0.5 
    end
    
--  71如果以botton为参照 ！！！！！继续 71 ftue测处理 ！！！！！！！！！！！！！！！！！！！！！！！！    
    rectShapSpr:setPosition(cc.p(pstX , pstY))
    
--  local xPer = self.drawRectX /684                  --对于flash版本的位置偏移比率
--  local yPer = self.drawRectY /1024          --对于flash版本的位置偏移比率 
--  local endX = MainValue.winSize.width * xPer
--  local endY = MainValue.winSize.height * yPer
--  local tmpX = xRate * 80 * 0.5 + endX
--  local tmpY = yRate * 80 * 0.5 + endY    
--  rectShapSpr:setPosition(tmpX,tmpY)

--  2014-12-12新加游戏内非游戏地图区域的巨型区域挖洞处理

    table.insert(self.digHoleRectAry,cc.rect(pstX , pstY , self.drawRectW * xRate , self.drawRectH * yRate))
    endShape:addChild(rectShapSpr) 
        
    return endShape
end

function FtueDigRectCreate:getDigHoleRectAry()-- 71测试用到
    return self.digHoleRectAry
end

return FtueDigRectCreate