require("ftue.ftue.ftuefactory.innercls.Dialogue")
require("ftue.ftue.ftuefactory.innercls.Arrow")
require("ftue.ftue.ftuefactory.innercls.BackGroundShape")

--////////////////////////静态常量////////////////////////
--        //箭头，对话框方向
--        public static var DIR_NO:int = 0;
--        public static var DIR_RIGHT:int = 1;
--        public static var DIR_DOWN:int = 2;
--        public static var DIR_LEFT:int = 3;
--        public static var DIR_UP:int = 4;
--        //对话框上头像显示方式
--        public static var AVA_Hide:int = 0;
--        public static var AVA_LEFT:int = 1;
--        public static var AVA_RIGHT:int = 2;
--        //掏空的形状
--        public static var ST_NOTHING:int = 0;  //0 无
--        public static var ST_CIRCLES:int = 1;   //1 圆形 circles=" x坐标 y坐标 r半径
--        public static var ST_RECTS:int = 2;      //2 矩形 rects=" x坐标 y坐标 w宽度 h高度
--        public static var ST_BLACK:int = 4;      //4 黑色
--        public static var ST_OTHER:int = 5;     //5 奇怪形状
--        ////////////////////////END////////////////////////
--        
--        public var id:int;
--        public var level:int;
--        public var trigger:Boolean;//false 随便点; true 点指定位置
--        public var out:Boolean;//true->游戏外
--        public var con:Boolean;//是否继续下个ftue
--        public var delay:Number;//延时出现
--        public var delayClose:Number;//延时消失
--        
--        public var ftueShape:BackgroundShape;
--        public var mouseShape:BackgroundShape;
--        public var dialogue:Dialogue;
--        public var arrow:Arrow;
--        public var switchArrow:SwitchArrow;
--        public var video:FtueVideo;
--        
--        public var isLast:Boolean;

--//箭头，对话框方向
--local DIR_NO=0
--local DIR_RIGHT=1
--local DIR_DOWN=2
--local DIR_LEFT=3
--local DIR_UP=4

--//对话框上头像显示方式
local AVA_Hide = 0
local AVA_LEFT=1
local AVA_RIGHT=2


-- //掏空的形状
local ST_NOTHING = 0  --0 无
local ST_CIRCLES = 1   --1 圆形 circles=" x坐标 y坐标 r半径
local ST_RECTS = 2    --2 矩形 rects=" x坐标 y坐标 w宽度 h高度
local ST_BLACK = 4      --4 黑色
local ST_OTHER = 5     --5 奇怪形状


--local id = 0
--local level=0
--local trigger=false--//false 随便点; true 点指定位置
--local out=false--//true->游戏外
--local con=false--//是否继续下个ftue
--local delay=0.1--//延时出现
--local delayClose=0.2--//延时消失




local ftueShape = nil
local mouseShape = nil
local dialogue = nil
local arrow = nil
local switchArrow = nil
local video = nil



FtueItem = class("FtueItem")
function FtueItem:ctor()
    self.isLast = false
end


function  FtueItem:setDialogue(data, petPose, petName, text) 
          
    self.dialogue = Dialogue.new();
    if data == nil then
        self.dialogue:setIsShow(false)
    end
--            local configAry ={}                                         
            --  data 根据标点把其切割 这里的配置文件已经 不是匹配的应用  0，0,110,123 实际用的  110 123 是x y 坐标 不是宽高  宽高是根据显示文字内容动态控制的  
--          "0,0;38,500"
    self.dialogue:setIsShow(true)
            
    if data == nil then
        self.dialogue:setIsShow(false)
        return
    elseif data == "" then
        self.dialogue:setIsShow(false)
        return
    end
            
            
    local dataStr = tostring(data)
            
    local arrayT = self:getAryByStrTools(dataStr)  -- data.split(/;|,/g);
            
--            dialogue:setAspectPar(arrayT[1])
--            dialogue:setArrowOffsetPar(arrowOffsetPar)

    self.dialogue:setXPar(arrayT[1])
    self.dialogue:setYPar(arrayT[2])
            
--            dialogue:setWPar(wPar)
--            dialogue:setHPar(hPar)
    self.dialogue:setPetName(petName);
    self.dialogue:setPetTypePar(petPose)
    self.dialogue:setTextPar(text)
end

function  FtueItem:getDialogue()    
    return self.dialogue 
end



function FtueItem:setArrow(data)--string
    self.arrow = Arrow.new();
    if data == nil then
         self.arrow:setIsShow(false)
    end
        self.arrow:setIsShow(true)
    if data==nil then
        self.arrow:setIsShow(false)
        return
    elseif data=="" then
        self.arrow:setIsShow(false)
        return
    end
--           
    local arrayT = self:getAryByStrTools(data)   -- data.split(/;|,/g);  
    self.arrow:setIsShow(true)
    self.arrow:setAspect(arrayT[1])
    self.arrow:setXPar(arrayT[2])
    self.arrow:setYPar(arrayT[3])
            
--            var array:Array = data.split(/;|,/g);
--            arrow.isShow = true;
--            arrow.aspect = array[1];--表示箭头的方向
--            arrow.x = array[2];
--            arrow.y = array[3];
end


function FtueItem:setSwitchArrow(data)
    self.switchArrow = Arrow.new();
    if data == nil then
        self.switchArrow:setIsShow(false)
        return
    end
    if data=="" then
        self.switchArrow:setIsShow(false)
        return
    end
    --           
    local arrayT = self:getAryByStrTools(data)   -- data.split(/;|,/g);  
    self.switchArrow:setIsShow(true)
    self.switchArrow:setAspect(arrayT[1])
    self.switchArrow:setXPar(arrayT[2])
    self.switchArrow:setYPar(arrayT[3])
end

function FtueItem:getSwitchArrow()
    return self.switchArrow
end

function  FtueItem:getId(idPar)    
    return self.id
end

function FtueItem:getArrow()
	return self.arrow
end

function  FtueItem:setId(idPar)    
    self.id= idPar
end

function  FtueItem:setPostp(pstTpPar)    
    self.pstTp= pstTpPar
end

function  FtueItem:getPostp()    
    return self.pstTp
end


function FtueItem:setLevel(levelPar)
    self.level = levelPar
end

function FtueItem:setTrigger(triggerPar)--//false 随便点; true 点指定位置
    self.trigger = triggerPar
end

function FtueItem:getTrigger()--//false 随便点; true 点指定位置
    return self.trigger
end

function FtueItem:setOut(outPar)--//true->游戏外
    self.out = outPar
end

function FtueItem:setCon(conPar)--//是否继续下个ftue
    self.con = conPar
end

function FtueItem:getCon()--//是否继续下个ftue
    return self.con
end


function FtueItem:setDelay(delayPar)--//延时出现
    self.delay = delayPar
end
function FtueItem:setDelayClose(delayClosePar)--//延时消失
    self.delayClose = delayClosePar
end

function FtueItem:setFtueShape(tp, data,operateData)--(tp:int, data:String)
    self.ftueShape = BackGroundShape.new(tp,data,operateData)-- new BackgroundShape(tp, data);
end

function FtueItem:setIsLast(isLastPar)
    self.isLast = isLastPar
end


function FtueItem:getIsLast(isLastPar)
    return self.isLast
end


function FtueItem:getFtueShape()
	return self.ftueShape
end
        
        
function FtueItem:setMouseShape(tp, data)--(tp:int, data:String):void
    self.mouseShape = BackGroundShape.new(tp,data)-- new BackgroundShape(tp, data);
end




--生命一个工具函数  "0,0,10,60"  这样的字符串以标点分开后放进数组中 
--形成 {0,0,10,60}
function FtueItem:getAryByStrTools(tmoStr)
    local endPstAry={} 
    local pointAry={}  
    local i=0
    for i=1,string.len(tmoStr)do
        local tmpChar = string.sub(tmoStr,i,i)
        local tmpNum = tonumber(tmpChar)
        if tmpNum == nil and tmpChar ~= "-" then
            table.insert(pointAry,i)
        end   
    end

    local indexOld = 0    
    local pointAryLen=table.maxn(pointAry)

    for index, v in pairs(pointAry) do        
        local tmpPstNum        
        if indexOld==0 then
            tmpPstNum = string.sub(tmoStr,1,v-1)
        else
            tmpPstNum= string.sub(tmoStr,indexOld+1,v-1)
        end   
        table.insert(endPstAry,tmpPstNum)        
        indexOld = v
    end   



    local endnum    
    if pointAryLen==0 then
        endnum = tmoStr
    else
        endnum = string.sub(tmoStr,pointAry[pointAryLen]+1,string.len(tmoStr))
    end

    table.insert(endPstAry,endnum)

    return  endPstAry
        --    print(endPstAry)       
end

return FtueItem