require "game.model.logics.Interval";
MissionGrid = class("MissionGrid")


     MissionGrid.ClearMode =  {
            MODE_NONE = 0,          --无标记消除状态
            MODE_3_HORIZONTAL=1,      --三消 - 横
            MODE_3_VERTICAL=2,--    三消-竖
            MODE_4_HORIZONTAL=3,          --四消-横
            MODE_4_VERTICAL=4,            --四消-竖
            MODE_5_HORIZONTAL=5,          --五消-横
            MODE_5_VERTICAL=6,            --五消-竖
            MODE_CROSS=7,                 --十字星
            MODE_L_T=8,                    --L T型炸弹
        };
        
    MissionGrid.DropStatus =
    {
        REST = 0,
        MOVE = 1,
        MOVE_X = 2,
    };
    
    MissionGrid.Direction = 
    {
        DirAtWill = -1,         --不计算的方向
        DirTop = 0,
        DirDown= 1,
        DirLeft= 2,
        DirRight= 3,
    };
    
    MissionGrid.EliminateType = 
    {
   
        DIR_H = 2;

        DIR_V = 3;
    };
    
    

    
    
    
     MissionGrid.BORDER = -2;
     MissionGrid.BLANK = -1;
     MissionGrid.NONE = 0;

  
     MissionGrid.ICE_CREAM_1 = 100;

   
     MissionGrid.ICE_CREAM_2 = 200;

   
     MissionGrid.ICE_CREAM_3 = 300;

   
     MissionGrid.ICE_CREAM_4 = 400;

  
     MissionGrid.ICE_CREAM_5 = 500;

  
     MissionGrid.ICE_CREAM_6 = 600;

    
     MissionGrid.ICE_CREAM_MELT_1 = 102;

    
     MissionGrid.ICE_CREAM_MELT_2 = 202;

   
     MissionGrid.ICE_CREAM_MELT_3 = 302;

  
     MissionGrid.ICE_CREAM_MELT_4 = 402;

  
     MissionGrid.ICE_CREAM_MELT_5 = 502;


   
     MissionGrid.ICE_CREAM_9 = 900;

   
     MissionGrid.ICE_CREAM_901 = 901;


    -------------------------------------------------------------------------------------------
 
     MissionGrid.PU_BOMB_9_1 = 2101;--九格炸弹 3X3    有颜色的     100代表颜色   个位代表类型
   
     MissionGrid.PU_BOMB_9_2 = 2201;--九格炸弹 3X3    有颜色的     200代表颜色   个位代表类型 
   
     MissionGrid.PU_BOMB_9_3 = 2301;--九格炸弹 3X3    有颜色的     300代表颜色   个位代表类型 
    
     MissionGrid.PU_BOMB_9_4 = 2401;--九格炸弹 3X3    有颜色的     400代表颜色   个位代表类型 
    
     MissionGrid.PU_BOMB_9_5 = 2501;--九格炸弹 3X3    有颜色的     500代表颜色   个位代表类型 


     MissionGrid.PU_BOMB_13_1 = 2111;--九格炸弹 3X3 + 4   有颜色的     100代表颜色   个位代表类型    十位代表 大小
  
     MissionGrid.PU_BOMB_13_2 = 2211;--九格炸弹  3X3 + 4  有颜色的     200代表颜色   个位代表类型 
   
     MissionGrid.PU_BOMB_13_3 = 2311;--九格炸弹 3X3 + 4   有颜色的     300代表颜色   个位代表类型 
    
     MissionGrid.PU_BOMB_13_4 = 2411;--九格炸弹  3X3 + 4  有颜色的     400代表颜色   个位代表类型 
   
     MissionGrid.PU_BOMB_13_5 = 2511;--九格炸弹 3X3 + 4   有颜色的     500代表颜色   个位代表类型 




    --/**PU区间基数*/
     MissionGrid.PU_INTERVAL_BASE_NUM = 2000;

  
     MissionGrid.PU_ROCKET_H1 = 2102;--横向火箭     有颜色的 个位数表示方向  横向
   
     MissionGrid.PU_ROCKET_H2 = 2202;--横向火箭     有颜色的
   
     MissionGrid.PU_ROCKET_H3 = 2302;--横向火箭     有颜色的
   
     MissionGrid.PU_ROCKET_H4 = 2402;--横向火箭     有颜色的
   
     MissionGrid.PU_ROCKET_H5 = 2502;--横向火箭     有颜色的




   
     MissionGrid.PU_ROCKET_V1 = 2103;-- 纵向火箭     有颜色的 个位数表示方向  纵向
 
     MissionGrid.PU_ROCKET_V2 = 2203;-- 纵向火箭     有颜色的
  
     MissionGrid.PU_ROCKET_V3 = 2303;-- 纵向火箭     有颜色的
   
     MissionGrid.PU_ROCKET_V4 = 2403;-- 纵向火箭     有颜色的
  
     MissionGrid.PU_ROCKET_V5 = 2503;-- 纵向火箭     有颜色的

   
     MissionGrid.PU_RAINBOW = 1000; -- 匹配颜色消除  彩虹(五彩球)


  
     MissionGrid.PD_CANDY_0 = 3010;
  
     MissionGrid.PD_CANDY_1 = 3011;

   
     MissionGrid.PD_CANDY_2 = 3012;

   
     MissionGrid.PD_CANDY_3 = 3013;

     MissionGrid.PD_POPCORN = 3021;

  
     MissionGrid.PD_CAKE = 3031;


  
     MissionGrid.PD_FRUIT_BERRIES  = 3041;


    --PowerDown
  
     MissionGrid.BOSS1_CHOCOLATE = 1;
  
     MissionGrid.BOSS2_POPCORN = 2;
  
     MissionGrid.BOSS3_BISCUIT = 3;

  
     MissionGrid.BOSS4 = 4;

  
     MissionGrid.BOSS5 = 5;

  
     MissionGrid.BOSS6 = 6;

   
     MissionGrid.BOSS7 = 7;


     MissionGrid.BOSS8 = 8;


     MissionGrid.BOSS9_UFO = 9;


    MissionGrid.BRICK_11 = 11;
    MissionGrid.BRICK_12 = 12;
    MissionGrid.BRICK_13 = 13;


    MissionGrid.TYPE_FRUIT_PLATE = 30;
    
   
   
   
   
   -------------------------
    MissionGrid.CM_KEY_1_CHOCOLATE = 1;
   
    MissionGrid.CM_KEY_4_SUGAR = 4;
   
    MissionGrid.CM_KEY_9_UFO = 9;
    

   

------------------------------------------------------------------------------




--/**
--* 炸弹
--*/

MissionGrid.PU_KEY_BOMBO = 1
--/**
--* 个位2表示横向火箭
--*/
MissionGrid.PU_KEY_ROCKET_H = 2
--/**
--* 个位3表示纵向火箭
--*/
MissionGrid.PU_KEY_ROCKET_V = 3

--//火箭消除类型
--/** 横向消除*/
MissionGrid.LINE_H = 1

--/**纵向消除 */
MissionGrid.LINE_V = 2

--/**横+纵向消除 */
MissionGrid.LINE_H_V = 3




MissionGrid.INTERVAL_BOSS = Interval.new(1,100)
MissionGrid.INTERVAL_COMMON = Interval.new(100,1000)
MissionGrid.INTERVAL_POWER_UP = Interval.new(1000,3000)
MissionGrid.INTERVAL_POWER_DOWN = Interval.new(3000,7000)

function MissionGrid.isBoss(mapV)
    return MissionGrid.INTERVAL_BOSS:includeValue(mapV);
end;

function MissionGrid.isCommonCell(mapV)
    return MissionGrid.INTERVAL_COMMON:includeValue(mapV);
end;

function MissionGrid.isPowerUp(mapV)
    return MissionGrid.INTERVAL_POWER_UP:includeValue(mapV);
end;

function MissionGrid.isPowerDown(mapV)
    return MissionGrid.INTERVAL_POWER_DOWN:includeValue(mapV);
end;

function MissionGrid.isBombo(mapV)
    return MissionGrid.isPowerUp(mapV) and mapV % 10 == MissionGrid.PU_KEY_BOMBO;
end

--/**
-- * 判断是否是大炸弹
-- * @param mapV （必须为POWERUP 区间的值）
-- * @return   bool 
-- */
function MissionGrid.isBigBomb(mapV)
    return MissionGrid.isBombo(mapV) and (math.floor((mapV % 100) / 10) == MissionGrid.PU_KEY_BOMBO)
end

function MissionGrid.isEli(mapV)
    return MissionGrid.isEliH(mapV) or MissionGrid.isEliV(mapV);
end;

--/**
-- * 是否是水平火箭
-- * @param mapV 
-- * @return   bool 
-- */
function MissionGrid.isEliH(mapV)
    return MissionGrid.isPowerUp(mapV) and (mapV % 10 == MissionGrid.PU_KEY_ROCKET_H and (mapV % 1000 > 6))
end


--是否是竖直火箭
--@param mapV
--@return bool
function MissionGrid.isEliV(mapV)
    return MissionGrid.isPowerUp(mapV) and (mapV % 10 == MissionGrid.PU_KEY_ROCKET_V and (mapV % 1000 > 6))
end


function MissionGrid.isCandy( mapV)
  
    return math.floor(mapV / 10) % 10 == 1 and  MissionGrid.isPowerDown(mapV);
end

function MissionGrid.isPopcorn( mapV)
  
    return math.floor(mapV / 10) % 10 == 2 and  MissionGrid.isPowerDown(mapV);
end

function MissionGrid.isCake( mapV)
  
    return math.floor(mapV / 10) % 10 == 3 and  MissionGrid.isPowerDown(mapV);
end

function MissionGrid.isFruit( mapV)
  
    return math.floor(mapV / 10) % 10 == 4 and  MissionGrid.isPowerDown(mapV);
end





function MissionGrid.isSugar( mapV)
    
    return MissionGrid.isCommonCell(mapV) and (mapV % 10 == MissionGrid.CM_KEY_4_SUGAR);
end
   
function MissionGrid.isChocolate(mapV)

    return MissionGrid.isCommonCell(mapV) and (mapV % 10 == MissionGrid.CM_KEY_1_CHOCOLATE);
end


