require "game.model.logics.LogicStatus"
local StatusLogic = class("StatusLogic")

function StatusLogic:ctor()
    local tempIndex = 0
--    //self.noneBrick
    self._noneBrick = LogicStatus.new()
    self._noneBrick.id = tempIndex
    self._noneBrick.move = false;
    self._noneBrick.dropOut = false;
    self._noneBrick.mathch = false;
    self._noneBrick.neighborMathch = false;
    self._noneBrick.destroy = false;
    self._noneBrick.cross = true;
    self._noneBrick.swap = false;
    
    tempIndex = tempIndex + 1
--    //self._blankBrick
    self._blankBrick = LogicStatus.new()
    self._blankBrick.id = tempIndex
    self._blankBrick.move = false;
    self._blankBrick.dropOut = false;
    self._blankBrick.mathch = false;
    self._blankBrick.neighborMathch = false;
    self._blankBrick.destroy = false;
    self._blankBrick.cross = true;
    self._blankBrick.swap = false;
    
    tempIndex = tempIndex + 1
--    //self._borderBrick
    self._borderBrick = LogicStatus.new()
    self._borderBrick.id = tempIndex
    self._borderBrick.move = false;
    self._borderBrick.dropOut = false;
    self._borderBrick.mathch = false;
    self._borderBrick.neighborMathch = false;
    self._borderBrick.destroy = false;
    self._borderBrick.cross = false;
    self._borderBrick.swap = false;
    
    tempIndex = tempIndex + 1
--    //self._commonBrick
    self._commonBrick = LogicStatus.new()
    self._commonBrick.id = tempIndex
    self._commonBrick.move = true;
    self._commonBrick.dropOut = false;
    self._commonBrick.mathch = true;
    self._commonBrick.neighborMathch = false;
    self._commonBrick.destroy = true;
    self._commonBrick.cross = false;
    self._commonBrick.swap = true;
    

    
    tempIndex = tempIndex + 1
    self._powUpBrick = LogicStatus.new()
    self._powUpBrick.id = tempIndex;
    self._powUpBrick.move = true;
    self._powUpBrick.dropOut = false;
    self._powUpBrick.mathch = true;
    self._powUpBrick.neighborMathch = false;
    self._powUpBrick.destroy = true;
    self._powUpBrick.cross = false;
    self._powUpBrick.swap = true;

    tempIndex = tempIndex + 1
   
    self._powUpActiveBrick = LogicStatus.new()
    self._powUpActiveBrick.id = tempIndex;
    self._powUpActiveBrick.move = true;
    self._powUpActiveBrick.dropOut = false;
    self._powUpActiveBrick.mathch = false;
    self._powUpActiveBrick.neighborMathch = false;
    self._powUpActiveBrick.destroy = false;
    self._powUpActiveBrick.cross = false;
    self._powUpActiveBrick.swap = false;
    
    tempIndex = tempIndex + 1
    self._rainbowBrick = LogicStatus.new()
    self._rainbowBrick.id = tempIndex;
    self._rainbowBrick.move = true;
    self._rainbowBrick.dropOut = false;
    self._rainbowBrick.mathch = false;
    self._rainbowBrick.neighborMathch = false;
    self._rainbowBrick.destroy = false;
    self._rainbowBrick.cross = false;
    self._rainbowBrick.swap = true;
    
    
    
        --self._hardCandyBrick--硬糖块的处理 
     tempIndex = tempIndex + 1     
     self._hardCandyBrick  =    LogicStatus.new()
    self._hardCandyBrick.id = tempIndex;
    self._hardCandyBrick.move = false;
    self._hardCandyBrick.dropOut = false;
    self._hardCandyBrick.mathch = false;
    self._hardCandyBrick.neighborMathch = true;
    self._hardCandyBrick.destroy = true;
    self._hardCandyBrick.cross = false;
    self._hardCandyBrick.swap = false;
    

    --self._popCornBrick--爆米花的处理
    tempIndex = tempIndex + 1        
    self._popCornBrick  =    LogicStatus.new() 
    self._popCornBrick.id = tempIndex;
    self._popCornBrick.move = true;
    self._popCornBrick.dropOut = false;
    self._popCornBrick.mathch = false;
    self._popCornBrick.neighborMathch = true;
    self._popCornBrick.destroy = true;
    self._popCornBrick.cross = false;
    self._popCornBrick.swap = true;
    

    --戚风蛋糕的处理
    tempIndex = tempIndex + 1
    self._qiFengCakeBrick  =    LogicStatus.new()
    self._qiFengCakeBrick.id = tempIndex;
    self._qiFengCakeBrick.move = true;
    self._qiFengCakeBrick.dropOut = false;
    self._qiFengCakeBrick.mathch = false;
    self._qiFengCakeBrick.neighborMathch = true;
    self._qiFengCakeBrick.destroy = true;
    self._qiFengCakeBrick.cross = false;
    self._qiFengCakeBrick.swap = false;
    

    --_bossChocolateBrick
    tempIndex = tempIndex + 1
    self._bossChocolateBrick  =    LogicStatus.new()
    self._bossChocolateBrick.id = tempIndex;
    self._bossChocolateBrick.move = false;
    self._bossChocolateBrick.dropOut = false;
    self._bossChocolateBrick.mathch = false;
    self._bossChocolateBrick.neighborMathch = false;
    self._bossChocolateBrick.destroy = false;
    self._bossChocolateBrick.cross = false;
    self._bossChocolateBrick.swap = false;
    

    --self._berriesBrick 草莓
    tempIndex = tempIndex + 1
    self._berriesBrick  =    LogicStatus.new()
    self._berriesBrick.id = tempIndex;
    self._berriesBrick.move = true;
    self._berriesBrick.dropOut = false;
    self._berriesBrick.mathch = false;
    self._berriesBrick.neighborMathch = false;
    self._berriesBrick.destroy = false;
    self._berriesBrick.cross = false;
    self._berriesBrick.swap = true;
    
    
    
end

function StatusLogic.create()
    local temp = StatusLogic.new()

    return temp;
end

function StatusLogic:getMathchEnable(mapV)
--    print("[StatusLogic:getMathchEnable]::mapV::"..mapV)
    return self:getStatusByMapValue(mapV).mathch
end

function StatusLogic:getComBricksStatus(mapV)
    local tempStatus = nil
--    switch (mapV % 10)
--    {
--    case 9://如果是boss笼罩额 单元 定义个位数9的为boss占用单元块  
--        tempStatus = _ufoScopeBrick;
--        break;
--    default:
        tempStatus = self._commonBrick
--        break;
--    }
    return tempStatus
end


function StatusLogic:getMoveEnable(mapV)
    return self:getStatusByMapValue(mapV).move
end

--function StatusLogic:getDropOutEnable(int mapV)
--{
--    return getStatusByMapValue(mapV).dropOut;
--}
--
--
--
function StatusLogic:getNeighborMathchEnable(mapV)

    return self:getStatusByMapValue(mapV).neighborMathch;
end
function StatusLogic:getDestroyEnable(mapV)
    --    print("[StatusLogic:getMathchEnable]::mapV::"..mapV)
    return self:getStatusByMapValue(mapV).destroy
end
--
--
function StatusLogic:getCrossEnable(mapV)
    return self:getStatusByMapValue(mapV).cross
end
function StatusLogic:getSwapEnable(mapV)

    return self:getStatusByMapValue(mapV).swap;
end

--
--
--


--
function StatusLogic:getPowerDownBricksStatus( mapV)

    local tempStatus = nil  ;

    if mapV == MissionGrid.PD_CANDY_1 or mapV == MissionGrid.PD_CANDY_2 or mapV == MissionGrid.PD_CANDY_3 then
        tempStatus = self._hardCandyBrick;
    elseif mapV == MissionGrid.PD_POPCORN then
        tempStatus = self._popCornBrick;
    elseif mapV == MissionGrid.PD_CAKE then
         tempStatus = self._qiFengCakeBrick;
    elseif mapV == MissionGrid.PD_FRUIT_BERRIES then
        tempStatus = self._berriesBrick;
    end

    return tempStatus;
end
--
function StatusLogic:getStatusByMapValue(mapV)
    local tempStatus = nil    
    if mapV == MissionGrid.NONE then
        tempStatus = self._noneBrick
    elseif mapV == MissionGrid.BLANK then
        tempStatus = self._blankBrick
    elseif mapV == MissionGrid.BORDER then
        tempStatus = self._borderBrick
    elseif MissionGrid.INTERVAL_COMMON:includeValue(mapV) then
        tempStatus = self:getComBricksStatus(mapV)
    elseif MissionGrid.INTERVAL_POWER_UP:includeValue(mapV) then   
    
        if mapV == MissionGrid.PU_RAINBOW then
            tempStatus = self._rainbowBrick;
        elseif math.floor(((mapV % 100) / 10)) == 1 then
        
            tempStatus = self._powUpActiveBrick;
        
        else 
            tempStatus = self._powUpBrick;  
        end          
        
    elseif MissionGrid.INTERVAL_POWER_DOWN:includeValue(mapV) then
    
        tempStatus = self:getPowerDownBricksStatus(mapV);
    end    
    if tempStatus == nil then
        print("--------------------tempStatus = nil---",mapV)
    end;
    return tempStatus
end



return StatusLogic


