local CellPDCandy = class("CellPDCandy",function(itemType,anm)
    local cellPowerUp = require("game.view.grid.CellPowerDown");
    return cellPowerUp.create(itemType,anm);
end)

function CellPDCandy.create(itemType,anm)
    local commonCell = CellPDCandy.new(itemType,anm)

    return commonCell;
end;

function CellPDCandy:play1RestMotion()

    if self.m_gridType == MissionGrid.PD_CANDY_3 then
    
        self.m_armature:getAnimation():play("1", -1, 0);
    
    elseif self.m_gridType == MissionGrid.PD_CANDY_2 then
    
        self.m_armature:getAnimation():play("3", -1, 0);
    
    elseif self.m_gridType == MissionGrid.PD_CANDY_1 then
    
        self.m_armature:getAnimation():play("5", -1, 0);
    end

end  

function CellPDCandy:play6CleartMotion()

    if self.m_gridType == MissionGrid.PD_CANDY_3 then
    
        self.m_armature:getAnimation():play("2", -1, 0);
    
    elseif self.m_gridType == MissionGrid.PD_CANDY_2 then
    
        self.m_armature:getAnimation():play("4", -1, 0);
    
    elseif self.m_gridType == MissionGrid.PD_CANDY_1 then
    
        self.m_armature:getAnimation():play("6", -1, 0);
    end
end

function CellPDCandy:animationEvent(armatureBack,movementType,movementID)

    if movementType == ccs.MovementEventType.complete then

        if movementID=="2" or  movementID=="4" then
            self:play1RestMotion();
        elseif movementID == "6" then
            self:destroy();
        end
    end
end;

return CellPDCandy