local CellPDFruit = class("CellPDFruit",function(itemType,anm)
    local cellPowerUp = require("game.view.grid.CellPowerDown");
    return cellPowerUp.create(itemType,anm);
end)

function CellPDFruit.create(itemType,anm)
    local commonCell = CellPDFruit.new(itemType,anm)

    return commonCell;
end;

function CellPDFruit:play1RestMotion()

    self.m_armature:getAnimation():play("1", -1, 1);

  

end  

function CellPDFruit:play6CleartMotion()

 

    self.m_armature:getAnimation():play("2", -1, -1);

    
end

function CellPDFruit:animationEvent(armatureBack,movementType,movementID)

    if movementType == ccs.MovementEventType.complete then

        if movementID=="2" then
            self.m_armature:getAnimation():play("3", -1, -1);
        elseif movementID == "3" then
            self:destroy();
        end
    end
end;

return CellPDFruit