require("config.mapConfig")

InGameResLoader = class("LoadDataManager")


InGameResLoader.armatures = {

       -- {"armature/shutter/shutter0.png", "armature/shutter/shutter0.plist","armature/shutter/shutter.ExportJson"},
       
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft11.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft200.csb"},
    
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2002_fly.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2102_fly.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2202_fly.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2302_fly.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2402_fly.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2502_fly.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2602_fly.csb"},
    
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2101.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2201.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2301.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2401.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2501.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft2601.csb"},
    
    
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft1000.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft1000_1_5.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft1000_2.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft3041.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/PowerUpActiveEft.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/PowerUpAppearEft.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/gloveSelectEft.csb"},
    
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft_final2.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/eft_final3.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/effect/kuaixuanzhongdonghua.csb"},

    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/grid/Item100.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/grid/Item200.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/grid/Item300.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/grid/Item400.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/grid/Item500.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/grid/Item600.csb"},
    


    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item1000.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item2101.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item2102.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item2201.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item2202.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item2301.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item2302.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item2401.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item2402.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item2501.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item2502.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item2601.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerUp/Item2602.csb"},
    
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerDown/Item3010.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerDown/Item3021.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/powerDown/Item3041.csb"},
    
  
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/brick/Brick11.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/brick/Brick30.csb"},
    
    
    {"armature/inGameArmature/goods.png", "armature/inGameArmature/goods.plist","armature/inGameArmature/goods/goods1.csb"},
    {"armature/inGameArmature/goods.png", "armature/inGameArmature/goods.plist","armature/inGameArmature/goods/goods4.csb"},
    {"armature/inGameArmature/goods.png", "armature/inGameArmature/goods.plist","armature/inGameArmature/goods/goods5.csb"},
    {"armature/inGameArmature/goods.png", "armature/inGameArmature/goods.plist","armature/inGameArmature/goods/goods7.csb"},
   
       
        
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/ingametop/scorestar.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/ingametop/shoujixingxing.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/ingametop/mubiaopaifeiru.csb"},    
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/ingametop/addTwoStepQian.csb"},
    {"armature/inGameArmature/inGameArmature.png", "armature/inGameArmature/inGameArmature.plist","armature/inGameArmature/ingametop/addTowStepHou.csb"},

    {"armature/inGameArmature/ingametop/colorlight0.png", "armature/inGameArmature/ingametop/colorlight0.plist","armature/inGameArmature/ingametop/colorlight.csb"},--为了保证大图是1024*512
    
};




InGameResLoader.images = {
    "ui/ingameUI.png"
};

--游戏内的动画资源
InGameResLoader.openingArmatures = {
    {"armature/openingAnimation/pic1/pic1_01/pic1_010.png", "armature/openingAnimation/pic1/pic1_01/pic1_010.plist","armature/openingAnimation/pic1/pic1_01/pic1_01.csb"}, 
    {"armature/openingAnimation/pic1/pic1_02/pic1_020.png", "armature/openingAnimation/pic1/pic1_02/pic1_020.plist","armature/openingAnimation/pic1/pic1_02/pic1_02.csb"},
    {"armature/openingAnimation/pic1/pic1_03/pic1_030.png", "armature/openingAnimation/pic1/pic1_03/pic1_030.plist","armature/openingAnimation/pic1/pic1_03/pic1_03.csb"},
    {"armature/openingAnimation/pic1/pic1_04/pic1_040.png", "armature/openingAnimation/pic1/pic1_04/pic1_040.plist","armature/openingAnimation/pic1/pic1_04/pic1_04.csb"},
    {"armature/openingAnimation/pic1/pic1_05/pic1_050.png", "armature/openingAnimation/pic1/pic1_05/pic1_050.plist","armature/openingAnimation/pic1/pic1_05/pic1_05.csb"},
    {"armature/openingAnimation/pic1/pic1_06/pic1_060.png", "armature/openingAnimation/pic1/pic1_06/pic1_060.plist","armature/openingAnimation/pic1/pic1_06/pic1_06.csb"},

    {"armature/openingAnimation/pic2/pic2_01/pic2_010.png", "armature/openingAnimation/pic2/pic2_01/pic2_010.plist","armature/openingAnimation/pic2/pic2_01/pic2_01.csb"},
    {"armature/openingAnimation/pic2/pic2_02/pic2_020.png", "armature/openingAnimation/pic2/pic2_02/pic2_020.plist","armature/openingAnimation/pic2/pic2_02/pic2_02.csb"},
    {"armature/openingAnimation/pic2/pic2_03/pic2_030.png", "armature/openingAnimation/pic2/pic2_03/pic2_030.plist","armature/openingAnimation/pic2/pic2_03/pic2_03.csb"},
    {"armature/openingAnimation/pic2/pic2_04/pic2_040.png", "armature/openingAnimation/pic2/pic2_04/pic2_040.plist","armature/openingAnimation/pic2/pic2_04/pic2_04.csb"},
    {"armature/openingAnimation/pic2/pic2_05/pic2_050.png", "armature/openingAnimation/pic2/pic2_05/pic2_050.plist","armature/openingAnimation/pic2/pic2_05/pic2_05.csb"},


    {"armature/openingAnimation/pic3/pic3_01/pic3_010.png", "armature/openingAnimation/pic3/pic3_01/pic3_010.plist","armature/openingAnimation/pic3/pic3_01/pic3_01.csb"},
    {"armature/openingAnimation/pic3/pic3_02/pic3_020.png", "armature/openingAnimation/pic3/pic3_02/pic3_020.plist","armature/openingAnimation/pic3/pic3_02/pic3_02.csb"},
    {"armature/openingAnimation/pic3/pic3_03/pic3_030.png", "armature/openingAnimation/pic3/pic3_03/pic3_030.plist","armature/openingAnimation/pic3/pic3_03/pic3_03.csb"},
};



--SpriteFrameCache::getInstance()->addSpriteFramesWithFile( "ui_map.plist" );
--cc.Director:getInstance():getTextureCache():addImageAsync(configFilePath,callBack)
function InGameResLoader:ctor()
     self.arms = nil; 
     self.imgs = nil;
     
     self.lastBossPath = nil;
     self.lastAnimalPath = nil;
end

function InGameResLoader.create()
    local temp = InGameResLoader.new();
    return temp;
end

function InGameResLoader:releaseGameResource()
    cc.Director:getInstance():getTextureCache():removeUnusedTextures();
end;

function InGameResLoader:loadGameResource(level,callBack)

    self:getAnimalPath(level);
    --cc.Director:getInstance():getTextureCache():removeUnusedTextures();
    --cc.SpriteFrameCache:getInstance():removeUnusedSpriteFrames();
   -- ccs.ArmatureDataManager:getInstance():rem
    if not MainValue.OUT_LOAD_COMPLETE then --如果外部游戏没有加载完成说明是第一次玩游戏
        print("[InGameResLoader]初次进入游戏,仅仅是第一次")
        local openingArmaturesLen = #InGameResLoader.openingArmatures
        for opI = 1, openingArmaturesLen do
            table.insert(InGameResLoader.armatures,InGameResLoader.openingArmatures[opI])
        end
    end
    
   
   
    self.arms = UtilHelp:copyTab(InGameResLoader.armatures,false);
    self.imgs = UtilHelp:copyTab(InGameResLoader.images,false);
    local bossInfo = self:getBossPath();
    if bossInfo ~= nil then
        table.insert(self.arms,bossInfo);
    end;
    
    local animalInfo = self:getAnimalPath(level);
    
    if animalInfo ~= nil then
        table.insert(self.arms,animalInfo);
    end;
    
    self:startLoad(callBack);
end;


function InGameResLoader:getBossPath()
    local bossID = MainValue.mxGameManager:getBossId();
    if bossID~=nil and bossID > 0 then
        local imagePath = string.format("armature/inGameArmature/boss/Item%d0.png",bossID);
        local plistPath = string.format("armature/inGameArmature/boss/Item%d0.plist",bossID);
        local configPath = string.format("armature/inGameArmature/boss/Item%d.csb",bossID);
        self.lastBossPath = imagePath;
        
        return {imagePath,plistPath,configPath};
    end;
    return nil;
end;

function InGameResLoader:getAnimalPath(level)
--    根据当前关卡的pet类型随即加载对应的动画资源游戏内部右上角
--    local pets = MainValue.
    print("[InGameResLoader] --getAnimalPath() 根据当前关卡的pet类型随即加载对应的动画资源游戏内部右上角")
    GameValue:initLvMap(level)
    
    
    local petId = GameValue.mxDataControler:getPetId()
   
    
    
    print("[InGameResLoader] --getAnimalPath()-petId=="..petId)    
    
    local m_config = mapConfig.position[MainValue.SELECTED_LEVEL];
    if m_config == nil then
        return;
    end;
    
    local type = m_config.tp;
    local imagePath = "armature/inGameArmature/animals/xiaoxiangUI0.png";
    local plistPath = "armature/inGameArmature/animals/xiaoxiangUI0.plist";
    local configPath = "armature/inGameArmature/animals/xiaoxiangUI.csb";
    
    if petId ==1 then
        imagePath = "armature/inGameArmature/animals/Dorothy/Dorothy0.png";
        plistPath = "armature/inGameArmature/animals/Dorothy/Dorothy0.plist";
        configPath = "armature/inGameArmature/animals/Dorothy/Dorothy.csb";
    elseif petId ==2 then
        imagePath = "armature/inGameArmature/animals/grassman/grassman0.png";
        plistPath = "armature/inGameArmature/animals/grassman/grassman0.plist";
        configPath = "armature/inGameArmature/animals/grassman/grassman.csb";
    elseif petId ==3 then
        imagePath = "armature/inGameArmature/animals/Robot/Robot0.png";
        plistPath = "armature/inGameArmature/animals/Robot/Robot0.plist";
        configPath = "armature/inGameArmature/animals/Robot/Robot.csb";
    elseif petId ==4 then
        imagePath = "armature/inGameArmature/animals/Lion/Lion0.png";
        plistPath = "armature/inGameArmature/animals/Lion/Lion0.plist";
        configPath = "armature/inGameArmature/animals/Lion/Lion.csb";
    end
    
    self.lastAnimalPath = imagePath;
    return {imagePath,plistPath,configPath};
    
end;


function InGameResLoader:startLoad(callBack)
    
    
    local imagesLength = table.maxn(self.imgs);
    local armLength = table.maxn(self.arms);
    
    if imagesLength == 0 and armLength == 0 then
        cc.SpriteFrameCache:getInstance():addSpriteFrames("ui/ingameUI.plist");
        callBack();
        return;
    end;
    
    if imagesLength > 0 then 
        local function loadImageComplete(percent)
           -- if percent >= 1 then   
                self:startLoad(callBack);
           -- end;
        end; 
        
        local imageInfo = self.imgs[1];
        table.remove(self.imgs,1);
        
        cc.Director:getInstance():getTextureCache():addImageAsync(imageInfo,loadImageComplete);
        return;
    end;
    
    
    if armLength > 0 then 
        local function loadArmComplete(percent)
            if percent >= 1 then   
                self:startLoad(callBack);
            end;
        end; 
        local armInfo = self.arms[1];
        table.remove(self.arms,1)
        ccs.ArmatureDataManager:getInstance():addArmatureFileInfoAsync(armInfo[1],armInfo[2],armInfo[3],loadArmComplete);
    end;

end;

function InGameResLoader:loadOtherBigArm()

    
--    cc.SpriteFrameCache:getInstance():addSpriteFrames("armature/inGameArmature/superFont.plist")
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/inGameArmature/bigEffect/sweet_final0.png","armature/inGameArmature/bigEffect/sweet_final0.plist","armature/inGameArmature/bigEffect/sweet_final.csb");
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/inGameArmature/bigEffect/win0.png","armature/inGameArmature/bigEffect/win0.plist","armature/inGameArmature/bigEffect/win.csb");
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/inGameArmature/bigEffect/lose0.png","armature/inGameArmature/bigEffect/lose0.plist","armature/inGameArmature/bigEffect/lose.csb");
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/inGameArmature/bigEffect/nomatch0.png","armature/inGameArmature/bigEffect/nomatch0.plist","armature/inGameArmature/bigEffect/nomatch.csb");
    
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/inGameArmature/superFont.png","armature/inGameArmature/superFont.plist","armature/inGameArmature/superFont/Amazing.csb");
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/inGameArmature/superFont.png","armature/inGameArmature/superFont.plist","armature/inGameArmature/superFont/Awesome.csb");
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/inGameArmature/superFont.png","armature/inGameArmature/superFont.plist","armature/inGameArmature/superFont/Smashing.csb");
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/inGameArmature/superFont.png","armature/inGameArmature/superFont.plist","armature/inGameArmature/superFont/Super.csb");
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/inGameArmature/superFont.png","armature/inGameArmature/superFont.plist","armature/inGameArmature/superFont/Yummy.csb");
    
end;

function InGameResLoader:removeOtherBigArm()

    print("[InGameResLoader]--111111111111111111111chma00000000000000000")
   --print("removeOtherBigArm----------------------------------------------")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("armature/inGameArmature/bigEffect/sweet_final0.png");
    cc.Director:getInstance():getTextureCache():removeTextureForKey("armature/inGameArmature/bigEffect/win0.png");
  --  cc.Director:getInstance():getTextureCache():removeTextureForKey("armature/inGameArmature/bigEffect/shengwubu0.png");
    cc.Director:getInstance():getTextureCache():removeTextureForKey("armature/inGameArmature/bigEffect/nomatch0.png");
    
    cc.Director:getInstance():getTextureCache():removeTextureForKey("armature/inGameArmature/bigEffect/superFont.png");
    
    cc.Director:getInstance():getTextureCache():removeTextureForKey(self.lastBossPath);
    cc.Director:getInstance():getTextureCache():removeTextureForKey(self.lastAnimalPath);
--    cc.SpriteFrameCache:removeSpriteFramesFromFile("armature/inGameArmature/bigEffect/sweet_final0.plist");
--    cc.SpriteFrameCache:removeSpriteFramesFromFile("armature/inGameArmature/bigEffect/win0.plist");
--    cc.SpriteFrameCache:removeSpriteFramesFromFile("armature/inGameArmature/bigEffect/shengwubu0.plist");
--    cc.SpriteFrameCache:removeSpriteFramesFromFile("armature/inGameArmature/bigEffect/nomatch0.plist");


end;


return InGameResLoader;