local LevelConfig = class("LevelConfig");

function LevelConfig:ctor()
    self.lvs = {};
end;

function LevelConfig.create()
    local lvConfig = LevelConfig.new();
    return lvConfig;
end;

function LevelConfig:getLevelConfig(lv)
    local level = tostring(lv)
    if self.lvs[level] == nil then
        local path = "mission."..level
        self.lvs[level] = require(path);
        
        print("[LevelConfig]--getLevelConfig()")
    end;
    
    return UtilHelp:copyTab(self.lvs[level]);
end;

return LevelConfig;