


local blockerLockOfflinePanel = nil;
local BlockerLockOfflinePanel = class("BlockerLockOfflinePanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/BlockerLockOffline.json");
end);

function BlockerLockOfflinePanel:disCallBackFun()
    blockerLockOfflinePanel:removeFromParent(true);
end

function BlockerLockOfflinePanel.create()
    blockerLockOfflinePanel = BlockerLockOfflinePanel.new()

    blockerLockOfflinePanel:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);

    local closebtn = blockerLockOfflinePanel:getChildByName("btnClose");

    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )

        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createUIAction():UIDisappear(blockerLockOfflinePanel,blockerLockOfflinePanel.disCallBackFun);
        end
        
    end

    closebtn:addTouchEventListener(touchEvent);
    
    --title文本替换
    local titleText = blockerLockOfflinePanel:getChildByName("title");
    local newTitle = FacFont:getFontsBmp(FontType.FontRed,MainValue.infosManager:getObjMultilingualByKey("Blockerlock_title"));
    blockerLockOfflinePanel:addChild(newTitle);
    newTitle:setPosition(3, 256);
    titleText:removeFromParent();
  
    --name you
    local nameDes = blockerLockOfflinePanel:getChildByName("userNameTxt");
    local nameText = FacFont:getFontsBmp(FontType.FontRed,"Name you");--language TODO
    blockerLockOfflinePanel:addChild(nameText);
    nameText:setPosition(nameDes:getPosition());
    nameDes:removeFromParent();

    --unlock
    local unlockBtn = blockerLockOfflinePanel:getChildByName("btnUnlock");
    local unlockLabel = unlockBtn:getChildByName("txt");
    local unlock = FacFont:getFontsBmp(FontType.FontRed,"Unlock 10")--language TODO
    unlockBtn:addChild(unlock);
    unlock:setPosition(unlockLabel:getPosition());
    unlockLabel:removeFromParent();


    return blockerLockOfflinePanel;
end


function BlockerLockOfflinePanel:init()

    MainValue.actionManager:createUIAction():UIAppear(blockerLockOfflinePanel);
end

return BlockerLockOfflinePanel