require "engine.uigridtools.ThreeLMRGridTools"
CellAim = class("CellAim",function ()
   return cc.Layer:create();
end)

function CellAim:ctor(value)
    self.typeid = value
--    self.shadeBg = ThreeLMRGridTools.create("ui/ingame/aochao.png",100,11)  --cc.Sprite:create("ui/ingame/aochao.png")
--    self.shadeBg:setPosition(0,-8)  
--    self:addChild(self.shadeBg)

    self:setAnchorPoint(0.5,0.5)
    
    local url= self:getUrlById(self.typeid)
    self.iconSpr = cc.Sprite:create(url)  --显示的收集目标的背景
--    self.iconSpr:setPosition(-50,5)   
    self.iconSpr:setAnchorPoint(0.5,0.5)
    self:addChild(self.iconSpr)

    self.numBmp = FacFont:getFontsBmp(FontType.FontWhiteNum,10)
    self:addChild(self.numBmp)  
    self.numBmp:setScale(0.8)
    
    self.iconSpr:setScale(0.7) 


    return self
end

function CellAim:getUrlById(idStr)
    self.endStr = tostring("ui/target/"..idStr..".png")
    return self.endStr
end

--播放收集到目标的动画效果
function CellAim:playCollectEft()
--    self.iconSpr:stopAllActions()
--    self.iconSpr:setScale(0.6,0.6)    
    local function callFun()
        self.iconSpr:setScale(0.7)
    end
    
    local changeScale = cc.ScaleBy:create(0.1,1.3,1.3)    
    local seqAct = cc.Sequence:create(changeScale, changeScale:reverse(),cc.CallFunc:create(callFun))  
    self.iconSpr:runAction(seqAct)
    
    if self.ani ~= nil and self.ani:getAnimation() ~=nil then
        self.ani:getAnimation():play("3",-1,0)
    end
    
--180.  
--181.  -- 三个丑八怪执行动作  
--182.  grossini:runAction(cc.RepeatForever:create(seq1)) 
    
    -- cc.EaseExponentialOut:create(createSimpleMoveBy())  
--    local move_ease_out_back = move_ease_out:reverse()

--            cc.EaseInOut:create(action,rate)
end


--function CellAim:setSetImgPos(pos)
--   self.iconSpr:setPosition(pos)
--end

function CellAim:setSum(sum)
	self.sum = sum	
    
    self.ani = ccs.Armature:create("mubiaopaifeiru")
    self.ani:setPosition(0,0)
    self.ani:retain()    
end

function CellAim:getId()
--   print("CellAim--grtId()",_typeid)
    return self.typeid
end

function CellAim:upDate(num)

    self.num = num
    
    if num <= 0 then
        self.num = 0
    end
    
    if self.numBmp ~= nil then
        self.numBmp:removeFromParent()
    end
    
--    print("----------------------------",self.num,"--------------",self.sum)
--    print(self.num==self.sum)
    
    if  self.num == self.sum then
    
        if self.numBmp ~= nil then
            self.numBmp:removeFromParent()
        end

        self.numBmp = cc.Sprite:createWithSpriteFrameName("ui/ui/iconTickS.png")
        self.numBmp:setScale(0.8)
        self.numBmp:setPosition(10,-23);
    
    else
        self.numBmp = FacFont:getFontsBmp(FontType.FontWhiteNum,tostring(self.num.."/"..self.sum))
        self.numBmp:setScale(0.8)
        self.numBmp:setPosition(10,-23);
    end
    
    self:addChild(self.numBmp)  
    self:playCollectEft()
    if self.ani ~=nil then
        if self.ani:getParent()~=nil then
            self.ani:getParent():removeChild(self.ani)
        end
        self:addChild(self.ani)  
        self.ani:getAnimation():play("3",-1,0)
    end
    
--    print("[CellAim]--当前收集的数量",self.num)
end
function CellAim:GC()
    if self.numBmp ~= nil then
        self.numBmp:removeFromParent()
    end
    if self.iconSpr ~= nil then
        self.iconSpr:removeFromParent()
    end
     self.iconSpr = nil
	 self.numBmp = nil
	 self.num = 0
	 self.sum = 0
	 self.endStr = nil
end