require "src.ui.collectaimui.scorestarui.CellStar"

local maxW = 150  -- 150 是进度条梯形总宽

local maxH = 80  -- 80    是进度条梯形总高

ScoreStarUI = class("ScoreStarUI",function ()
    return cc.Layer:create();    
end)

function ScoreStarUI:ctor()
return self
end








function ScoreStarUI:setScoreData(scoreDate)

    
    if self.threeStars==nil then
        self.threeStars={}
    
        for i = 1,3 do
            local cellStar = CellStar.new(i)
            self.threeStars[i] = cellStar
        end
        
        self:addChild(self.threeStars[3])
        
        self:addChild(self.threeStars[2])
        
        self:addChild(self.threeStars[1])
        
    end


    self.threeScores={}
    self.targetRatio=0
    self.starOneScore=0
    self.starTwoScore=0
    self.starThreeScore=0
    self.curScore=0
    self.isPlaystarOne = false
    self.isPlaystarTwo = false
    self.isPlaystarThree = false

    self.threeScores=scoreDate--{100,250,300}    
    
    
    
    self.starThreeScore = self.threeScores[3]    
    self.threeStars[3]:setPosition(cc.p(160,maxH))
    
         
    

    self.starTwoScore = self.threeScores[2]
    self.ratio2 = (self.starTwoScore/self.starThreeScore);

    self.threeStars[2]:setPosition(cc.p(ScoreStarUI:getPosXByRatio(self.ratio2),self.ratio2 * maxH))
   


    self.starOneScore = self.threeScores[1]
    self.ratio1 = (self.starOneScore/self.starThreeScore);
    self.threeStars[1]:setPosition(cc.p(ScoreStarUI:getPosXByRatio(self.ratio1),self.ratio1 * maxH))
  
    
    
    
end

--根据初始值初始化星星的位置ui 
function ScoreStarUI:initUI()
	
	self.curScore = 0;
    self.targetRatio = -1
    self.isPlaystarOne = false
    self.isPlaystarTwo = false
    self.isPlaystarThree = false   
    	
end


 function ScoreStarUI:setProgress(newScore)
        if self.curScore >= newScore then
            return
        end
        self.curScore = newScore
            

        
        if self.curScore >= self.starOneScore then
           if not self.isPlaystarOne then
             self.threeStars[1]:playStar();
             self.isPlaystarOne = true;
            end
        end     
        
        if self.curScore >= self.starTwoScore then
            if not self.isPlaystarTwo then
                self.threeStars[2]:playStar();
            self.isPlaystarTwo = true;
            end
        end   
        
        if self.curScore >= self.starThreeScore then
            if not self.isPlaystarThree then
                self.threeStars[3]:playStar();
                self.isPlaystarThree = true;
            end
        end   
end


function ScoreStarUI:getPosXByRatio(ratio)

   local leftH=maxH-ratio*maxH
   if leftH<=30 then
        return maxW -  maxW*(maxH-ratio*maxH)/30  -- 30是进度条梯形斜角的高度
   else
        return 0
   end
   
 end



function ScoreStarUI:GC()
    
    
    if self.threeStars~=nil then
        for i = 1,#(self.threeStars) do
            self.threeStars[i]:resetPlayAni()
            --            cellAry[i]:GC()           
        end        
    end
    
    self.targetRatio=0   
    self.curScore=0
    self.isPlaystarOne = false
    self.isPlaystarTwo = false
    self.isPlaystarThree = false
    
end