


local bigPanel = nil
local closeFun = nil

local BigPanel = class("BigPanel",function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/CommonPanelBig.json")    
end
)

local function init()
    local closeBtn = tolua.cast(bigPanel:getChildByName("BtnClose"), "ccui.Button")
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )    
        if eventType == ccui.TouchEventType.ended then                
            if closeFun~=nil then
                closeFun()
                --                cc.CallFunc:create(closeFun)//创建函数 不是执行
                closeFun = nil
            end    
        end
    end    
    closeBtn:addTouchEventListener(touchEvent)
end

function BigPanel:setCloseHandler(callBackFun)
-- 判断是不是函数
    if type(callBackFun)=="function" then
        closeFun = callBackFun
    end
    print("[BigPanel]---",closeFun) 
end


function BigPanel:setTitle(titleStr)
    local titleLayer = bigPanel:getChildByName("TitleLayer")    
    local titleTxt= ccui.Helper:seekWidgetByName(titleLayer, "LabelTxt")
        
    local titleBmp = FacFont:getFontsBmp(FontType.FontWhite,titleStr);
    titleLayer:addChild(titleBmp)
    titleBmp:setPosition(titleTxt:getPosition())
    titleTxt:removeFromParent();
    
end


function BigPanel.create()
     bigPanel = BigPanel.new()
--    tarPanel:setPosition(VisibleRect:center())  
    init() 
    return bigPanel
end

function GC()
	--TODO::
end

return BigPanel 


