


local dailyBonusPopupPanel = nil;

local DailyBonusPopupPanel = class("DailyBonusPopupPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/DailyBonusPopup.json");
end);

function DailyBonusPopupPanel:disCallBackFun()
    dailyBonusPopupPanel:removeFromParent(true)
end

function DailyBonusPopupPanel.create()
    dailyBonusPopupPanel = DailyBonusPopupPanel.new()

    dailyBonusPopupPanel:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);

    local closebtn = dailyBonusPopupPanel:getChildByName("btnClose");
    
    local titleLB = dailyBonusPopupPanel:getChildByName("title")
    local titleLabel = FacFont:getFontsBmp(FontType.FontRed,"Daily Attendance")
    titleLabel:setPosition(titleLB:getPosition())
    titleLabel:setPositionY(titleLabel:getPositionY() + 20)
    dailyBonusPopupPanel:addChild(titleLabel)
    titleLB:removeFromParent()
    
    local txtNameLB = dailyBonusPopupPanel:getChildByName("txtName")
    
    
    
    local goodsName = FacFont:getFontsBmp(FontType.FontRed,MainValue.infosManager:getObjMultilingualByKey("Common_coin"))
    goodsName:setPosition(txtNameLB:getPosition())
    dailyBonusPopupPanel:addChild(goodsName)
    txtNameLB:removeFromParent()
    
    local panelItem = dailyBonusPopupPanel:getChildByName("Panel_item")
    local txtNumLB = panelItem:getChildByName("txtNum")
    local awardCount = FacFont:getFontsBmp(FontType.FontRed,"X10")
    awardCount:setPosition(txtNumLB:getPosition())
    panelItem:addChild(awardCount)
    txtNumLB:removeFromParent()
    
    local txtNum2LB = panelItem:getChildByName("txtNum2")
    local cashCount = FacFont:getFontsBmp(FontType.FontRed,"350")
    cashCount:setPosition(txtNum2LB:getPosition())
    panelItem:addChild(cashCount)
    txtNum2LB:removeFromParent()

    local txtNode = dailyBonusPopupPanel:getChildByName("txtNode")
    local desLabel = FacFont:getFontsBmp(FontType.FontRed,MainValue.infosManager:getObjMultilingualByKey("DailyBonus_popup_title_1"))
    desLabel:setPosition(txtNode:getPosition())
    dailyBonusPopupPanel:addChild(desLabel)
    txtNode:removeFromParent()
    
    local btnAsk = dailyBonusPopupPanel:getChildByName("btnAsk")
    local askLB = btnAsk:getChildByName("LabelAsk")
    local askLabel = FacFont:getFontsBmp(FontType.FontRed,MainValue.infosManager:getObjMultilingualByKey("DailyBonus_popup_btn_2"))
    askLabel:setPosition(askLB:getPosition())
    btnAsk:addChild(askLabel)
    askLB:removeFromParent()
    
    local btnUse = dailyBonusPopupPanel:getChildByName("btnUse")
    local useLB = btnUse:getChildByName("LabelUse")
    local useLabel = FacFont:getFontsBmp(FontType.FontRed,MainValue.infosManager:getObjMultilingualByKey("DailyBonus_popup_btn_1"))
    useLabel:setPosition(useLB:getPosition())
    btnUse:addChild(useLabel)
    useLB:removeFromParent()

    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )

        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createUIAction():UIDisappear(dailyBonusPopupPanel,dailyBonusPopupPanel.disCallBackFun)
        end
    end

    closebtn:addTouchEventListener(touchEvent)


    return dailyBonusPopupPanel;
end


function DailyBonusPopupPanel:init()
    MainValue.actionManager:createUIAction():UIAppear(dailyBonusPopupPanel);
end

return DailyBonusPopupPanel