require("engine.uigridtools.NineGridTools")

require "BuyFlowValue"

require "ui.inGame.ItemCell"

tableState = {};
tableCell= {};
tableIdCell = {};
local itemIdList = {};
local itemList = {1,2,3,4};--5个cell背景
local curIndex=nil;

local lastId = nil;
local itemBg = nil;

--local lastId = nil;
local ItemBottomBar = class("ItemBottomBar",function()
       
       return cc.Layer:create();
end);

function ItemBottomBar:setProps(item1,item2,item3,item4,item5,item6)
    if BuyFlowValue.innerBuyAry == nil or table.maxn(BuyFlowValue.innerBuyAry) ==0 then
        BuyFlowValue.innerBuyAry = {}
    end
    
    
    itemIdList[1] = item1;
    itemIdList[2] = item2;
    itemIdList[3] = item3;
    itemIdList[4] = item4;
--    itemIdList[5] = item5;
--    itemIdList[6] = item6;
    self:init();

end


function ItemBottomBar.create()

   
    
   local itemBar = ItemBottomBar.new();
   itemBar:setAnchorPoint(0,0);
   
    itemBg = NineGridTools.create("itemBg.png" , 415 , 150 , 32)--cc.Sprite:createWithSpriteFrameName("itemBg.png");
    itemBg:setAnchorPoint(0,0);
    itemBg:setPosition(207,5);
    itemBar:addChild(itemBg);
   
    --添加cell
    for i in pairs(itemList) do
        local cell = ItemCell.create();
        cell:setPosition((i-1)*101 + 56,42);
        itemBar:addChild(cell);
        tableCell[i] = cell;
    end
    
    --更新数量
    local function updateGoodsNum(idpar,num)
        local id = tonumber(idpar);
        if tableIdCell[id] ~= nil then
            tableIdCell[id]:updateGoodsNum(num);
        end
    end 

    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_GOODS, updateGoodsNum);
    return itemBar;
end

--使用成功 失败   置回原状态
function ItemBottomBar:cancelProp(index,isUsed,isExitGame)
    tableIdCell[index]:cancelProp(index,isUsed,isExitGame);

end

--满足条件请求使用
function ItemBottomBar:useProp(index)
    tableIdCell[index]:useProp(index);

end

--判断当前玩家是否有足够的钱购买当前的道具
function ItemBottomBar:haveCash(index)

    local good = MainValue.infosManager:getObjGoodsById(index);
    local goodCash = good.cash;
    local userCash = MainValue.dataManager.userManager:getCash();
    
    if MainValue.mxFTUEManager:hasFtue() == true then
       self:useProp(index);
       MainValue.mxFTUEManager:removeFtue();
       return;
    end
    
    local goodsNum =  MainValue.dataManager.goodsManager:getGoodsNumber(index);
    if  goodsNum>0 then
        self:useProp(index);
    else
          local isBuyItem = require("ui/inGame/IsBuyItemPanel");
          local isBuyItemPanel = isBuyItem.create(index,1);
          isBuyItemPanel:appear();
    end
end


function ItemBottomBar.clickCell(itemCell)
    if itemCell.goodsId == lastId and itemCell.state == 1 then
        itemCell:cancelProp(itemCell.goodsId,false);
        lastId = nil;
        return;
    elseif  lastId ~= nil and tableIdCell[lastId].state == 1 then
       -- itemCell:cancelProp(lastId,false);
        tableIdCell[lastId]:cancelProp(lastId,false);
        lastId = nil;
    end

    if MainValue.mxFTUEManager:hasFtue() == true then
        itemCell:useProp(itemCell.goodsId);
        MainValue.mxFTUEManager:removeFtue();
        return;
    end

    local goodsNum =  MainValue.dataManager.goodsManager:getGoodsNumber(itemCell.goodsId)
    if  goodsNum > 0 then
        itemCell:useProp(itemCell.goodsId);
        lastId = itemCell.goodsId;

    else
--      没有数量
        if BuyFlowValue.innerBuyAry ~= nil or table.maxn(BuyFlowValue.innerBuyAry) ==0 then
            local tmpBuyLifeData = BuyFlowData.new(BuyFlowValue.buyItemPanel)
            tmpBuyLifeData:setGoodsId(itemCell.goodsId)
            BuyFlowValue.innerBuyAry[1] = tmpBuyLifeData    
              
        end
        
        local isBuyItem = require("ui/inGame/IsBuyItemPanel");
        local isBuyItemPanel = isBuyItem.create(itemCell.goodsId,1);
        isBuyItemPanel:setCell(itemCell);
        isBuyItemPanel:appear();     
        
    end
end

function ItemBottomBar:useItem(id)

    local index = tonumber(id);
    tableIdCell[index]:useProp(index);
end



--得到id就更新新的动画
function ItemBottomBar:init()
    curIndex = -1;
    --根据cellId 添加动画
    for i in pairs(itemList) do
        tableCell[i]:updateAddCell(itemIdList[i]);
        tableState[i] = 0;
        tableIdCell[itemIdList[i]] = tableCell[i];
        tableIdCell[itemIdList[i]]:setTouchListener(self.clickCell);
    end
end

function ItemBottomBar:removeAnimate()
    for i in pairs(tableIdCell) do
        self:cancelProp(i,false,true);
        tableIdCell[i]:removeGoodsNum();
        tableIdCell[i]:removeAnimate();
        
    end
end

return ItemBottomBar;