LoadingProgressBar = class("LoadingProgressBar",function ()
    return cc.Layer:create();    
end)

function LoadingProgressBar:ctor()
    return self
end

function LoadingProgressBar:initUI()

    self.tarFileNum = 0 --当前已经加载的文件数
    self.moveX = MainValue.winSize.width - 15 --  100 前进的    总共前进  MainValue.winSize.width - 15
   
    
    self.bgShader = cc.Sprite:create("ui/loadingui/LoadProgress0.png") 
    
    self.bgShader:setPosition(0,15)
    self.bgShader:retain()
    self:addChild(self.bgShader)
--  添加背景的处理
    --    遮罩的实现start
--    collectAimProgessBg.png
    
    self.clippingNode = cc.ClippingNode:create()
    self.clippingNode:setPosition(0,14)        
    self.stencil = cc.Sprite:create("ui/loadingui/LoadProgress1.png") --遮罩
    self.stencil:retain()
    self.clipSize = self.stencil:getContentSize()    
    self.spark  = cc.Sprite:create("ui/loadingui/LoadProgress1.png")  
    self.spark:retain()
    self.clippingNode:setContentSize(self.clipSize)
    self.clippingNode:addChild(self.spark)
    self.clippingNode:retain()
    
--    680   40 

    self.offsetX = -(768  - MainValue.winSize.width)*0.5
    
    self.spark:setPosition( - MainValue.winSize.width + self.offsetX + self.moveX ,0) 



    --   设定被遮挡的透明度start
--    spark:setCascadeOpacityEnabled(true)
--    spark:setOpacity(255*0.5)--//渐隐
    --   设定被遮挡的透明度end

    --    stencil:setOpacity(0.6)
    self.clippingNode:setInverted(false)
    self.clippingNode:setAlphaThreshold(0)


    self.clippingNode:setStencil(self.stencil)       
    self:addChild(self.clippingNode)
    --    遮罩的实现end
        
    self.collectAimProgessBgOver = cc.Sprite:create("ui/loadingui/LoadProgress2.png")
    self.collectAimProgessBgOver:setPosition(0,18)
    self:addChild(self.collectAimProgessBgOver)
--    self.collectAimProgessBgOver:retain()
    
    
    self.progessOverDot = cc.Sprite:create("ui/loadingui/LoadProgress3.png")
    self.progessOverDot:setPosition(- MainValue.winSize.width + self.offsetX + 386 +  self.moveX ,18)
    self.progessOverDot:setScale(0.9)
    self.progessOverDot:retain()    
    self:addChild(self.progessOverDot)
    
          
        
        
    self.percentNum = FacFont:getFontsBmp(FontType.FontWhite,"00%")    
    self.percentNum:setAnchorPoint(1,0.5)
    self.percentNum:retain()
    self.percentNum:setPosition(- MainValue.winSize.width + self.offsetX + 398 + self.moveX,16)
    self:addChild(self.percentNum)
    
end


function LoadingProgressBar:setFileTotalNum(fileTotalNumPar)
    self.fileNum =  fileTotalNumPar -- load 文件总数量
end


--根据初始值初始化星星的位置ui 
--function LoadingProgressBar:initUI()
--    self.curScore = 0;
--    self.targetRatio = -1   
--end

function LoadingProgressBar:setProgress(addFileNum)

    self.tarFileNum = self.tarFileNum + addFileNum    
    self.moveX = (MainValue.winSize.width - 15) * self.tarFileNum / self.fileNum    
    self.spark:setPosition( - MainValue.winSize.width + self.offsetX + self.moveX ,0) 
        
    self.progessOverDot:setPosition(- MainValue.winSize.width + self.offsetX + 386 +  self.moveX ,18)
    local percent = tostring(math.ceil(self.tarFileNum*100 / self.fileNum).."%")
    self.percentNum:setText(percent)
end


function LoadingProgressBar:GC()
   
    self.curScore = 0
    
    self.stencil:release()
    self.stencil = nil
    
    self.collectAimProgessBgOver:getParent():removeChild(self.collectAimProgessBgOver)
    self.collectAimProgessBgOver:release()
    self.collectAimProgessBgOver = nil  
    
    self.spark:getParent():removeChild(self.spark)    
    self.spark:release()
    self.spark = nil
        
    self.clippingNode:getParent():removeChild(self.clippingNode)
    self.clippingNode:release()
    self.clippingNode = nil
   
end