MapUtils = class("MapUtils");

--设置动画
function MapUtils:setAnimationTouch(_mapArmature)

    local function onTouchBegan(touch, event)
        local target = event:getCurrentTarget()

        local locationInNode = target:convertToNodeSpace(touch:getLocation())
        
        
--        local s = target:getContentSize()
--        local rect = cc.rect(MainValue.winSize.width/2-(s.width/2),MainValue.winSize.height/2+(s.height/2) , s.width, s.height)--target:getPositionX()-(s.width/2), target:getPositionY()+(s.height/2)
--
--        if cc.rectContainsPoint(rect, locationInNode) then
--            target:setOpacity(180)
--            return true
--        end

        target:setOpacity(180)
        
        return true;
    end

    local function onTouchMoved(touch, event)
        local target = event:getCurrentTarget()
        local posX,posY = target:getPosition()
        local delta = touch:getDelta()
        target:setPosition(cc.p(posX + delta.x, posY + delta.y))

        print("onTouchMoved : "..target:getPositionX() .. " = " .. target:getPositionY());

    end

    local function onTouchEnded(touch, event)
        local target = event:getCurrentTarget()
        target:setOpacity(255)
        
    end

    local listener1 = cc.EventListenerTouchOneByOne:create()
    listener1:setSwallowTouches(true)
    listener1:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
    listener1:registerScriptHandler(onTouchMoved,cc.Handler.EVENT_TOUCH_MOVED )
    listener1:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED )
    local eventDispatcher = _mapArmature:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener1, _mapArmature)
end