require "ui.playGamePanel.frontprops.FrontPropsDataCell"
FrontPropsData = class("FrontPropsData")
function FrontPropsData:ctor()
-- 得到道具的配置表
    local goodsConfigs = MainValue.infosManager:getObjGoods()
-- 便利取出前置道具
    self.frontPropsData = {}
        
    for key, var in pairs(goodsConfigs) do
        if goodsConfigs[key]['type'] ~= nil and goodsConfigs[key]['type'] == "2" then       --type'] == "2" 标志是 前置道具 
            local tmpFrontPropsDataCell = FrontPropsDataCell.new(goodsConfigs[key]['id'],goodsConfigs[key]['costType'],goodsConfigs[key]['cash'],goodsConfigs[key]['coin'],goodsConfigs[key]['lv'],goodsConfigs[key]['name'],goodsConfigs[key]['type'],goodsConfigs[key]['useType'])            
            table.insert(self.frontPropsData,tmpFrontPropsDataCell)
        end
    end
    
    local function comps(aPar,bPar)
        local isTrue = false
        if tonumber(aPar['id']) > tonumber(bPar['id']) then
            isTrue = false
        else
            isTrue = true
        end    
        return isTrue  
    end
        
    --应用
    table.sort(self.frontPropsData,comps)    
--    print(self.frontPropsData)
    return self    
end

--返回前置道具数组
function FrontPropsData:getFrontPropsAry()
    return self.frontPropsData
end

return FrontPropsData;