require "ui.panelManager.PanelManager"
local RateGamePanel = class("RateGamePanel",function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/RateGamePanel_1.json");
end)

function RateGamePanel.create()
    local panel = RateGamePanel.new();
 
    panel:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);
    local titleText = FacFont:getFontsBmp(FontType.FontRed, "Having Fun?");
    panel:addChild(titleText);
    titleText:setPosition(0,268);
    
    local des = FacFont:getFontsBmp(FontType.FontRed, "Do you like us?");
    panel:addChild(des);
    des:setPosition(0,-150);
    
    local function removeComplte()
        if panel ~= nil then
            panel:removeFromParent();
        end
    end;
    
    local likeBtn = tolua.cast(panel:getChildByName("likeBtn"), "ccui.Button")
    -- touchEvent 触摸事件回调方法
    local function touchLikeEvent( sender, eventType )

        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            panel:setTouchEnabled(false);
            MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN,removeComplte);
            PlatformLuaRateGame();
            MainValue.dataManager.expandManager:setComments();
        end
    end
    likeBtn:addTouchEventListener(touchLikeEvent);
    
    local noLikeBtn = tolua.cast(panel:getChildByName("noLikeBtn"), "ccui.Button")
    -- touchEvent 触摸事件回调方法
    local function touchNolikeEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            panel:setTouchEnabled(false);
            MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN,removeComplte);
        end
    end
    noLikeBtn:addTouchEventListener(touchNolikeEvent);
    
    
    
    local button_Label = likeBtn:getChildren()[1];
    local licktext = FacFont:getFontsBmp(FontType.FontRed, "Like");
    likeBtn:addChild(licktext);
    licktext:setPosition(button_Label:getPosition());
    button_Label:removeFromParent();

   
    local no_button_Label = noLikeBtn:getChildren()[1];
    local noLiketext = FacFont:getFontsBmp(FontType.FontRed, "Dislike");
    noLikeBtn:addChild(noLiketext);
    noLiketext:setPosition(no_button_Label:getPosition());
    no_button_Label:removeFromParent();
    
    
    return panel;
end;



function RateGamePanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_UP,nil,nil);
end













return RateGamePanel;
