local ShareSuccessPanel = class("ShareSuccessPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/PromptBoxPanel.json");
end)

function ShareSuccessPanel:ctor()
    self.okBtn =nil;
    
    self.desTxt = nil;
end

function ShareSuccessPanel.create()
    local temp = ShareSuccessPanel.new();
    temp:init();
    return temp;
end

function ShareSuccessPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    self:setScale(0);

    self.desTxt =  FacFont:getFontsBmp(FontType.FontYellowRedSide, "Ads is loading.", 392, "C", -20);
    self.desTxt:setPosition(0, 80);
    self:addChild(self.desTxt);
    
    self.okBtn = ccui.Button:create("ui/ui/btnYellow1.png","ui/ui/btnYellow2.png", nil ,1);
    self.okBtn:setScale9Enabled(true)
    self.okBtn:setContentSize(cc.size(284, 110))
    self.okBtn:setPosition(0, -62)
    self:addChild(self.okBtn);

    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:disapperAlone();
        end
    end
    self.okBtn:addTouchEventListener(touchEvent);

    self.okTxt = FacFont:getFontsBmp(FontType.FontWhite, "OK") --MainValue.infosManager:getObjMultilingualByKey("Try_btn"))
    self.okTxt:setPosition(137, 60);
    self.okBtn:addChild(self.okTxt);
end

function ShareSuccessPanel:appearAlone()
    MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.POP_UP, self.appearComplete,self.disapperAlone);
end

function ShareSuccessPanel:appearComplete()

end

function ShareSuccessPanel:disapperAlone()
    MainValue.mxUIManager.panelManager:removePanelAlone(self,PanelDisappearType.POP_UNDER , self.disapperComplete)
end

function ShareSuccessPanel:disapperComplete()

end

return ShareSuccessPanel
