local BuySucUI = class("BuySucUI",function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/PromptBoxPanel.json")
end)
local thisW
local thisH
function BuySucUI:ctor()
  
end

function BuySucUI.create()
    local thisUI = BuySucUI.new()
    thisUI:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);
    thisW = thisUI:getContentSize().width
    thisH = thisUI:getContentSize().height
    
    local titleBgLeft = cc.Sprite:createWithSpriteFrameName("ui/ui/panelEaves.png")
    titleBgLeft:setPosition(thisW*0.5-154,thisH*0.5+170)
    thisUI:addChild(titleBgLeft)
    
    
    local titleBgRight = cc.Sprite:createWithSpriteFrameName("ui/ui/panelEaves.png")
    titleBgRight:setScaleX(-1)
    titleBgRight:setPosition(thisW*0.5+154,thisH*0.5+170)
    thisUI:addChild(titleBgRight)
    
    
    
    
    
    
--    auto starMenuItem = MenuItemImage::create(
--    "ButtonStar.png",
--    "ButtonStarSel.png", CC_CALLBACK_1(HelloWorld::starMenuCallback, this));
--starMenuItem->setPosition(Point(160, 220));
--auto starMenu = Menu::create(starMenuItem, NULL);
--starMenu->setPosition(Point::ZERO);
--this->addChild(starMenu, 1);
    
    
    
--    local yellow1Spr = ThreeLMRGridTools.create("ui/ui/btnYellow1.png",260,47)
--    local yellow2Spr = ThreeLMRGridTools.create("ui/ui/btnYellow2.png",260,47)

    local yellow2Spr = NineGridTools.create("ui/ui/bgCooky.png",460,140,26)
    yellow2Spr:setPosition(thisW*0.5,thisH*0.5 + 10)
    thisUI:addChild(yellow2Spr)
    
    local function touchEvent1( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            if thisUI.isAloneShow then
                thisUI:disapperAlone();
            else
                thisUI:disapper();
            end
        end
    end
    
    local  item1 = cc.MenuItemImage:create(cc.Sprite:createWithSpriteFrameName("ui/ui/btnYellow1.png"), cc.Sprite:createWithSpriteFrameName("ui/ui/btnYellow2.png"))
    item1:registerScriptTapHandler(touchEvent1)
    item1:setPosition(thisW * 0.5 ,thisH * 0.5 - 117)
    thisUI:addChild(item1)
    
    
    local closeBtn = ccui.Button:create("ui/ui/btnYellow1.png","ui/ui/btnYellow2.png","",1);
    closeBtn:setScaleX(1.5)
    closeBtn:setPosition(thisW * 0.5 ,thisH * 0.5 - 117)
    thisUI:addChild(closeBtn)
    
    
    local playSpr = FacFont:getFontsBmp(FontType.FontWhite,MainValue.infosManager:getObjMultilingualByKey("Common_play"))
--    playSpr:setScaleX(1.5)
    playSpr:setPosition(70,65)
    closeBtn:addChild(playSpr)
--    local bestScores = MainValue.infosManager:getObjMultilingualByKey("Common_BestScore")
--    bestScores = string.gsub(bestScores, "%b{}", self.bestScore)
    
    local title = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,MainValue.infosManager:getObjMultilingualByKey("BuySucUITitle"))
    title:setScale(0.8)
    title:setPosition(thisW * 0.5,thisH * 0.5 + 200)
    thisUI:addChild(title)    
    
--    添加ok按钮

    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            if thisUI.isAloneShow then
                thisUI:disapperAlone();
            else
                thisUI:disapper();
            end
        end
    end
    closeBtn:addTouchEventListener(touchEvent);
    
    return thisUI    
end

function BuySucUI:setData(cashNum)
    local descStr = MainValue.infosManager:getObjMultilingualByKey("BuySucUIDesc")
    descStr = string.gsub(descStr, "%b{}", cashNum)
    local desc = FacFont:getFontsBmp(FontType.FontYellowRedSide,descStr)
    
    desc:setPosition(thisW * 0.5,thisH * 0.5 + 40)
    self:addChild(desc)


end

function BuySucUI:appearAlone()
    self.isAloneShow = true
--    MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapperAlone);
    MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.COME_DOWN);
end

function BuySucUI:disapperAlone()
--    MainValue.mxUIManager.panelManager:removePanelAlone(self,PanelDisappearType.LEAVE_DOWN , self.disapperComplete)
    MainValue.mxUIManager.panelManager:removePanelAlone(self,PanelDisappearType.LEAVE_DOWN )
end
return BuySucUI   