local listsp
--ui名称列表
local uilist = {"AskForLive","AskForHelp", "FBConnect","FBConnectSuccess","FBDisconnect",
                "BlockerLock","BlockerLockOffline","BlockerReward","DailyBonusMain","DailyBonusPopup",
                --[["Failed",]]"Help","HintClickLinkRewardGot","Inbox",
                --[["InGameStart",]]"InviteFriends",--[["LoadingMobile","LoseNotEnoughScore","LoseNotReachTarget",]]
                "LoseSettlement","NotEnoughLife","PlayGamePanel",--[["QuitLevelPopup","RecommendItem",]]
                "ShopBuyCash","UnlockItem","WinAheadOfAnother","WinRankUp","WinSettlement","DailyRewards",
                --[["InGameExitPopup",]]"StarterPackage","AskFbHelp","GetFbMsg","DeleteMsg",
                "PassLevel","PassLevel(10)","AddCash","VersionInfo","FBLoginPanel"}
                

local listNode = nil
local cheatManager = nil;
             
local UIListSp = class("UIListSp", function()
    return cc.Node:create();
end);

function UIListSp:create()
    listsp = UIListSp.new()
    cclog("!!UIListSp.create!!!!");
    
    listsp:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    
    --添加列表容器
    listNode = cc.Node:create();
    listsp:addChild(listNode);
    
    local cheat = require("ui.uiListHelp.CheatManager");  
    cheatManager = cheat.create();
    
    return listsp;
end

--显示对应UI
local menuCallback = function (index)
    print("index : " .. index.." ,ui name : " .. uilist[index]);
    
    if uilist[index] == "AskForLive" then
    

        local buySucUIClz = require("src/ui/storeUI/BuySucUI")
        local BuySucUI = buySucUIClz.create();
        BuySucUI:setData(10)
        BuySucUI:appearAlone();
    
--        local askForLiveClz = require("ui/AskForHelp/AskForHelp")
--        local askForLive = askForLiveClz.create(1);
--        askForLive:appear();
    elseif uilist[index] == "AskForHelp" then
        local askForHelpClz = require("ui/AskForHelp/AskForHelp")
        local askForHelp = askForHelpClz.create(2);
        askForHelp:setBlockId(2);
        askForHelp:appear();
    elseif uilist[index] == "FBConnect" then
        local askForHelpClz = require("ui/FBConnect/FBConnectPanel")
        local askForHelp = askForHelpClz.create();
        askForHelp:appearAlone();
    elseif uilist[index] == "FBConnectSuccess" then
        local askForHelpClz = require("ui/FBConnect/FBConnectSuccessPanel")
        local askForHelp = askForHelpClz.create();
        askForHelp:appearAlone();
    elseif uilist[index] == "FBDisconnect" then
        local askForHelpClz = require("ui/FBConnect/FBDisconnectPanel")
        local askForHelp = askForHelpClz.create();
        askForHelp:appearAlone();
    elseif uilist[index] == "BlockerLock" then
        local blockerLockClz = require("ui/blockerLock/BlockerLockPanel")
        local blockerLock = blockerLockClz.create();
        blockerLock:init();
        listsp:getParent():addChild(blockerLock);
    elseif uilist[index] == "BlockerLockOffline" then
        local blockerLockOfflineClz = require("ui/blockerLockOffline/BlockerLockOfflinePanel")
        local blockerLockOffline = blockerLockOfflineClz.create();
        blockerLockOffline:init();
        listsp:getParent():addChild(blockerLockOffline);
    elseif uilist[index] == "BlockerReward" then
        local blockerRewardPanelClz = require("ui/blockerReward/BlockerRewardPanel")
        local blockerRewardPanel = blockerRewardPanelClz.create();
        blockerRewardPanel:init();
        listsp:getParent():addChild(blockerRewardPanel);
    elseif uilist[index] == "DailyBonusMain" then
        local dailyBonusMainPanelClz = require("ui.dailyBonusMain.DailyBonusMainPanel")
        local dailyBonusMainPanel = dailyBonusMainPanelClz.create();
--        listsp:getParent():addChild(dailyBonusMainPanel);
        dailyBonusMainPanel:appear();
    elseif uilist[index] == "DailyBonusPopup" then
    	local dailyBonusPopupPanelClz = require("ui/dailyBonusPopup/DailyBonusPopupPanel")
        local dailyBonusPopupPanel = dailyBonusPopupPanelClz.create();
        listsp:getParent():addChild(dailyBonusPopupPanel);
        dailyBonusPopupPanel:init();
    elseif uilist[index] == "Failed" then
        local ingGameFailedClz = require("ui/inGame/InGameFailedPanel")
        local ingGameFailed = ingGameFailedClz.create(1);
        ingGameFailed:init();
        listsp:getParent():addChild(ingGameFailed);
    elseif uilist[index] == "HintClickLinkRewardGot" then
        local hintClickLinkRewardGotPanelClz = require("ui/hintClickLinkRewardGot/HintClickLinkRewardGotPanel")
        local hintClickLinkRewardGotPanel = hintClickLinkRewardGotPanelClz.create();
        hintClickLinkRewardGotPanel:init();
        listsp:getParent():addChild(hintClickLinkRewardGotPanel);
    elseif uilist[index] == "Help" then
        local helpClz = require("ui/help/HelpPanel")
        local helpPanel = helpClz.create();
        helpPanel:init();
        listsp:getParent():addChild(helpPanel);
    elseif uilist[index] == "PlayGamePanel" then
        local playGamePanelClz = require("ui/playGamePanel/PlayGamePanel")
        local playGamePanel = playGamePanelClz.create(1);
        playGamePanel:init();
        listsp:getParent():addChild(playGamePanel);
    elseif uilist[index] == "Inbox" then
--        local function getMesSuccess(i, data)
--            local inboxClz = require("ui/inbox/InboxPanel")
--            local inbox = inboxClz.create(data);
--            inbox:appear();
--        end
--        MainValue.fbManager:getMessage(getMesSuccess)
        
        --------本地测试------
        local inboxClz = require("ui/inbox/InboxPanel")
        local inbox = inboxClz.create();
        inbox:appear();
    elseif uilist[index] == "InGameStart" then
        local ingGameStartClz = require("ui/inGame/InGameStartPanel")
        local ingGameStart = ingGameStartClz.create();
        ingGameStart:setData();
        ingGameStart:appear();
    elseif uilist[index] == "InviteFriends" then
        local inviteClz = require("ui/inviteFriend/InviteFriendPanel")
        local invite = inviteClz.create();
        invite:init();
        listsp:getParent():addChild(invite);
    elseif uilist[index] == "LoadingMobile" then
        --没资源
    elseif uilist[index] == "LoseNotEnoughScore" then
        local notEnoughClz = require("ui/inGame/InGameFailedPanel")
        local notEnough = notEnoughClz.create();
        notEnough:setData(2);
        notEnough:appear();
    elseif uilist[index] == "LoseNotReachTarget" then
        local notReachClz = require("ui/inGame/InGameFailedPanel")
        local notReach = notReachClz.create();
        notReach:setData(3);
        notReach:appear();
    elseif uilist[index] == "LoseSettlement" then
        local loseSettlementClz = require("ui/loseSettlement/LoseSettlementPanel")
        local loseSettlement = loseSettlementClz.create()
        loseSettlement:setData(1)
        loseSettlement:appear();
    elseif uilist[index] == "NotEnoughLife" then
        local notEnoughLifes = require("ui/NotEnoughLife")
        local notEnoughLife = notEnoughLifes.create()
        notEnoughLife:init()
        listsp:getParent():addChild(notEnoughLife)
    elseif uilist[index] == "QuitLevelPopup" then
        local quitPanelUIClz = require("ui/quitLevelPopup/QuitLevelPopup");
        local quitPanelUI = quitPanelUIClz.create();
        quitPanelUI:init();
        listsp:getParent():addChild(quitPanelUI);
    elseif uilist[index] == "RecommendItem" then
        local recommendItemUIClz = require("ui/RecommendItemUI")
        local obj = {{des = "xxxxxxxxxxxxxxxxxxxxx",id = 1,count=5,cost=20},{count =10,cost=30}}
        local recommendItemUI = recommendItemUIClz.create(obj);
        recommendItemUI:init();
        listsp:getParent():addChild(recommendItemUI);
    elseif uilist[index] == "ShopBuyCash" then
        local storeUIClz = require("ui.StoreUI.StoreUI")
        local storeUI = storeUIClz.create()
        --storeUI:init()
        storeUI:appear();
    elseif uilist[index] == "UnlockItem" then
        local UnlockItemClz = require("ui/UnlockItemPanel")
        local unlockItem = UnlockItemClz.new()
        unlockItem:appear();
        
    elseif uilist[index] == "WinAheadOfAnother" then
        local WinAheadOfAnotherClz = require("ui/winAheadOfAnother/WinAheadOfAnotherPanel")
        local WinAheadOfAnother = WinAheadOfAnotherClz.create();
        WinAheadOfAnother:appear();
    elseif uilist[index] == "WinRankUp" then
        local winkRankUp = require("ui/winRankUp/WinRankUpPanel")
        local winkRankUp = winkRankUp.create();
        winkRankUp:appear();
    elseif uilist[index] == "WinSettlement" then
        local winSettlement = require("ui/winSettlement/WinSettlement")
        local winSettlement = winSettlement.create();
        winSettlement:setData(1, 1000, 0, 5000, 2);
        winSettlement:appear();
    elseif uilist[index] == "DailyRewards" then
        local dailyRewards = require("ui/dailyRewards/DailyRewards")
        local dailyRewardsUI = dailyRewards.create();
        dailyRewardsUI:appear();
    elseif uilist[index] == "InGameExitPopup" then
        local inGameExitPopupClz = require("ui/inGame/InGameExitPanel")
        local inGameExitPopup = inGameExitPopupClz.create();
        inGameExitPopup:init();
        listsp:getParent():addChild(inGameExitPopup);
    elseif uilist[index] == "StarterPackage" then
        local starterPackageClz = require("ui/StarterPackage")
        local starterPackage = starterPackageClz.create()
        starterPackage:init()
        listsp:getParent():addChild(starterPackage)   
    elseif uilist[index] == "AskFbHelp" then
        local fids = MainValue.dataManager.friendManager:getFriendsIds();
        MainValue.fbManager:askHeart(fids);
    elseif uilist[index] == "GetFbMsg" then
        cheatManager:getMessage();
    elseif uilist[index] == "DeleteMsg" then
        MainValue.fbManager:deleteMessage();
    elseif uilist[index] == "PassLevel" then 
        cheatManager:passLevel();
    elseif uilist[index] == "PassLevel(10)" then 
        cheatManager:passLevelMore();
    elseif uilist[index] == "AddCash" then
        MainValue.dataManager.userManager:addCash(10000)
    elseif uilist[index] == "VersionInfo" then
        cheatManager:showVersionPanel()
    elseif uilist[index] == "FBLoginPanel" then
        local loginClz = require("src/ui/FBConnect/FBLoginPanel")
        local loginPanel = loginClz.create();
        loginPanel:appearAlone()
    end
    
    
    
end

function UIListSp:init()
	if config.isDebug() then
		--添加测试按钮块
		local function testButtonTouchEvent(sender,eventType)
			if eventType == ccui.TouchEventType.began then
				print("Touch Down")
			elseif eventType == ccui.TouchEventType.moved then
				print("Touch Move")
			elseif eventType == ccui.TouchEventType.ended then
				print("Touch Up")
				--设置测试列表是否显示
				setTestUIListEnabled();
			elseif eventType == ccui.TouchEventType.canceled then
				print("Touch Cancelled")
			end
		end 
		
		local testButton = ccui.Button:create()
		testButton:setTitleText("Test UI");
		testButton:setTitleColor(cc.c3b(1,255,1))
		testButton:setTitleFontSize(14)
		testButton:loadTextures("ui/ui/btnYellow1.png", "ui/ui/btnYellow2.png", "",1)
		testButton:setPosition(-(MainValue.winSize.width / 2) + (testButton:getContentSize().width / 2 - 10) , (MainValue.winSize.height / 2 - 30))
		testButton:addTouchEventListener(testButtonTouchEvent)
		testButton:retain();
		
		listsp:addChild(testButton)
		--添加测试UI列表
		addTestUIList();
		--设置测试列表是否显示
		setTestUIListEnabled();
	end
end

function addTestUIList()

     --添加背景
    local width = MainValue.winSize.width;
    local height = MainValue.winSize.height;

--    local draw = cc.DrawNode:create();
--    --draw a solid rectangle
--    draw:drawSolidRect(cc.p((width/2),(height/2)), cc.p(-(width/2),-(height/2)), cc.c4f(255,255,255,1));
--    listNode:addChild(draw);

    local menu = cc.Menu:create()
    menu:setPosition(cc.p(0,-300))
    listNode:addChild(menu)

    for i in pairs(uilist) do
        ----cc.MenuItemFont:create(uilist[i])
        
        local item = cc.MenuItemSprite:create(cc.Sprite:createWithSpriteFrameName("ui/ui/btnYellow1.png"),cc.Sprite:createWithSpriteFrameName("ui/ui/btnYellow2.png"),cc.Sprite:createWithSpriteFrameName("ui/ui/btnYellow2.png"))
        --cc.MenuItemImage:create("ui/button/btn1SR1.png", "ui/button/btn1SR2.png", "");
        
        item:setTag(i);
        
        local itemLable = cc.LabelTTF:create(uilist[i], "Marker Felt", 30);
        itemLable:setPosition(item:getContentSize().width / 2,item:getContentSize().height / 2);
        itemLable:setColor(cc.c3b(255, 0, 0))
        item:addChild(itemLable);
        item:setScale(0.6)
        
        if i % 3 == 0 then
            item:setPositionX(200)
        elseif i % 3 == 1 then
            item:setPositionX(0)
        elseif i % 3 == 2 then
            item:setPositionX(-200)
        end 

        local setY = ((i+1)/3) * 45;
        item:setPositionY(setY)
        item:registerScriptTapHandler(menuCallback)
        menu:addChild(item)

    end
end

function setTestUIListEnabled()
    local value = listNode:isVisible();
    
    value = not value;
    listNode:setVisible(value);
end


return UIListSp
