
local AlertManager = class("AlertManager");

AlertManager.layer = nil;

function AlertManager:ctor()
    self.layer = cc.Layer:create();
    self.exitLogin = nil;
    self.isHavePanel = nil;

    if device.platform ~= "android" then
        return 
    end


    self.layer:addNodeEventListener(cc.KEYPAD_EVENT, function(event) 
        if event.key == "back" then 

            --    Application:onEnterBackground()
            --    Application:onEnterForeground()
            MainValue.platformManager:onAndroidKeyBackEvent()
            --    MainValue.mxSplashManager:backPack()

            print("AlertManager-110110110110-点击返回键")

        elseif event.key == "menu" then

        end                   
    end)
    self.layer:setKeypadEnabled(true)
end

function AlertManager.create()
    local temp = AlertManager.new();








    return temp;
end


function AlertManager:addShowText(txt)

    local txtStr = tostring(txt)
    local descBmp =  FacFont:getFontsBmp(FontType.FontWhite,txtStr)

    descBmp:setPosition(VisibleRect:center())
    self.layer:addChild(descBmp)



end


function AlertManager:addPanel()

    if self.isHavePanel == true then
        return;
    end
    if self.exitLogin == nil then
        local exitLoginPanel = require("ui.backPack.ExitLoginPanel");
        self.isHavePanel = true;
        self.exitLogin = exitLoginPanel.create();
        self.layer:addChild(self.exitLogin);
        self.exitLogin:init();
    end


end

function AlertManager:removePanel()

    if self.exitLogin ~= nil then
        self.exitLogin:onClose();
    end



end

--进入游戏开始界面
function AlertManager:onEnterSplash()
end

--退出游戏开始界面
function AlertManager:onExitSplash()
end 

--进入地图
function AlertManager:onEnterMap()
end 

--退出地图
function AlertManager:onExitMap()
end

--进入游戏
function AlertManager:onEnterGame()
end
--onEnteredGame

--退出游戏
function AlertManager:onExitGame()
end

function AlertManager:backPack()

    return self.isHavePanel; 
end
return AlertManager;