-- Game config. 游戏配置文档（请确保为UTF-8无BOM格式）。
-- 发布时务必注释所有debug选项
config = {
ver=1,
grid = {
	tiledWidth = 82,							-- 格子宽
	tiledHeight = 82,							-- 格子高
	rimW = 6,									-- 边框修正
	rimH = 6,									-- 边框修正
	
	promptGap = 4,								-- 提示间隔时间  单位：s
	swapDuration = 0.1,							-- 交换单位时间
	checkDealyTime = 0.05,						-- 检测延迟时间
    clearDuration = 0.35,                        -- 延迟一定时间后开始播放爆炸特效
	clearPowerUpDuration = 0.4;						
	checkDropDealyTime = 0.46,					-- 检测下落延迟时间
	
	dropSpeed = 450,							-- 下落速度 (像素/秒)
	dropTiltSpeed = 700,						-- 斜落速度 (像素/秒)
	dropGSpeed = 1500,							-- 下落加速度 (像素/秒)
	dropMaxSpeed = 3000,						-- 下落加速度 (像素/秒)
	
	startDropDuration = 0.5,					-- 进入关卡时下落的时间(单位时间)
	armatureAnimationSpeed = 1.5,				-- 格子中物品的动画播放速度
	clearToBigDuration = 0.2,					-- 格子消失动画从小变大需要的时间
	clearToBigScale = 1.2,						-- 格子消失动画变大的倍率
	clearToSmallDuration = 0.2,					-- 格子消失动画从大变小需要的时间
	clearToSmallScale = 0,						-- 格子消失动画变小的倍率
	--clearDuration = clearToBigDuration + clearToSmallDuration,--影响下落检测的延时
	
	},
	
effect={
	rocketOffset = 2000,						-- 火箭飞行距离
	flyTime = 1.5,								-- 火箭飞行时间
	},
	
init = function(self)
	-- 格子动物因为锚点转换，需要修正的位置偏移量
	self.grid.gridOffsetX = (self.grid.tiledWidth/2) + self.grid.rimW
	self.grid.gridOffsetY = (self.grid.tiledHeight/2) + self.grid.rimH
	self.grid.clearDuration = self.grid.clearToBigDuration + self.grid.clearToSmallDuration
	-- print_r(self.grid)
end,

isDebug = function()
	return DEBUG == 1 or DEBUG == 2
end
}