local TaskDataManager = class("TaskDataManager");

function TaskDataManager:ctor()
    self.usePropData = {};
end

function TaskDataManager.create()
    local temp = TaskDataManager.new();
    
    
    return temp;
end
--关卡
function TaskDataManager:getLevel()
    return MainValue.dataManager.levelManager:getMaxLevel() - 1;
end
--星星
function TaskDataManager:getStar()
    return MainValue.dataManager.levelManager:getMaxStar();
end
--根据道具id获取使用所有道具次数
function TaskDataManager:getAllUsePorpDataByID(propID)
    if self.usePropData[propID] == nil then
        self.usePropData[propID] = 0;
    end

    return self.usePropData[propID];
end
--获取使用所有道具次数
function TaskDataManager:getAllUsePorpData()
    return self.usePropData;
end
--设置使用道具
function TaskDataManager:setUsePorp(propID,count)
    count = count or 1;
    
    if self.usePropData[propID] == nil then
        self.usePropData[propID] = count;
    else
        self.usePropData[propID] = self.usePropData[propID] + count;
    end

end


return TaskDataManager;