local DataFriend = class("DataFriend");

--此类数据不缓存本地
function DataFriend:ctor()
    self.KEY = 
        {
            --已安装好友数据
            FRIENDS_DATA = "fdData",
            --未装好友数据
            INVITE_FRIENDS_DATA = "inviteData",
            --平台好友交互限制数据(如：送心、要心等等每天一次)
            PLATFORM_DATA = "pfData",
            --信箱(免费赠送道具，心和钱。注：好友的数据信件暂无，延用FB的信箱)
            INBOX = "inbox",
            --每日给好友送心限制
            DAILY = "daily"
        }
    
    self.data = {};
end

-- ----------------------------------------------------------LEVEL

function DataFriend:getAllFriend()
    return self.data[self.KEY.FRIENDS_DATA];
    --return self.data;
end

function DataFriend:setAllFriend(pdata)
    self.data[self.KEY.FRIENDS_DATA] = pdata;
    --self.data = pdata;
end

function DataFriend:getAllInviteFriend()
    return self.data[self.KEY.INVITE_FRIENDS_DATA];
end

function DataFriend:setAllInviteFriend(pdata)
    self.data[self.KEY.INVITE_FRIENDS_DATA] = pdata;
end

--[[
function DataFriend:getAllPlatform()
    return self.data[self.KEY.PLATFORM_DATA];
end

function DataFriend:setAllPlatform(pdata)
    self.data[self.KEY.PLATFORM_DATA] = pdata;
end
]]

function DataFriend:getInbox()
    return self.data[self.KEY.INBOX];
end

function DataFriend:setInbox(pdata)
    self.data[self.KEY.INBOX] = pdata;
end

function DataFriend:getDaily()
    return self.data[self.KEY.DAILY];
end

function DataFriend:setDaily(pdata)
    self.data[self.KEY.DAILY] = pdata;
    MainValue.dbManager:flush();
end

-- -------------------------------------------------------------

function DataFriend:setData(pdata)
    self.data = pdata;
    if(self.data[self.KEY.DAILY] == nil) then self.data[self.KEY.DAILY] = {} end
end

function DataFriend:getData()
    local dailyData = self.data[self.KEY.DAILY];
    local loc_data = {};
    --只保存daily数据(每日限制数据)
    loc_data[self.KEY.DAILY] = dailyData;
    
    return loc_data;
end

function DataFriend.create()
    local temp = DataFriend.new();
    return temp;
end

return DataFriend;