--LEVEL    {"1":{"score":1000,"stars":1},"2":{"score":2000,"stars":2}}
--BLOCK    {"20":{"bk":0,"id":["1000","1000","1000"]},"30":{"bk":0,"id":["1000","1000","1000"]}}
local DataLevel = class("DataLevel");

function DataLevel:ctor()

    self.KEY = 
    {
        LEVEL = "lvData",
        --BLOCK = "bkData",
        BOX = "boxData"
    }
    
    self.data = {};
    
end

-- ----------------------------------------------------------LEVEL

function DataLevel:getAllLevel()
    return self.data[self.KEY.LEVEL];
end

function DataLevel:setAllLevel(pdata)
    self.data[self.KEY.LEVEL] = pdata;
    MainValue.dbManager:flush();
end

function DataLevel:getLevel(lv)
    return self.data[self.KEY.LEVEL][tostring(lv)];
end

function DataLevel:setLevel(lv, pdata)
    self.data[self.KEY.LEVEL][tostring(lv)] = pdata;
    MainValue.dbManager:flush();
end

-- ----------------------------------------------------------BLOCK
--[[
function DataLevel:getAllBlock()
    return self.data[self.KEY.BLOCK];
end

function DataLevel:setAllBlock(pdata)
    self.data[self.KEY.BLOCK] = pdata;
    MainValue.dbManager:flush();
end

function DataLevel:getBlock(lv)
    return self.data[self.KEY.BLOCK][tostring(lv)];
end

function DataLevel:setBlock(lv, pdata)
    self.data[self.KEY.BLOCK][tostring(lv)] = pdata;
    MainValue.dbManager:flush();
end

]]

-- ----------------------------------------------------------BOX

function DataLevel:getAllBox()
    return self.data[self.KEY.BOX];
end

function DataLevel:setAllBox(pdata)
    self.data[self.KEY.BOX] = pdata;
    MainValue.dbManager:flush();
end

function DataLevel:getBox(id)
    return self.data[self.KEY.BOX][tostring(id)];
end

function DataLevel:setBox(id, pdata)
    self.data[self.KEY.BOX][tostring(id)] = pdata;
    MainValue.dbManager:flush();
end

-- ---------------------------------------------------------

function DataLevel:setData(pdata)
    self.data = pdata;
    
    if(self.data[self.KEY.LEVEL] == nil) then self.data[self.KEY.LEVEL] = {} end
    --if(self.data[self.KEY.BLOCK] == nil) then self.data[self.KEY.BLOCK] = {} end
    if(self.data[self.KEY.BOX] == nil) then self.data[self.KEY.BOX] = {} end
end

function DataLevel:getData()
    return self.data;
end

function DataLevel.create()
    local temp = DataLevel.new();
    return temp;
end

return DataLevel;