local DataUser = class("DataUser");

function DataUser:ctor()

    self.data = {}
    
    self.KEY = 
    {
        UID = "uid",
        CASH = "cash",
        HEART = "heart",
        
        PID = "pid",
        NAME = "name",
        PIC = "picture",
        USERNAME = "username",
    }
    
end

-- ----------------------------------UID

function DataUser:getUID()
    return self.data[self.KEY.UID];
end

function DataUser:setUID(pdata)
    self.data[self.KEY.UID] = pdata;
end

-- ----------------------------------PID (platform id)

function DataUser:getPID()
    return self.data[self.KEY.PID];
end

function DataUser:setPID(pdata)
    self.data[self.KEY.PID] = pdata;
end

-- ----------------------------------name (platform name)

function DataUser:getName()
    return self.data[self.KEY.NAME];
end

function DataUser:setName(pdata)
    self.data[self.KEY.NAME] = pdata;
end

-- ----------------------------------picture (platform picture)

function DataUser:getPicture()
    return self.data[self.KEY.PIC];
end

function DataUser:setPicture(pdata)
    self.data[self.KEY.PIC] = pdata;
end

-- ----------------------------------username (platform username)

function DataUser:getUserName()
    return self.data[self.KEY.USERNAME];
end

function DataUser:setUserName(pdata)
    self.data[self.KEY.USERNAME] = pdata;
end

-- ----------------------------------coin
--[[
function DataUser:getCoin()
    return self.data[self.KEY.COIN];
end

function DataUser:setCoin(pdata)
    self.data[self.KEY.COIN] = pdata;
    MainValue.dbManager:flush();
end
]]
-- ----------------------------------cash

function DataUser:getCash()
    return self.data[self.KEY.CASH];
end

function DataUser:setCash(pdata)
    self.data[self.KEY.CASH] = pdata;
    MainValue.dbManager:flush();
end

-- ----------------------------------heart

function DataUser:getHeart()
    return self.data[self.KEY.HEART];
end

function DataUser:setHeart(pdata)
    self.data[self.KEY.HEART] = pdata;
    MainValue.dbManager:flush();
end

-- ------------------------------------------

function DataUser:setData(pdata)
    self.data = pdata;
    
    if(self.data[self.KEY.UID] == nil) then self.data[self.KEY.UID] = "" end
    if(self.data[self.KEY.PID] == nil) then self.data[self.KEY.PID] = "" end
    --if(self.data[self.KEY.COIN] == nil) then self.data[self.KEY.COIN] = 0 end
    if(self.data[self.KEY.CASH] == nil) then self.data[self.KEY.CASH] = 20 end
    if(self.data[self.KEY.HEART] == nil) then self.data[self.KEY.HEART] = 5 end
end

function DataUser:getData(pkey)
    return self.data;
end

function DataUser.create()
    local temp = DataUser.new();
    return temp;
end

return DataUser;