local FadeAction = class("FadeAction");

function FadeAction.create()
    local temp = FadeAction.new();
    return temp;
end

-- 淡入
function FadeAction:FadeIn(uiNode,callFun)  
    local action1 = cc.FadeIn:create(1);
    if (callFun == nil) then
        uiNode:runAction(cc.Sequence:create(action1));
    else
        uiNode:runAction(cc.Sequence:create(cc.EaseIn:create(action1, 0.8), cc.CallFunc:create(callFun)));
    end
    
end

-- 淡出
function FadeAction:FadeOut(uiNode,callFun)
    local action2 = cc.FadeOut:create(0.6);
    
    if (callFun == nil) then
        uiNode:runAction(cc.Sequence:create(action2));
    else
        uiNode:runAction(cc.Sequence:create(action2, cc.CallFunc:create(callFun)));
    end
    
end

return FadeAction;