local JellyAction = class("JellyAction");

function JellyAction.create()
    local temp = JellyAction.new();
    return temp;
end

-- 果冻抖动
function JellyAction:run(uiNode,offV,callFun)  
    local button = uiNode;
    
    local function zoom1(offset, time, onComplete)
        local x, y = button:getPosition()
        local size = button:getContentSize()

        local scaleX = button:getScaleX() * (size.width + offset) / size.width
        local scaleY = button:getScaleY() * (size.height - offset) / size.height

        y = y - offset

        local ac = cc.Sequence:create(cc.ScaleTo:create(time,scaleX,scaleY),cc.CallFunc:create(onComplete));--cc.MoveTo:create(time, cc.p(x, y)),
        button:runAction(ac)
    end

    local function zoom2(offset, time, onComplete)
        local x, y = button:getPosition()
        local size = button:getContentSize()

        y = y + offset

        local ac = cc.Sequence:create(cc.ScaleTo:create(time,1.0,1.0),cc.CallFunc:create(onComplete));--cc.MoveTo:create(time, cc.p(x, y)),
        button:runAction(ac)
    end

    zoom1(offV, 0.08, function()
        zoom2(offV, 0.09, function()
            zoom1(offV/2, 0.10, function()
                zoom2(offV/2, 0.11, function()
                    if (callFun ~= nil) then callFun() end;
                end)
            end)
        end)
    end)
    
end

-- 果冻压扁
function JellyAction:press(uiNode,offV,callFun)  
    local button = uiNode;

    local function zoom1(offset, time, onComplete)
        local x, y = button:getPosition()
        local size = button:getContentSize()

        local scaleX = button:getScaleX() * (size.width + offset) / size.width
        local scaleY = button:getScaleY() * (size.height - offset) / size.height

        y = y - offset

        local ac = cc.Sequence:create(cc.ScaleTo:create(time,scaleX,scaleY),cc.CallFunc:create(onComplete));--cc.MoveTo:create(time, cc.p(x, y)),
        button:runAction(ac)
    end

    local function zoom2(offset, time, onComplete)
        local x, y = button:getPosition()
        local size = button:getContentSize()

        y = y + offset

        local ac = cc.Sequence:create(cc.ScaleTo:create(time,1.0,1.0),cc.CallFunc:create(onComplete));--cc.MoveTo:create(time, cc.p(x, y)),
        button:runAction(ac)
    end

    zoom1(offV/2, 0.10, function()
        if (callFun ~= nil) then callFun() end;
    end)

end

return JellyAction;