local PopAction = class("PopAction");

function PopAction.create()
    local temp = PopAction.new();
    return temp;
end

-- 中间弹开
function PopAction:PopUp(uiNode,callFun)  
    local function action2(node)
        node:stopAllActions() --After this stop next action not working, if remove this stop everything is working

        local ac3 = nil;
        if (callFun == nil) then
            ac3 = cc.Sequence:create(cc.EaseOut:create(cc.ScaleTo:create(0.1, 1), 0.8));
        else
            ac3 = cc.Sequence:create(cc.EaseOut:create(cc.ScaleTo:create(0.1, 1), 0.8), cc.CallFunc:create(callFun));
        end
        node:runAction(ac3);
    end

    local ac1 = cc.Sequence:create(cc.EaseIn:create(cc.ScaleTo:create(0.15, 1.1), 0.8), cc.CallFunc:create(action2));
    uiNode:runAction(ac1);
end

-- 中间收回
function PopAction:PopUnder(uiNode,callFun)
    uiNode:stopAllActions()
    
    local ac1 = cc.ScaleTo:create(0.15, 0)
    
    if (callFun == nil) then
        uiNode:runAction(cc.Sequence:create(ac1));
    else
        uiNode:runAction(cc.Sequence:create(ac1, cc.CallFunc:create(callFun)));
    end
end

return PopAction;