local UIAction = class("UIAction");

function UIAction.create()
    local temp = UIAction.new();
    return temp;
end

-- ui出现
function UIAction:UIAppear(uiNode, actionType, callFun)  
    local winSizeHeight = MainValue.winSize.height;
    
    local function action2(node)
        node:stopAllActions() --After this stop next action not working, if remove this stop everything is working
        
        local ac3 = nil;
        if (callFun == nil) then
            ac3 = cc.Sequence:create(cc.EaseOut:create(cc.MoveBy:create(0.1,cc.p(0, 10)), 0.3));
        else
            ac3 = cc.Sequence:create(cc.EaseOut:create(cc.MoveBy:create(0.1,cc.p(0, 10)), 0.3), cc.CallFunc:create(callFun));
        end
        node:runAction(ac3);
    end

    local ac = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.2,cc.p(0, - winSizeHeight - 10)), 0.3), cc.CallFunc:create(action2));
    uiNode:runAction(ac);
end

-- ui消失
function UIAction:UIDisappear(uiNode, actionType, callFun)
    local winSizeHeight = MainValue.winSize.height;
    
    local disAc1 = nil;
    local disAc2 = nil;
    
    if actionType == PanelDisappearType.LEAVE_DOWN then
        local function action2(node)
            node:stopAllActions() --After this stop next action not working, if remove this stop everything is working
            disAc2 = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.25,cc.p(0, -winSizeHeight - 15)), 0.8),cc.CallFunc:create(callFun));
            node:runAction(disAc2);
        end

        disAc1 = cc.Sequence:create(cc.EaseOut:create(cc.MoveBy:create(0.15,cc.p(0, 15)), 0.6),cc.CallFunc:create(action2));
        uiNode:runAction(disAc1); 
        
    elseif actionType == PanelDisappearType.LEAVE_UP then
        disAc1 = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.15,cc.p(0, winSizeHeight)), 0.8),cc.CallFunc:create(callFun));
        uiNode:runAction(disAc1);
    end
end

return UIAction;