-- 九宫格工具
ThreeLMRGridTools = class("ThreeLMRGridTools",function ()
    return cc.Layer:create();
end)

function ThreeLMRGridTools:ctor(imgUrl,w,cellSize)
    self.endPic= cc.Layer:create();
    --    self.endPic:setContentSize(w,h)

    --    根据路径先得到原图
    self.srcimg = cc.Sprite:createWithSpriteFrameName(imgUrl)

    local signX = self.srcimg:getTextureRect().x --实际代表大图中的 x方向坐标   !!!!如果打入 plist需要这个修正值
    local signY = self.srcimg:getTextureRect().y --实际代表大图中的y方向 坐标  !!!!如果打入 plist需要这个修正值
    
    self.srcImgWidth=self.srcimg:getContentSize().width
    self.srcImgHeight=self.srcimg:getContentSize().height



    self.srcImgTextures=self.srcimg:getTexture()

    --1
    self.leftImg=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX,signY,cellSize,self.srcImgHeight))

    --2
    self.midImg =cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX + cellSize,signY,self.srcImgWidth-2*cellSize,self.srcImgHeight))
    self.midImg:setScaleX((w-2*cellSize)/(self.srcImgWidth-2*cellSize))    
    --3    
    self.rightImg=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX + self.srcImgWidth-cellSize,signY,cellSize,self.srcImgHeight))


    --1 2 3

    --    其实坐标  x为0的应该是   cellSize/2  才是完整的0 0左下角 位置

    --1
    local leftImgX = cellSize/2
    local leftImgY = cellSize/2+cellSize/2
    self.leftImg:setPosition(cc.p(leftImgX,leftImgY))
    self.endPic:addChild(self.leftImg)
    --2

    local midImgX= cellSize/2+cellSize/2+ (w-2*cellSize)/2    
    local midImgY = cellSize/2+cellSize/2

    self.midImg:setPosition(cc.p(midImgX,midImgY))
    self.endPic:addChild(self.midImg)
    --3
    local rightImgX=cellSize/2+ w- cellSize 
    local rightImgY=cellSize/2+cellSize/2
    self.rightImg:setPosition(cc.p(rightImgX,rightImgY))
    self.endPic:addChild(self.rightImg)

    self.endPic:setPosition(-w/2,-cellSize/2)

    self:addChild(self.endPic)
    self.srcImgTextures:release()
    self.srcImgTextures:retain()
    return self
end

function ThreeLMRGridTools.create(imgUrl,w,cellSize)
    local endImg = ThreeLMRGridTools.new(imgUrl,w,cellSize)    
    return endImg
end