require("ftue.ftue.ftuefactory.FtueAssets")
require("ftue.ftue.ftuefactory.FtueBackGround")
require("ftue.ftue.ftuefactory.FtueDialogue")
require("ftue.ftue.ftuefactory.FtueItem")

local ftueRootLayer = nil

--local ftueAssets = nil
local layer = cc.Sprite:create()
local SWITCH_TIME = 0.2 --is number
local ftueCallback = nil --is function
--local mouseSp = nil
local ftueItemConfigs = nil

local Ftue = class("Ftue", function()
    ftueRootLayer = cc.Layer:create()
    ftueRootLayer:setAnchorPoint(0.5,0.5);
    ftueRootLayer:setPosition(MainValue.winSize.width * 0.5,MainValue.winSize.height * 0.5)
    return ftueRootLayer
end)

--require("Hero").new()


function Ftue:ctor()   
    self.ftueAssets = nil
    ftueRootLayer:addChild(layer)
    self.rowNum = 0
    self.colNum = 0   
    self.touchTirgger = false
    self.currentFuteItem = nil
--    print(type(ftueRootLayer))

    self.canTouchForDelay = true; --有  Delay的FTUE 暂时不可以点击
    
    ftueItemConfigs = {}  --ftueItemConfigs = new Dictionary();
    
    self.tempFtueArrary = {} --tempFtueArrary = new Array();

    self.color4B = cc.c4b(153,153,153,10)  -- ccDrawColor4B(255,0,0,0)        100 可以设置透明度
        
    
--    self.mouseSp:setAnchorPoint(self.mouseSp:getContentSize().width*0.5,self.mouseSp:getContentSize().height*0.5)
--        mouseSp:setAnchorPoint(0.5,0.5) -- no eft
    
--    ftueRootLayer:ignoreAnchorPointForPosition(true);  
   
    
    
--    mouseSp = new Quad(MainValue.GAME_WIDTH, MainValue.GAME_HEIGHT, 0);
--    mouseSp.alpha = 0;


    self:init()    
    
    local ftueDataP = require("ftue.ftue.FtueData")
    
    self.ftueData = ftueDataP.new();  
    
end




function Ftue:getFtueAssets()
    return self.ftueAssets
end

function Ftue:init()

--    self.upLayer = cc.Layer:create();
--    self.downLayer = cc.Layer:create();
--    self.shadeLayer = cc.Layer:create();
    
--    ftueRootLayer:addChild(self.shadeLayer)--添加阴影层
--    ftueRootLayer:addChild(self.downLayer)--可以操控层
--    ftueRootLayer:addChild(self.upLayer)--视图展示层


    self.ftueAssets = FtueAssets.new()
    
    self.ftueAssets:initTexture()

    self.dialogSp = FtueDialogue.new()
    self.dialogSp:retain()
    
    local function onTouchBgBegan(touch, event)
        
        if touch == nil or event == nil then
            return false
        end
        
        if self.currentID == -1 then
            return false
        end
        
        
        if self.currentFuteItem~=nil and self.currentFuteItem['trigger'] then --trigger 0是随便点击  1是指定位置
    --        如果在矩形区域返回false 可以操作
    --        如果不在就返回true 不可以操作
    
            local locationInNode = self.ftueBackGround:convertToNodeSpace(touch:getLocation())
            local clickRectContainsPoint = false
            
            local digHoleRectAry = self.ftueBackGround:getDigHoleRectAry()
            
            if digHoleRectAry ~= nil then --针对不是other的rect处理碰撞检测区域定义是否穿透
                local digHoleRectAryNew = {}
                for i = 1,#(digHoleRectAry)do
                    local tmpRec = cc.rect(digHoleRectAry[i].x - digHoleRectAry[i].width * 0.5,digHoleRectAry[i].y - digHoleRectAry[i].height * 0.5,digHoleRectAry[i].width,digHoleRectAry[i].height)            
                    table.insert(digHoleRectAryNew,tmpRec)
                end  
                for rectI = 1,#(digHoleRectAryNew) do
                    local rect = digHoleRectAryNew[rectI]
                    if cc.rectContainsPoint(rect, locationInNode) then
--                        print("可以点击1111111111111111111locationInNode".."locationInNode::x::"..locationInNode.x.."::locationInNode.y::"..locationInNode.y)
                        clickRectContainsPoint = true 
                        break                    
                    end
                end  
                
            else
                
    --            针对other类型生效 start
                local digHoleOtherRectAry = self.ftueBackGround:getDigHoleOtherAry()          
                  
                local endShapPst = self.ftueBackGround:getEndShapePos() --  只针对other类型有效  得到方向和操作参照点坐标 ！！！！！！！
                               
                local tmpX = endShapPst.x  - MainValue.winSize.width * 0.5
                local tmpY = endShapPst.y  - MainValue.winSize.height * 0.5 
                
                local digHoleOtherRectAryNew = {}  
                for i = 1,#(digHoleOtherRectAry)do
--                    local tmpRec = cc.rect(tmpX + digHoleOtherRectAry[i].x - 20,tmpY + digHoleOtherRectAry[i].y - 20 + 25,digHoleOtherRectAry[i].width,digHoleOtherRectAry[i].height)        	
                    local tmpRec = cc.rect(tmpX + digHoleOtherRectAry[i].x,tmpY + digHoleOtherRectAry[i].y,digHoleOtherRectAry[i].width,digHoleOtherRectAry[i].height)
                	table.insert(digHoleOtherRectAryNew,tmpRec)
                end  
                
--                print("可以点击测试22222222222222222222locationInNode".."locationInNode::x::"..locationInNode.x.."::locationInNode.y::"..locationInNode.y)
               
                for rectI = 1,#(digHoleOtherRectAryNew) do
                    local rect = digHoleOtherRectAryNew[rectI]
                    if cc.rectContainsPoint(rect, locationInNode) then
--                         print("可以点击22222222222222222222locationInNode".."locationInNode::x::"..locationInNode.x.."::locationInNode.y::"..locationInNode.y)
                         clickRectContainsPoint = true   
                         break                  
                    end
                end  
    --            针对other类型生效 end     
            
            end
            
           
           if clickRectContainsPoint then
                self.ftueLayerEventListener:setSwallowTouches(false);
           else
                self.ftueLayerEventListener:setSwallowTouches(true);
           end
           
       else
        --        trigger = false  的处理 允许点击
       end 
       
       self.touchTirgger = true       
       return true
    end
        
    local function onTouchBgMoved(touch, event)
        if self.currentFuteItem~=nil and self.currentFuteItem['trigger'] then
        
            --        print(digHoleOtherRectAryNew)        
            local locationInNode = self.ftueBackGround:convertToNodeSpace(touch:getLocation())
            --        local rect = cc.rect(target:getPositionX()-(s.width/2), 7, s.width, s.height);
            local clickRectContainsPoint = false
        
            --        如果在矩形区域返回false 可以操作
            --        如果不在就返回true 不可以操作
            
             local digHoleRectAry = self.ftueBackGround:getDigHoleRectAry()
            
            if digHoleRectAry ~= nil then --针对不是other的rect处理碰撞检测区域定义是否穿透
                local digHoleRectAryNew = {}
                for i = 1,#(digHoleRectAry)do
                    local tmpRec = cc.rect(digHoleRectAry[i].x - digHoleRectAry[i].width * 0.5,digHoleRectAry[i].y - digHoleRectAry[i].height * 0.5,digHoleRectAry[i].width,digHoleRectAry[i].height)            
                    table.insert(digHoleRectAryNew,tmpRec)
                end  
                for rectI = 1,#(digHoleRectAryNew) do
                    local rect = digHoleRectAryNew[rectI]
                    if cc.rectContainsPoint(rect, locationInNode) then
                        --                print("可以点击locationInNode".."locationInNode::x::"..locationInNode.x.."::locationInNode.y::"..locationInNode.y)
                        clickRectContainsPoint = true
                        break                     
                    end
                end  
                
            else
            
                local digHoleOtherRectAry = self.ftueBackGround:getDigHoleOtherAry()                   
                local endShapPst = self.ftueBackGround:getEndShapePos()        
                local tmpX = endShapPst.x - MainValue.winSize.width * 0.5
                local tmpY = endShapPst.y - MainValue.winSize.height * 0.5
                
                local digHoleOtherRectAryNew = {}              
                for i = 1,#(digHoleOtherRectAry)do
                    local tmpRec = cc.rect(tmpX + digHoleOtherRectAry[i].x,tmpY + digHoleOtherRectAry[i].y,digHoleOtherRectAry[i].width,digHoleOtherRectAry[i].height)            
                    table.insert(digHoleOtherRectAryNew,tmpRec)
                end 
                for rectI = 1,#(digHoleOtherRectAryNew) do
                    local rect = digHoleOtherRectAryNew[rectI]
                    if cc.rectContainsPoint(rect, locationInNode) then
--                print("可以点击3333333333333333333333333locationInNode".."locationInNode::x::"..locationInNode.x.."::locationInNode.y::"..locationInNode.y)
                        clickRectContainsPoint = true                     
                    end
                end 
            
            end
             
            
            if clickRectContainsPoint then
--            print("掠过了区域1111111111111")
                self.ftueLayerEventListener:setSwallowTouches(false);
            else
--            print("掠过了区域2222222222222222222222")
                self.ftueLayerEventListener:setSwallowTouches(true);
            end
        
        else
--        trigger = false  的处理 允许点击
        
        end
        
    end
    
   local function  onTouchBgCancled(touch, event)
        self.touchTirgger = false
   end
   
   local function onTouchBgEnded(touch, event)
--        print("Ftue 点击了ftue")
        if self.touchTirgger then
  
--            if( (!currentFute.trigger) && (currentFute.delay_close > 0) )
--            {
--                disableMouseTouch = true;
--                runAction( CCSequence::createWithTwoActions( CCDelayTime::create( currentFute.delay_close ) , CocosUtil::createCallFunction( [this]()
--                {
--                    disableMouseTouch = false;
--                    FTUEManagerBase::Shared().removeFtue();
--                } ) ) );
--            }
--            else
--            {
--                self:removeFtue()
--            }

            if not self.canTouchForDelay then
                return;
            end
            
            if self.currentFuteItem~=nil and self.currentFuteItem:getTrigger() then
--                self:removeFtue() --暂时测试启用！！！！！！！！！
            else
                self:removeFtue()
            end
        end
        self.touchTirgger = false;
    end
    
    
    
    self.ftueLayerEventListener = cc.EventListenerTouchOneByOne:create();
    
    self.ftueLayerEventListener:setSwallowTouches(true);
    
    self.ftueLayerEventListener:registerScriptHandler(onTouchBgBegan,cc.Handler.EVENT_TOUCH_BEGAN );
    self.ftueLayerEventListener:registerScriptHandler(onTouchBgMoved,cc.Handler.EVENT_TOUCH_MOVED );
    self.ftueLayerEventListener:registerScriptHandler(onTouchBgEnded,cc.Handler.EVENT_TOUCH_ENDED );
    self.ftueLayerEventListener:registerScriptHandler(onTouchBgCancled,cc.Handler.EVENT_TOUCH_CANCELLED );
    
    
    self.eventDispatcher = self:getEventDispatcher();
    self.eventDispatcher:addEventListenerWithSceneGraphPriority(self.ftueLayerEventListener, self);
    
    

    --    对应的颜色层
    
    --    local color4B =cc.c4b(255,0,0,100)-- ccDrawColor4B(255,0,0,0)        
    --    local layerColor = cc.LayerColor:create(color4B,300,300)
    
    --    bgSp = new FtueBackGround();
    --    bgSp.setGameSize(MainValue.GAME_WIDTH, MainValue.GAME_HEIGHT);
    --    
    --    dialogSp = new FtueDialogue();
    --   
    --    
    --    layer.addEventListener(TouchEvent.TOUCH, onTouch);            
end




function Ftue:setFtueOffset(xOff, yOff)
    self.ftueBackGround:setOtherOffset(xOff, yOff)
--  bgSp.setOtherOffset(xOff, yOff);
end

--TODO:::
function Ftue:isFtuePlayedByIndex(ftueId)
--    if(MainValue.mxDataManager.user.getFtueArray().indexOf(ftueId)==-1)   --要打开的
--        return true;
--    else 
--        return false;
    return false
end

--function Ftue:setFtueData(xmlData)


function Ftue:setTargetConfig(rowNum,colNum)
    self.rowNum = rowNum --!!!行数 需要告诉我几行几列
    self.colNum = colNum --!!!列数 self.talkWord
end


function Ftue:setFtueData()
    
--($xml:XML):void
    local items = MainValue.infosManager:getObjFtueAll() 
     --var items:XMLList = $xml.children();
    self.itemsIndex = 0
    for key in pairs(items) do
       
        self.itemsIndex = self.itemsIndex + 1
        local ftueItemConfig = FtueItem.new()
        
        ftueItemConfig:setId(items[key]['id'])
        
--        print("Ftue.lua --------FtueId-----:::"..tostring(ftueItemConfig:getId()))
--        
--        if tostring(ftueItemConfig:getId()) == "71" then
--            print("---")
--        end
        
        ftueItemConfig:setLevel(items[key]['level'])
        ftueItemConfig:setTrigger(items[key]['trigger']=="1")--//0--false随便点击  1--true 有条件的
        ftueItemConfig:setOut(items[key]['out']=="1")--//0--false 1--true
        ftueItemConfig:setCon(items[key]['con']=="1")--//0--false 1--true
        ftueItemConfig:setDelay(tonumber(items[key]['delay']))
        ftueItemConfig:setDelayClose(tonumber(items[key]['delayClose']))
        
        
        
        
        local layer1 = items[key]['layer'][1] 
        
        if layer1['postp']~=nil then
            ftueItemConfig:setPostp(tonumber(layer1['postp']))-- 4 表示基于center 位置矫正时用到 
        else
            ftueItemConfig:setPostp(-1)-- 4 表示基于center
        end
        
        ftueItemConfig:setDialogue(layer1['dialogue'],layer1['petPos'], layer1['petName'], layer1['text'])
        
        if layer1['arrow'] ~= nil then
            ftueItemConfig:setArrow(layer1['arrow'])
        end
        
        
        if layer1['switchArrow'] ~= nil then
            ftueItemConfig:setSwitchArrow(layer1['switchArrow'])   
        end
        
--      ftueItemConfig:setFtueVideo(layer1.@video, layer1.@text, new Point(205, 55)); --TODO:::

        local tp = tonumber(layer1['tp'])
        if tp == 1 then
            ftueItemConfig:setFtueShape(tp, layer1['circles'])
        elseif tp == 2 then
            ftueItemConfig:setFtueShape(tp, layer1['rects'])
        elseif tp == 3 then
            ftueItemConfig:setFtueShape(tp, layer1['ellipses'])
        elseif tp == 5 then
            ftueItemConfig:setFtueShape(tp, layer1['others'],layer1['operatedots'])
        else
            ftueItemConfig:setFtueShape(tp, nil);
        end   
             
        if self.itemsIndex == table.maxn(items) then 
            ftueItemConfig:setIsLast(true)
        end
--      ftueItemConfigs[ftueItemConfig.id+""] = ftueItemConfig;

       
        ftueItemConfigs[tostring(ftueItemConfig:getId())] = ftueItemConfig 
     end
     
    print("Ftue---::all ftueData init complete")
end






function Ftue:showFtueById(ftueId)
--    if ( $ftueId < 1 || hasFtue() || !isMouseEnable() ) return;
    self.ftueLayerEventListener:setSwallowTouches(true)
    self.ftueBackGround = FtueBackGround.new()
    self.ftueBackGround:setGameSize(MainValue.winSize.width,MainValue.winSize.height)
    self.ftueBackGround:retain();

    self.mouseSp = cc.LayerColor:create(self.color4B,MainValue.winSize.width , MainValue.winSize.height) --TODO 游戏的的尺寸    
    self.mouseSp:setPosition( - MainValue.winSize.width * 0.5,- MainValue.winSize.height * 0.5)
    ftueRootLayer:addChild(self.mouseSp)
    
    if ftueId < 0 then 
        return
    elseif self:hasFtue() then
        return 
    elseif self:isMouseEnable() then
        return
    end
    if self.ftueArray == nil then
        self.ftueArray = {} -- MainValue.dataManager:getFtue -- MainValue.mxDataManager.user.getFtueArray(); --TODO:::得到当前存放 ftueid的数组 表
    end
--    if (ftueArray == null)
--    {
--        ftueArray = MainValue.mxDataManager.user.getFtueArray();
--    }
    local condition = false --var condition:Boolean;
    self.currentFuteItem = ftueItemConfigs[tostring(ftueId)]  --var item:FtueItem = ftueItemConfigs[$ftueId + ""] as FtueItem;
    
--    if (item.out) condition = (ftueArray.indexOf($ftueId) == -1);
--    else condition = (MainValue.mxDataManager.user.getMaxLevel() <= item.level) && (tempFtueArrary.indexOf($ftueId) == -1);
    if self.currentFuteItem ~= nil and self.currentFuteItem['out'] then
        condition = true
--            condition = (ftueArray.indexOf($ftueId) == -1) --TODO:::
    else
        condition = true
--         condition = (MainValue.mxDataManager.user.getMaxLevel() <= item.level) && (tempFtueArrary.indexOf($ftueId) == -1); --TODO:::
    end
    
    
    if condition then
        self.currentID = ftueId
--        local curConfig = ftueItemConfigs[tostring(self.currentID)]
--      showVideo( curConfig ); --TODO:::

--        self:showBg(self.currentFuteItem)
--        self:showDialogue(self.currentFuteItem)
--        self:addMouseSp(true)
        
        if self.currentFuteItem.delay ~=nil and self.currentFuteItem.delay > 0 then
            --      TweenLite.delayedCall(curConfig.delay, delayComplete); --TODO:::
            
            self.canTouchForDelay = false;
            local function complete()
                self:delayComplete();
            end
            self:runAction(cc.Sequence:create(cc.DelayTime:create(self.currentFuteItem.delay),cc.CallFunc:create(complete)));
        else
            self:delayComplete();
        end
    else
        self.currentID = 0
    end
    
--    if (condition)
--    {
--        self.currentID = $ftueId;
--        
--        var curConfig:FtueItem = ftueItemConfigs[currentID + ""];
--        showBG( curConfig );
--        showDialogue( curConfig );
--        showVideo( curConfig );
--        
--        addMouseSp(true);
--        TweenLite.delayedCall(curConfig.delay, delayComplete);
--    }
--    else
--    {
--        //trace( "[FtueManager] ftue " + $ftueId +" has been triggered");
--        currentID = 0;
--    }

--[[
    local ftueCellDataObj = self.ftueData:getFtueConfigByFtueId(ftueId)
    
	if ftueCellDataObj~=nil then
	
	   self.id = ftueCellDataObj:getId()
       self.level = ftueCellDataObj:getLevel()
       self.con = ftueCellDataObj:getCon()
       self.trigger = ftueCellDataObj:getTrigger()
       self.out = ftueCellDataObj:getOut()
       self.layer = ftueCellDataObj:getLayer()
        
	end
--]]
   
	
end

function Ftue:addCallback(callFunPar)
    ftueCallback = callFunPar
end

function Ftue:delayComplete()
--    TweenLite.to(self.ftueBackGround, SWITCH_TIME, {alpha:1});
--    TweenLite.to(self.dialogSp, SWITCH_TIME, {alpha:1, onComplete:controlFtueEnd});

    self.canTouchForDelay = true;

    self:showBg(self.currentFuteItem)
    self:showDialogue(self.currentFuteItem)
    self:addMouseSp(true)
    
--    self:controlFtueEnd()
end
function Ftue:controlFtueEnd()
    self:addMouseSp(false)
end

function Ftue:showBg(currentFuteItemPar)

    self.ftueBackGround:setBackGround(currentFuteItemPar,self.rowNum,self.colNum);    
    self.ftueBackGround:setPosition(- MainValue.winSize.width *0.5,- MainValue.winSize.height *0.5)   
    ftueRootLayer:addChild(self.ftueBackGround)
    self.ftueBackGround:release();
end

function Ftue:showDialogue(currentFuteItemPar)
    self.dialogSp:setDialogue(currentFuteItemPar);
--            dialogSp.alpha = 0;

    self.dialogSp:setAnchorPoint(0.5,0.5);
    self.dialogSp:setPosition(- MainValue.winSize.width *0.5,- MainValue.winSize.height *0.5)
    ftueRootLayer:addChild(self.dialogSp);-- 2014-11-21 暂时注掉
    
end


function Ftue:addMouseSp(flag)
    if flag  and self.mouseSp == nil then
        self.mouseSp = cc.LayerColor:create(self.color4B,MainValue.winSize.width , MainValue.winSize.height) --TODO 游戏的的尺寸    
        self.mouseSp:setPosition( - MainValue.winSize.width * 0.5,- MainValue.winSize.height * 0.5)
        ftueRootLayer:addChild(self.mouseSp)
    elseif not flag then
        if self.mouseSp:getParent()~=nil then
            self.mouseSp:getParent():removeChild(self.mouseSp)
            self.mouseSp = nil
        end
    end
--    if (flag)
--    {
--        layer.addChild(mouseSp);
--    }
--    else
--    {
--        if (mouseSp.parent)
--            layer.removeChild(mouseSp);
--    }
end

function Ftue:removeFtue()
    self.touchTirgger = false
    if not self:hasFtue() then
        return
    elseif self:isMouseEnable() then
        return
    end
--    if( !hasFtue() || !isMouseEnable()) return;
    
    self:addMouseSp(true);
    
--    local curConfig = ftueItemConfigs[tostring(self.currentID)];
    
--    TweenLite.delayedCall(curConfig.delayClose, delayCloseComplete);
    self:delayCloseComplete()
end
function Ftue:delayCloseComplete()
--    TweenLite.to(self.ftueBackGround, SWITCH_TIME, {alpha:0});--TODO:::
--    TweenLite.to(dialogSp, SWITCH_TIME, {alpha:0, onComplete:removeFtueEnd});
   self:removeFtueEnd()
end


function Ftue:removeFtueEnd()

    self:addMouseSp(false)
    self:hideBG()
    self:hideDialogue()
    
--    Ftue:hideVideo(); --TODO:::
   
     
--    tempFtueArrary.push(currentID)
    table.insert(self.tempFtueArrary,self.currentID)
    table.insert(self.ftueArray,self.currentID)
--    ftueArray.push(currentID);
--    MsgSender.sendFtue(currentID); --TODO::
    
--    MainValue.manWebpage.ftueFinish();
--    
--    StatisticsManager.oneFtueComplete(currentID);
    
    local tempID =  self.currentID --  var tempID:int = currentID;//如果不是同一关可能有问题
    self.currentID = -1;  
    self:addNextFtue( tempID )
end

function Ftue:addNextFtue(curId)

    self.currentFuteItem = ftueItemConfigs[tostring(curId)]     -- var curConfig:FtueItem = ftueItemConfigs[$curId + ""];
    
    if not self.currentFuteItem:getIsLast() and self.currentFuteItem:getCon()  then
        MainValue.mxFTUEManager:addFtue()
        self:showFtueById(curId + 1)
    elseif ftueCallback ~=nil then 
        ftueCallback()
    end
    
--    if(!curConfig.isLast && curConfig.con)
--    {       
--        showFtueById($curId + 1);
--    }
--    else if (ftueCallback != null)
--    {
--        ftueCallback.apply();
--        ftueCallback = null;
--    }    
end



function Ftue:hideBG()
    if self.ftueBackGround ~= nil and self.ftueBackGround:getParent() ~= nil then
--            self.ftueBackGround:clear()
            self.ftueBackGround:getParent():removeChild(self.ftueBackGround)
            self.ftueBackGround = nil
    end
end

function Ftue:hideDialogue()
    if self.dialogSp ~= nil and self.dialogSp:getParent() ~= nil then
        self.dialogSp:getParent():removeChild(self.dialogSp)
    end
end


function Ftue:hasFtue()
    
    return (self.currentID ~= nil and self.currentID ~= -1)
end

function Ftue:isMouseEnable()
    if self.mouseSp ~= nil and self.mouseSp:getParent() ~= nil then
        return false
    else
        return true
    end    
end

--@param swapPstAry 根据当前交换的坐标来判断是否允许交换  2015-1-13
function Ftue:isAllowSwapByFtue(swapPstAry)
    return self.ftueBackGround:isAllowSwapByFtue(swapPstAry)
end

--public function onWorldTimerRunHandler(spendTimes:Number):void
--{
--    //if (ftueVideoPlayer) ftueVideoBg.onWorldTimerRunHandler(spendTimes);
--    if (dialogSp) dialogSp.onWorldTimerRunHandler(spendTimes);
--}


return Ftue