CocosUtil = class("CocosUtil");


function CocosUtil:extractGrid9( txture, origin, grid )
    --裁切宽度
    local left = grid.x;
    local top = grid.y;
    local right = origin.width - grid.x - grid.width;
    local bottom = origin.height - grid.y - grid.height;

    local ret = {};
    --top left
    table.insert(ret,cc.SpriteFrame:createWithTexture(txture,cc.rect(
            origin.x
            , origin.y
            , left
            , top ) ) );

    --top
    table.insert(ret,cc.SpriteFrame:createWithTexture(txture,cc.rect(
            origin.x + left
            , origin.y
            , origin.width - left - right
            , top ) ) );

    --top right
    table.insert(ret,cc.SpriteFrame:createWithTexture(txture,cc.rect(
            origin.x + origin.width - left
            , origin.y
            , right
            , top ) ) );

    -- left
    table.insert(ret,cc.SpriteFrame:createWithTexture(txture,cc.rect(
            origin.x
            , origin.y + top
            , left
            , origin.height - top - bottom ) ) );

    --center
    table.insert(ret,cc.SpriteFrame:createWithTexture(txture,cc.rect(
            origin.x + left
            , origin.y + top
            , origin.width - left - right
            , origin.height - top - bottom ) ) );

    --right
    table.insert(ret,cc.SpriteFrame:createWithTexture(txture,cc.rect(
            origin.x + origin.width - left
            , origin.y + top
            , right
            , origin.height - top - bottom ) ) );

    -- bottom left
    table.insert(ret,cc.SpriteFrame:createWithTexture(txture,cc.rect(
            origin.x
            , origin.height + origin.y - bottom
            , left
            , bottom ) ) );

   --bottom
   table.insert(ret,cc.SpriteFrame:createWithTexture(txture,cc.rect(
            origin.x + left
            , origin.height + origin.y - bottom
            , origin.width - left - right
            , bottom ) ) );

    --bottom right
    table.insert(ret,cc.SpriteFrame:createWithTexture(txture,cc.rect(
            origin.x + origin.width - left
            , origin.height + origin.y - bottom
            , right
            , top ) ) );

    return ret;
end