local IAPEnManager = class("IAPEnManager");
local instance = nil;
local isBuying = false;  

local Idol = 0;--开始
local Forbidden = 1;--不支持内购
local Loading = 2;--正在通信
local Done = 3;--完成
local Failed = 4;--失败
local Cancelled = 5;--取消

local Restored = 6;--未用到
local NotFound = 7;--没找到商品   

function IAPEnManager:ctor()



    -----------------------------------------------------------
    local iosAppId = "0015581225b7b095"; --todo:::
    local iosVerifyServer = "http://payval-mobile.6waves.com/verify.php";
    local gpAppId = "0035581217694ee7";
    local gpVerifyServer = "http://payval-mobile.6waves.com/gp_verify.php";

    StoreLuaInit(iosAppId, iosVerifyServer, gpAppId, gpVerifyServer, self.onBuyStatusHandler);
end

function IAPEnManager:buy(storeId)
    cclog("IAPbuy! storeId = "..storeId)
    -- storeId = "com.sixwaves.sundaesmash.gp.goods"..storeId
    --    local net = self:getNetwork();
    --    if net == "none" then
    --        PlatformLuaShowNativePopDialog("","please check your net!","ok","");
    --    else 
    --加上遮罩
    MainValue.mxLoadingManager:addLoading();

    local targetPlatform = cc.Application:getInstance():getTargetPlatform()
    if targetPlatform == cc.PLATFORM_OS_IPHONE or targetPlatform == cc.PLATFORM_OS_IPAD  then
        storeId = "com.6waves.oz.goods"..storeId;
    --storeId = "com.smartron5.woo.goods"..storeId; --临时dev测试内购逻辑调试用
    elseif targetPlatform == cc.PLATFORM_OS_ANDROID then
        storeId = "com.sixwaves.woo.gp.goods"..storeId; --临时
    end;

    -- storeId = "com.6waves.sundaesmash.1";
    --com.6waves.sundaesmash1-6
    isBuying = true;
    StoreLuaBuy(storeId);
--    end;
end

function IAPEnManager:callBackOnBuyStatusHandler(status, statusVerify, storeId, index)


    local tmpStoreId = storeId

    print("IAPEnManager:callBackOnBuyStatusHandler ------------------")
    print("IAPEnManager:callBackOnBuyStatusHandler --------status----------"..status)
    if statusVerify~=nil  then
        print("IAPEnManager:callBackOnBuyStatusHandler --------statusVerify----------"..tostring(statusVerify))
    end
    print("IAPEnManager:callBackOnBuyStatusHandler --------storeId----------"..storeId)
    print("IAPEnManager:callBackOnBuyStatusHandler --------index----------"..index)

    --    local goodObject = MainValue.dataManager.storeManager:getStartPackageObjectByID(storeId)
    --    
    --    for i in pairs(goodObject) do
    --        MainValue.dataManager.goodsManager:addGoods(goodObject[i].id,tonumber(goodObject[i].num))
    --    end

    --    MainValue.mxAlertManager:addShowText("asdd jlasdh ash l hlasdf ")

    if isBuying then
    --        print("IAPEnManager:callBackOnBuyStatusHandler --------isBuying------true----")
    else
    --        print("IAPEnManager:callBackOnBuyStatusHandler --------isBuying------false----")
    end

    if not isBuying then
        return
    end;
    --     MainValue.mxAlertManager:addShowText("asdd jlasdh ash l hlasdf10000 ")

    if tonumber(statusVerify) == 0 then
        --    如果当前平台是android
        print("IAPEnManager:callBackOnBuyStatusHandler ------Error The product does not exist.")
    end

    --    print("购买购买购买购买购买购买购买购买购买购买购买购买--------")
    local function showBuyFailed()
        MainValue.mxLoadingManager:removeLoading();

        PlatformLuaShowNativePopDialog("","purchase failed!","ok");  -- ??????????????
        isBuying = false;
    end;

    local function showBuyDone(storeId)
        --        print("购买完成")
        MainValue.mxLoadingManager:removeLoading();


        local splitStr = "s"
        local strArr = lua_string_split(tmpStoreId,splitStr);
        local length = table.maxn(strArr);
        tmpStoreId =  tonumber(strArr[length])

        if tmpStoreId == 6 then --首充礼包的处理
            --              MainValue.mxAlertManager:addShowText(tostring(tmpStoreId).."11111111")
            local goodObject = MainValue.dataManager.storeManager:getStartPackageObjectByID(tmpStoreId)

            for i in pairs(goodObject) do
                --            MainValue.mxAlertManager:addShowText(tostring(tmpStoreId).."111111122")
                MainValue.dataManager.goodsManager:addGoods(tonumber(goodObject[i].id),tonumber(goodObject[i].num))

            end


            MainValue.dataManager.expandManager:setHasBuyStartPackage();--保存服务器已购买
            MainValue.mxUIManager.mapUI:removeStartPackageIcon();--隐藏首充礼包图标
        else
            local cashObject = MainValue.dataManager.storeManager:getStoreObjectByStoreID(storeId);
            MainValue.dataManager.storeManager:buyStoreObjectSuccess(storeId);
        --  PlatformLuaShowNativePopDialog("purchase success","you got "..tonumber(cashObject.cash).." coins", "ok");
        end


        isBuying = false;
    end;

    --    print("111111111111111111111111111111111111111111---Done-----"..Done)
    if tonumber(statusVerify) == Done then
    --        print("111111111111111111111111111111111111111111--------")
    else
    --        print("22222222222222222222222222222222--------")
    end

    --statusVerify  非商店验证状态(优先判断)
    --status        商店验证状态
    -- MainValue.storeManager:buyStatusBack(result.storeId, result.statusVerify);
    --    print("购买购买购买购买购买购买购买购买购买购买购买购买110--------")
    if tonumber(statusVerify) == Failed then  
        --        print("购买失败112")
        showBuyFailed();
        return;
    elseif tonumber(statusVerify) == Done then
        --        print("购买完成111")
        showBuyDone(storeId);
        return;
    end;



    if status == Forbidden then
        --   PlatformLuaShowNativePopDialog("","purchase Forbidden!","ok","");
        showBuyFailed();
    --        print("购买Forbidden--------")
    elseif status == Loading then

    elseif status == Done then
    --        print("购买完成--------")
    --        showBuyDone(storeId)

    elseif status == Failed then
        --  PlatformLuaShowNativePopDialog("","purchase Failed!","ok","");
        --        print("购买失败--------")
        showBuyFailed();

    elseif status == Cancelled then
        --        print("取消购买--------")
        showBuyFailed();
    elseif status == NotFound then
        --  PlatformLuaShowNativePopDialog("","purchase NotFound!","ok","");
        --        print("购买NotFound--------")
        showBuyFailed();

    end;
end

function IAPEnManager.onBuyStatusHandler(status, statusVerify, storeId, index)
    -- cclog("IAP_EN onBuyStatusHandler = buyStatus:"..status.." statusVerify:"..statusVerify.." storeId:"..storeId.." index:"..index)
    IAPEnManager:callBackOnBuyStatusHandler(status, statusVerify, storeId, index)
end

function IAPEnManager.create()
    local temp = IAPEnManager.new()
    return temp
end

return IAPEnManager;