local PlatformManager = class("PlatformManager");


function PlatformManager:ctor()
    --self.readPermissions = ;
    
      
end

function PlatformManager:FBinviteDialog(title, messages)
    cclog("PlatformManager:FBinviteDialog");
--    PlatformLuaFBinviteDialog(title, messages);  ????????????? C++端没有了
end

function PlatformManager:FBloadImage(id, path, sprite, callBackFun)
--测试
    print("show load imager 110")
--    path = "https://fbcdn-profile-a.akamaihd.net/hprofile-ak-xfa1/v/t1.0-1/p100x100/10402627_1451671878420239_6942083990566733531_n.jpg?oh=a6050fb646eea8d121f45ac45e266fc3&oe=56350BD3&__gda__=1445256607_8f395976aef43e1995d88eae2629c696"
      local xhr = cc.XMLHttpRequest:new()
      xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_STRING
      xhr:open("GET", path)
      
      local function onResponse()
          if xhr.readyState == 4 and (xhr.status >= 200 and xhr.status < 207) then
--              local fp = io.open(id .. "'s head", "rb+")


               local src = DataConfig.tmpPath --.. "_temp" --DataConfig.tmpPath .. DataConfig.gameName .. "_temp"
              if device.platform == "windows" then
                  os.execute("md ".. string.gsub(src, '/', '\\'))
              else
                  os.execute("md -p " .. path)
              end
              src = src .. "/"
              local fp = io.open(src .. id .. "_head", "wb+")
              if fp ~= nil then
--                  fp = io.open(id .. "'s head", "wb+")
                  fp:write(xhr.response)
                  fp:close()  
              end
              
              local pic = cc.Image:new()
              if pic:initWithImageFile(src .. id .. "_head") then
--                  print(pic:getWidth(), pic:getHeight())
                  local texture = cc.Texture2D:new()
                  texture:initWithImage(pic)
                  local sp = cc.Sprite:createWithTexture(texture)
                  sp:setScaleX(sprite:getContentSize().width / pic:getWidth())
                  sp:setScaleY(sprite:getContentSize().height / pic:getHeight())
                  sprite:addChild(sp)
                  sp:setPosition(sprite:getContentSize().width * 0.5 - 1, sprite:getContentSize().height * 0.5 - 1)
              end
             
          else
              print("xhr.readyState is:", xhr.readyState, "xhr.status is: ",xhr.status)
              --未成功，应该取默认头像图片
          end
          callBackFun(id, path)
      end
    xhr:registerScriptHandler(onResponse)
    xhr:send()
--    PlatformLuaFBloadImage(id, path, sprite, callBackFun); --要改成lua写的 ？？？？
end

--[[
    LN[LocalNotification] 
    int id 
    std::string title 推送标题
    std::string text 推送信息
    int secondsAfter 延迟多久发送信息
    int iconBadgeNumber 推送信息ICON下标数字
    std::string buttonText 按钮信息
    std::string type 自定义信息
]]--
function PlatformManager:LNsend(id, title, text, secondsAfter, iconBadgeNumber, buttonText, type)
    PlatformLuaLNsend(id, title, text, secondsAfter, iconBadgeNumber, buttonText, type);
    cclog("PlatformManager:LNsend");
end

--IOS 注册通知权限
function PlatformManager:LNregisterNotify()
    cclog("PlatformManager:LNregisterNotify");
    PlatformLuaLNregisterNotify();
end

--取消通知
function PlatformManager:LNcancelAllScheduled()
    cclog("PlatformManager:LNcancelAllScheduled");
    PlatformLuaLNcancelAllScheduled();
end

function PlatformManager.create()
    local temp = PlatformManager.new();
    return temp;
end
function PlatformManager:onRequestGraphResult(graphPath,result)
    cclog("onRequestGraphResult graphPath:")
end

function PlatformManager:onDeleteObjectResult(graphPath, result)
    cclog("onDeleteObjectResult graphPath:")
end

function PlatformManager:onAndroidKeyBackEvent()
    cclog("onAndroidKeyBackEvent")
    MainStatus:backPack();
end

function PlatformManager:onAndroidKeyHomeEvent()
    cclog("onAndroidKeyHomeEvent")
end



function PlatformManager:OpenUrl(url)
    PlatformLuaOpenUrl(url)
end

function PlatformManager:isIOS()
    local targetPlatform = cc.Application:getInstance():getTargetPlatform()
    if targetPlatform == cc.PLATFORM_OS_IPHONE or targetPlatform == cc.PLATFORM_OS_IPAD  then
        return true;
    elseif targetPlatform == cc.PLATFORM_OS_ANDROID then
        return false;
    end;
end;

-- local aa = PlatformLuaGetPackageValue("version");
--    local bb = PlatformLuaGetSystemProperty("version");
--    local androidID = PlatformLuaGetSystemProperty("androidID");
--    local uuid = PlatformLuaGetSystemProperty("uuid");
--    local name = PlatformLuaGetSystemProperty("name");
--    print("aa======",aa,"bb=========",bb);
--    print("androidID======",androidID,"uuid=========",uuid,"name--------",name);
--得到版本号
function PlatformManager:getAppVersion()
    
    local version = PlatformLuaGetPackageValue("version");
    return version;
end;

function PlatformManager:getAndroidID()
  
    local androidID = PlatformLuaGetSystemProperty("androidID");
    return androidID;
end;

function PlatformManager:getUUID()
  
    local uuid = PlatformLuaGetSystemProperty("uuid");
    return uuid;
end;

function PlatformManager:getMac()
    
   local mac = PlatformLuaGetSystemProperty("mac_address");
  return mac;
end; 

function PlatformManager:getCountry()
    
  local mac = PlatformLuaGetSystemProperty("country");
  return mac;
end;

      
        --"none" "mobile" "wifi"
function PlatformManager:getNetwork()
    
    local net = PlatformLuaGetSystemProperty("network");
  return net;
end;


-- callBack返回一个bool值，true 点了yes 
function PlatformManager:showNativePopDialog(title,des,okDes,cancelDes,callBack)
    local mac = PlatformLuaShowNativePopDialog(title,des,okDes,cancelDes,callBack);
    return mac;
end;

function PlatformManager:getJSONMap(jsonStr)
    return nil-- PlatformGetJSONMap(jsonStr);
end


function PlatformManager:base64Encode(str)
    return PlatformLuaBase64Encode(str);
end

function PlatformManager:MD5(str)
    return PlatformMd5(str)
end


function PlatformManager:platformOpenSupport(url,uid,ver,game)
    return PlatformOpenSupport(url,uid,ver,game);
end


function PlatformManager:onSixWavesXSell()
   local url = nil;
    local targetPlatform = cc.Application:getInstance():getTargetPlatform()
    if targetPlatform == cc.PLATFORM_OS_IPHONE or targetPlatform == cc.PLATFORM_OS_IPAD  then
        url = "http://mobile-xsell.6waves.com/prompt.php?client=ios&appid=0015581225b7b095";
    elseif targetPlatform == cc.PLATFORM_OS_ANDROID then
        url = "http://mobile-xsell.6waves.com/prompt.php?client=android&appid=0035581217694ee7";
        
    end;
    url = "http://mobile-xsell.6waves.com/prompt.php?client=ios&appid=0015581225b7b095";
    local xhr = cc.XMLHttpRequest:new()
    xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_STRING
    xhr:open("POST", url)
    local function onReadyStateChange()
        if xhr.readyState == 4 and (xhr.status >= 200 and xhr.status < 207) then
            local responseData = self:getJSONMap(xhr.response);           
            if responseData == nil then return end;
            if responseData["status"] == 0 then return end;
            
            local url = responseData["url"];
            local name = responseData["name"];
            local message = responseData["message"];
            local deeplink = responseData["deeplink"];
            
            
            
            print("sendRequest Response: "..xhr.response)
        else
            print("xhr.readyState is:", xhr.readyState, "xhr.status is: ",xhr.status)
        end
    end

    xhr:registerScriptHandler(onReadyStateChange)
    xhr:send()
end

function PlatformManager:onLoginResult(result)
    cclog("onLoginResult result:")
    MainValue.fbManager:onLoginResult(result);
end

function PlatformManager:onGetMeResult(userGraph)
    --{["id"] = "602976786473880",["name"] = "Rax Liu",["picture"] = "https://fbcdn-profile-a.akamaihd.net/hprofile-ak-xpa1/v/t1.0-1/c31.95.386.386/s100x100/644708_360365724068322_637591488_n.jpg?oh=0023cb95ac99ba7606e1074fa7329235&oe=54D8AF75&__gda__=1428181152_57ec398602a6b0fc0c41a8a8831efa5a",["username"] = "Rax"}
    cclog("onGetMeResult userGraph:")
    MainValue.fbManager:onGetMeResult(userGraph);
end

function PlatformManager:onGetFriendsResult(userGraphList)
    cclog("onGetFriendsResult userGraphList:")
    MainValue.fbManager:onGetFriendsResult(userGraphList);
end

--返回未安装的好友列表
function PlatformManager:onGetFriendsListResult(inviteFriendsList)
    cclog("onGetFriendsListResult inviteFriendsList:")
    MainValue.fbManager:onGetFriendsListResult(inviteFriendsList);
end

return PlatformManager;