-- 九宫格工具


NineGridTools = class("NineGridTools",function (imgUrl,w,h,cellSize)
    local self = cc.Layer:create();
    
    self.endPic= cc.Layer:create();

      
--    根据路径先得到原图
    self.srcimg = cc.Sprite:create(imgUrl)
    self.srcImgWidth=self.srcimg:getContentSize().width
    self.srcImgHeight=self.srcimg:getContentSize().height
    
--    同时用
--    self.srcimg:setScaleY(2)
--    self.srcimg:setContentSize(70, 90)
    
     
     
    self.srcImgTextures=self.srcimg:getTexture()
    
    --1
    self.topLeftImg=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(0,0,cellSize,cellSize))
    
    --2
    self.topCenterImg=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(cellSize,0,self.srcImgWidth-2*cellSize,cellSize))
    self.topCenterImg:setScaleX((w-2*cellSize)/(self.srcImgWidth-2*cellSize))
    
    --3
    
    self.topRightImg=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(self.srcImgWidth-cellSize,0,cellSize,cellSize))
    
    --4
    self.midLeftImg = cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(0,cellSize,cellSize,self.srcImgHeight-2*cellSize))
    self.midLeftImg:setScaleY((h-2*cellSize)/(self.srcImgHeight-2*cellSize))
   
    --5
    self.midCenterImg= cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(cellSize,cellSize,self.srcImgWidth-2*cellSize,self.srcImgHeight-2*cellSize))
    self.midCenterImg:setScaleX((w-2*cellSize)/(self.srcImgWidth-2*cellSize))
    self.midCenterImg:setScaleY((h-2*cellSize)/(self.srcImgHeight-2*cellSize))
    
    --6
    self.midRightImg =  cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(self.srcImgWidth-cellSize,cellSize,cellSize,self.srcImgHeight-2*cellSize))
    self.midRightImg:setScaleY((h-2*cellSize)/(self.srcImgHeight-2*cellSize))
    
    --7
    self.bottomLeftImg =  cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(0,self.srcImgHeight-cellSize,cellSize,cellSize))
    
    --8
    self.bottomCenterImg=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(cellSize,self.srcImgHeight-cellSize,self.srcImgWidth-2*cellSize,cellSize))
    self.bottomCenterImg:setScaleX((w-2*cellSize)/(self.srcImgWidth-2*cellSize))
    
    --9
    self.bottomRightImg=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(self.srcImgWidth-cellSize,self.srcImgHeight-cellSize,cellSize,cellSize))
    
    
    
    --1 2 3
    --4 5 6
    --7 8 9
    
    --    其实坐标  x为0的应该是   cellSize/2  才是完整的0 0左下角 位置
    
    --1
    local topLeftImgX = cellSize/2
    local topLeftImgY = cellSize/2+h-cellSize/2
    self.topLeftImg:setPosition(cc.p(topLeftImgX,topLeftImgY))
    self.endPic:addChild(self.topLeftImg)
    --2
    
    local topCenterImgX= cellSize/2+cellSize/2+ (w-2*cellSize)/2    
    local topCenterImgY = cellSize/2+h-cellSize/2
    
    self.topCenterImg:setPosition(cc.p(topCenterImgX,topCenterImgY))
    self.endPic:addChild(self.topCenterImg)
    --3
    local topRightImgX= cellSize/2+w- cellSize 
    local topRightImgY= cellSize/2+h-cellSize/2
    self.topRightImg:setPosition(cc.p(topRightImgX,topRightImgY))
    self.endPic:addChild(self.topRightImg)
    
    --4
    local midLeftImgX = cellSize/2
    local midLeftImgY = cellSize/2+cellSize+ (h-2*cellSize)/2   
    self.midLeftImg:setPosition(cc.p(midLeftImgX,midLeftImgY))
    self.endPic:addChild(self.midLeftImg)
    --5
    local midCenterImgX =cellSize/2+ cellSize/2+ (w-2*cellSize)/2    
    local midCenterImgY = cellSize/2+cellSize+ (h-2*cellSize)/2   
    self.midCenterImg:setPosition(cc.p(midCenterImgX,midCenterImgY))
    self.endPic:addChild(self.midCenterImg)
    --6
    local midRightImgX =cellSize/2+ w- cellSize 
    local midRightImgY = cellSize/2+cellSize+ (h-2*cellSize)/2   
    self.midRightImg:setPosition(cc.p(midRightImgX,midRightImgY))
    self.endPic:addChild(self.midRightImg)
    --7
    local bottomLeftImgX = cellSize/2
    local bottomLeftImgY = cellSize/2+cellSize/2
    self.bottomLeftImg:setPosition(cc.p(bottomLeftImgX,bottomLeftImgY))
    self.endPic:addChild(self.bottomLeftImg)
    --8
    local bottomCenterImgX= cellSize/2+cellSize/2+ (w-2*cellSize)/2  
    local bottomCenterImgY=cellSize/2+ cellSize/2
    self.bottomCenterImg:setPosition(cc.p(bottomCenterImgX,bottomCenterImgY))
    self.endPic:addChild(self.bottomCenterImg)
    --9
    local bottomRightImgX= cellSize/2+w- cellSize
    local bottomRightImgY= cellSize/2+cellSize/2
    self.bottomRightImg:setPosition(cc.p(bottomRightImgX,bottomRightImgY))
    self.endPic:addChild(self.bottomRightImg)
    
    self.endPic:setPosition(-w/2,-h/2)
    
    self:addChild(self.endPic)
    
    self.srcImgTextures:release()
    
    
      return self
end)

function NineGridTools.create(imgUrl,w,h,cellSize)
    local endImg = NineGridTools.new(imgUrl,w,h,cellSize)    
    return endImg
end