

require "src.ui.gamecondition.CellCondition"
--    2014-10-31
local testSendLifeUI = nil;

local TestSendLifeUI = class("TestSendLifeUI", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/TestSendLifeUI.json")
end)



function TestSendLifeUI:init()
--    return testSendLifeUI
    MainValue.actionManager:createUIAction():UIAppear(testSendLifeUI);
end


function TestSendLifeUI.closePanel()
    cclog("TestSendLifeUI.lua 点击关闭")
    MainValue.actionManager:createUIAction():UIDisappear(testSendLifeUI,testSendLifeUI.disCallBackFun)
end


function TestSendLifeUI:disCallBackFun()
    testSendLifeUI:removeFromParent(true);
end


function TestSendLifeUI.create()
    testSendLifeUI = TestSendLifeUI.new()    
    testSendLifeUI:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5)    
    
    -- 取得当期窗体的存放大背景的容器
--    local panelCommon = testSendLifeUI:getChildByName("PanelCommon");

    --    取得大背景 放入当前层级
    local loadCommonBigPanel = require("ui.commonpanel.BigPanel");        
    local bigPanel = loadCommonBigPanel.create();         
    bigPanel:setCloseHandler(testSendLifeUI.closePanel);--注册close 函数

    bigPanel:setTitle("Ask live")    
    testSendLifeUI:addProtectedChild(bigPanel,0)
    
    local cellCondition = CellCondition.create(2)
    
--    cellCondition:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5)

    cellCondition:setPosition(VisibleRect:center())  
    testSendLifeUI:addChild(cellCondition)
    
--    panelCommon:addChild(bigPanel);
        
    return testSendLifeUI
end

return TestSendLifeUI   