-- 九宫格工具


ThreeUMDGridTools = class("ThreeUMDGridTools",function (imgUrl,h,cellSize)
    local self = cc.Layer:create();
    
    self.endPic= cc.Layer:create();

    --    根据路径先得到原图
    self.srcimg = cc.Sprite:create(imgUrl)
    self.srcImgWidth = self.srcimg:getContentSize().width
    self.srcImgHeight = self.srcimg:getContentSize().height

    self.srcImgTextures = self.srcimg:getTexture()

    --1
    self.upImg = cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(0,0,self.srcImgWidth,cellSize))

    --2
    self.midImg = cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(0,cellSize,self.srcImgWidth,self.srcImgHeight-2*cellSize))
    self.midImg:setScaleY((h-2*cellSize)/(self.srcImgHeight-2*cellSize))    
    --3    
    self.underImg = cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(0,self.srcImgHeight-cellSize,self.srcImgWidth,cellSize))

    --1 
    --2
    --3

    --    其实坐标  x为0的应该是   cellSize/2  才是完整的0 0左下角 位置

    --1
    local upImgX = self.srcImgWidth/2
    local upImgY =cellSize/2+ h-cellSize/2
    self.upImg:setPosition(cc.p(upImgX,upImgY))
    self.endPic:addChild(self.upImg)
    --2

    local midImgX= self.srcImgWidth/2 
    local midImgY =cellSize/2+cellSize+ (h-2*cellSize)/2   

    self.midImg:setPosition(cc.p(midImgX,midImgY))
    self.endPic:addChild(self.midImg)
    --3
    local underImgX= self.srcImgWidth/2
    local underImgY= cellSize/2+cellSize/2
    self.underImg:setPosition(cc.p(underImgX,underImgY))
    self.endPic:addChild(self.underImg)
    self.endPic:setPosition(-self.srcImgWidth/2,-h/2)

    self:addChild(self.endPic)
    self.srcImgTextures:release()
    return self
end)

function ThreeUMDGridTools.create(imgUrl,h,cellSize)
    local endImg = ThreeUMDGridTools.new(imgUrl,h,cellSize)    
    return endImg
end