require "engine.uigridtools.NineGridTools";
DailyCell = class("DailyCell",function()
    return cc.Layer:create();
end);
function DailyCell:ctor()
    self.state = nil;
    self.day = nil;
    self.days = nil;
    self.goodList = nil;
    self.value = nil;
    self.bg = nil;
    self.dayPic = nil;
    self.goodPic = nil;
    self.numPic = nil;
    self.statePic = nil;
    self.cashPic = nil;
    self.duigou = nil;
    self.selectBg = nil;
    
    
end

function DailyCell.create(day,value,state,days)
   
    local dailyCell = DailyCell.new();

    
    if day == 7 then
        dailyCell.bg = NineGridTools.create("ui/ui/bgPan1.png" , 468 , 202 , 32);--cc.Sprite:create("ui/ui/bgpan1")--背景图片
        dailyCell.selectBg = NineGridTools.create("ui/ui/bgPan3.png" , 468 , 202 , 32);--cc.Sprite:create("ui/ui/bgpan1")--背景图片
    else
        dailyCell.bg = NineGridTools.create("ui/ui/bgPan1.png" , 205 , 155 , 32);--cc.Sprite:create("ui/ui/bgpan1")--背景图片
        dailyCell.selectBg = NineGridTools.create("ui/ui/bgPan3.png" ,205 , 155 , 32);--cc.Sprite:create("ui/ui/bgpan1")--背景图片
       dailyCell.touying = cc.Sprite:createWithSpriteFrameName("ui/ui/dailyTouying.png");
    end
    dailyCell.selectBg:setVisible(false);
    dailyCell:addChild(dailyCell.bg);
    dailyCell:addChild(dailyCell.selectBg);
    if dailyCell.touying ~= nil then
        dailyCell.touying:setPosition(0,-28);
        dailyCell:addChild(dailyCell.touying);
    end
    
    dailyCell.day = day;
    dailyCell.days = days;
    dailyCell.value = value;
    dailyCell.state = state;
    
   
    
    --第几天 
    local str = dailyCell.day.." DAY";
    if dailyCell.dayPic == nil then
        dailyCell.dayPic = FacFont:getFontsBmp(FontType.FontYellowWhiteSide,str);
    else
        dailyCell.dayPic.setText(str);
    end
  --  dailyCell.dayPic:setScale(1,1)
    if day == 7 then
        dailyCell.dayPic:setPosition(0,120);
    else
        dailyCell.dayPic:setPosition(0,95);
    end

    local cash = value["cash"];
    local item = value["item"];
    
    if cash ~= "0" then
        if day == 7 then
            dailyCell.cashPic = cc.Sprite:createWithSpriteFrameName("ui/ui/dailyCoin.png");
            dailyCell.cashPic:setPosition(0,20);
        else
            dailyCell.cashPic = cc.Sprite:create("ui/prop/big/0.png");
            dailyCell.cashPic:setScale(0.9);
            dailyCell.cashPic:setPosition(0,10);
        end
        dailyCell:addChild(dailyCell.cashPic);
        if state == 1 and day == days then
            dailyCell.bg:setVisible(false);
            dailyCell.selectBg:setVisible(true);
        end

        dailyCell:addNum(cash);
      
    end


    if next(item) ~= nil then
        for i,v in pairs(item) do
       
            dailyCell.good = MainValue.infosManager:getObjGoodsById(i);
            local str = string.format("ui/prop/big/%s.png",i);
            local goodsIcon = cc.Sprite:create(str)
         --   goodsIcon:setScale(0.8);
            if day == 7 then
                goodsIcon:setPosition(0,12);
            else
                goodsIcon:setPosition(0,7);
            end
            dailyCell:addChild(goodsIcon);
            dailyCell:addNum(v);
            --满足条件 奖励
            if state == 1 and day == days then
                dailyCell.bg:setVisible(false);
                dailyCell.selectBg:setVisible(true);
            end
        end
    end
    if state == 1 then
   --     MainValue.dataManager.dailyManager:signin();
    end
   dailyCell:addChild(dailyCell.dayPic);
    
    --状态处理

    if day<days or (day == days and state ~=1)  then
        dailyCell.duigou = cc.Sprite:createWithSpriteFrameName("ui/ui/iconTickL.png");
        dailyCell.duigou:setPosition(5,-20);
        dailyCell:addChild(dailyCell.duigou);
    end
    
    return dailyCell;
end

function DailyCell:addNum(num)
    self.number = FacFont:getFontsBmp(FontType.FontSmallWhiteBrownSide,num);
    if self.day == 7 then
        self.number:setPosition(200,-40);
    else
        self.number:setPosition(70,-20);
    end
    
    self:addChild(self.number);
end


function DailyCell:remove()
    if self.bg~= nil then
       self.bg:removeFromParent();
       self.bg = nil;
    end
    if self.dayPic ~= nil then
        self.dayPic:removeFromParent(true);
        self.dayPic = nil;
    end
    if self.goodPic ~= nil then
        self.goodPic:removeFromParent(true);
        self.goodPic = nil;
    end
    if self.numPic ~= nil then
        self.numPic:removeFromParent(true);
        self.numPic = nil;
    end
    
    if self.cashPic ~= nil then
        self.cashPic:removeFromParent(true);
        self.cashPic = nil;
    end
    if self.statePic ~= nil then
        self.statePic:removeFromParent(true);
        self.statePic = nil;
    end

end

function DailyCell:init()

end