local inGameShowCash = nil;
local newCash = nil;
local InGameShowCash = class("InGameShowCash",function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/InGameShowCash.json");

end)

function InGameShowCash.create()
    inGameShowCash = InGameShowCash.new();
    local addCashBtn = inGameShowCash:getChildByName("addCash");
    
    local function btnCloseHandler( sender, eventType )
       
        if eventType == ccui.TouchEventType.began then
        --cclog("点击开始")
        elseif eventType == ccui.TouchEventType.moved then
        --cclog("移动")
        elseif eventType == ccui.TouchEventType.ended then
            --cclog("点击结束")
            local shop = require("ui.storeUI.StoreUI")
            local shopUI = shop.create()
            shopUI:appear(false);
        end
    end
    addCashBtn:addTouchEventListener(btnCloseHandler)
    local function updata()
        local cashText = inGameShowCash:getChildByName("cashText");
        if newCash == nil then
            newCash = FacFont:getFontsBmp(FontType.FontWhite, MainValue.dataManager.userManager:getCash());
            newCash:setPosition(cashText:getPosition());
            cashText:getParent():addChild(newCash);
        else
            newCash:setText(MainValue.dataManager.userManager:getCash());
            newCash:setPosition(cashText:getPosition());
        end
        
       
    end
    updata();
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_CASH, updata);
    return inGameShowCash;
end





return InGameShowCash;