local InboxAskFriCell = class("InboxAskFriCell", function()
    return ccui.Layout:create();
end)

function InboxAskFriCell:ctor()

end

function InboxAskFriCell.create(callBack)
    local temp = InboxAskFriCell:new();
    temp.callBack = callBack;
    temp:init();
    return temp;
end

function InboxAskFriCell:init()
    self.bg = NineGridTools.create("ui/ui/bgCell1.png" , 479 , 138 , 30);
    self.bg:setPosition(237, 60);
    self.bg:setAnchorPoint(0, 0);
    self:addChild(self.bg); 
    
    local spr = cc.Layer:create()
    spr:setRotation(-10);
    spr:setPosition(-15, -10);
    self:addChild(spr);

    self.headIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/inboxHead.png");
--    self.headIcon:setContentSize(82, 82);
    self.headIcon:setPosition(-5, 140);
    self.headIcon:setRotation(10);
    spr:addChild(self.headIcon);

    self.headFrame = NineGridTools.create("ui/ui/bgFrameS.png" , 120 , 120 , 32);
    self.headFrame:setPosition(0, 119)
    spr:addChild(self.headFrame); 

    local desStr = MainValue.infosManager:getObjMultilingualByKey("Inbox_invite_des");

    self.desLabel = FacFont:getFontsBmp(FontType.FontYellowNoSide, desStr , 401, "L", -14);
    self.desLabel:setAnchorPoint(0, 0.5);
    self.desLabel:setPosition(129, 90);
    self:addChild(self.desLabel);
    
    self.receiveBtn = ccui.Button:create("ui/ui/btnRed1.png", "ui/ui/btnRed2.png","" ,1);
    self.receiveBtn:setScaleY(0.5)
    self.receiveBtn:setPosition(396, 47);
    self:addChild(self.receiveBtn);

    self.receiveBtnTxt = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("InviteFriends_btn"));
    self.receiveBtnTxt:setScale(0.7)
    self.receiveBtnTxt:setPosition(395, 53);
    self:addChild(self.receiveBtnTxt);
    
    local function clickHandler(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            self.callBack(true);
        end
    end
    self.receiveBtn:addTouchEventListener(clickHandler)
    
    self:setContentSize(509, 138);
    self:setAnchorPoint(0, 1);
end

return InboxAskFriCell;