local Box = class("Box", function ()
    return cc.Node:create();
end);

function Box:ctor()
    self:setAnchorPoint(0,0);
    self:setContentSize(107,109);
    
    self.flag = false;
    self.isNext = false;
end

function Box.create()
    local temp = Box.new();
    return temp;
end

function Box:init(info)
    self.pbc = info;
    self.bg = cc.Sprite:createWithSpriteFrameName(self.pbc.path)
    self:addChild(self.bg)
end
--设置box可领取状态
function Box:setBoxGetState()
    local allStar = MainValue.dataManager.levelManager:getMaxStar();
    
    if self.pbc ~= nil and allStar >= self.pbc.needStar then
        self:effet()
        self.flag  = true
    end
    
    return self.flag;
end
-- 抖动
function Box:effet() 
    local function cf()
        local function cff()
            MainValue.actionManager:createJellyAction():run(self.bg,40,cf);
        end
        
        self.bg:runAction(cc.Sequence:create(cc.ScaleTo:create(1,1,1),cc.CallFunc:create(cff)))
    end
    MainValue.actionManager:createJellyAction():run(self.bg,40,cf);
end

function Box:setNextMissionState()
    MainValue.mxUIManager.mapManager:setUserHeadFramePos(self:getPositionX(),self:getPositionY(),false, true);
end

return Box;