--[[
地图中的头像
]]--

local HeadFrame = class("HeadFrame", function ()
    return cc.Node:create();
end);

function HeadFrame:ctor()
    self.offX = MainValue.winSize.width / 2;
    self.offY = MainValue.winSize.height / 2;
    
    self:setPosition(self.offX, self.offY);
    self:setAnchorPoint(0,0);
    
    self.isChangePos = false;
    
    self.myBgpath = "ui/ui/myFrame.png";
    self.friendBgpath = "ui/ui/bgFrameBlue.png";
end

function HeadFrame.create()
    local temp = HeadFrame.new();
    return temp;
end
--flag: 1:自已 2:好友
function HeadFrame:init(flag)
    local loc_picture = nil;
    local loc_id = nil;
    self.sp = nil;
    
    local bgpath = self.myBgpath;
    if flag == 2 then
        bgpath = self.friendBgpath;
    elseif flag == 1 then
        loc_picture = MainValue.dataManager.userManager:getPicture();
        loc_id = MainValue.dataManager.userManager:getPID();
    end
    
    self.bgSp = cc.Sprite:createWithSpriteFrameName(bgpath);
    self.bgSp:setPosition(1,-4);
    self:addChild(self.bgSp, 1);
    
    
    if loc_picture == nil or loc_picture == "" or loc_picture == " " or loc_id == nil or loc_id == "" or loc_id == " "then 
    
        if flag == 1 then
            loc_picture = "ui/ui/myDefault.png";
        elseif flag == 2 then
            loc_picture = "ui/ui/inviteDefault.png";
        end
        
        self.sp = cc.Sprite:createWithSpriteFrameName(loc_picture);
        self.sp:setContentSize(50,50);
        
        if flag == 1 then
            --self.sp:setPosition(0, 4);
            
            local function updataHead()
                loc_picture = MainValue.dataManager.userManager:getPicture();
                loc_id = MainValue.dataManager.userManager:getPID();
                self:updataHead(loc_id,loc_picture,1);
            end
            MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_PLATFORM, updataHead);
            
        elseif flag == 2 then
            self.sp:setScale(0.5);
            self.sp:setPosition(-12, -10);
        end
        
        self:addChild(self.sp, 0);
        
--        local fbidxx = FacFont:getFontsBmp(FontType.FontWhite, loc_id.."+++");
--        fbidxx:setPosition(0,300);
--        self:addChild(fbidxx, 2);
--
--        local fbpxx = FacFont:getFontsBmp(FontType.FontWhite, loc_picture.."+++");
--        fbpxx:setPosition(0,100);
--        self:addChild(fbpxx, 3);
--        
--        
--        local ffff = FacFont:getFontsBmp(FontType.FontWhite, loc_id.." **wei kong** "..loc_picture);
--        ffff:setScale(0.5)
--        ffff:setPosition(0,500);
--        self:addChild(ffff, 2);
        
    else
    
--        local ddddddd = FacFont:getFontsBmp(FontType.FontWhite, loc_id.." **bu wei kong** "..loc_picture);
--        ddddddd:setScale(0.5)
--        ddddddd:setPosition(0,500);
--        self:addChild(ddddddd, 2);
    
        self:updataHead(loc_id,loc_picture);
        
        if flag == 2 then
            self.sp:setPosition(0, 4);
        end
    end
end

function HeadFrame:updataHead(pid, picture, isupData)    --self.sp:removeAllChildren(false);
    if self.sp ~= nil then self.sp:removeFromParent();end
    
    local ox = self.bgSp:getPositionX()
    local oy = self.bgSp:getPositionY()

    self.sp = cc.Sprite:create();
    self.sp:setContentSize(50,50);
    if isupData ~= nil then
--        ox = ox -14;
--        oy = oy -8;
--        self.sp:setPosition(ox, oy);
    else
        if picture == MainValue.dataManager.userManager:getPicture() then
--            ox = ox -14;
--            oy = oy -8;
--            self.sp:setPosition(ox,oy);
        else
--            ox = ox -14;
--            oy = oy -8;
--            self.sp:setPosition(ox,oy);
        end
    end
    self:addChild(self.sp, 0);
    
    local function tempFunc(id, url)
    end

    MainValue.platformManager:FBloadImage(pid, picture, self.sp, tempFunc); 
    
    
--    local fbidxx = FacFont:getFontsBmp(FontType.FontWhite, pid.."---");
--    fbidxx:setPosition(0,300);
--    self:addChild(fbidxx, 2);
--
--    local fbpxx = FacFont:getFontsBmp(FontType.FontWhite, picture.."---");
--    fbpxx:setPosition(0,100);
--    self:addChild(fbpxx, 3);
end

return HeadFrame;