require("ui/map/mapview/MapCell")
require("ui/map/mapview/MapComingSpr")

MapSprite = class("MapSprite",function ()
    return cc.Scene:create()
end)
local schedulerObj = nil
function MapSprite:ctor()
    self.updatePageFun =  nil
    return self
end

function MapSprite:init(maxLevelPar)
    
    self.loadNum = 0 --当前加载中的图片数量
    
    self.sideOffsetValue = 0 --上下边界的缓动缓冲值

--  self.comingLevel = maxLevelPar + 10 --用于显示coming soon
--  self.comingMaxRunRow =  self.comingLevel/10 * 4  --共 多少行

    --    共关卡数  100   
    self.maxLevel = maxLevelPar  + 10
    self.maxRunRow = self.maxLevel/10 * 4  --共 40行

    --控制地图引动的变量声明start
    self.dragEnable = true -- 标示是否允许拖拽
    self.dragSpriteIsRun = false --被拖拽的对象是否在运动中
    self.dragSpriteIsEasingRun = false --标示被拖拽的容器是否是自行缓动运动中

    self.dragStartPstY = 0 --被拖拽开始（手指）y
    self.dragEndPstY = 0 --被拖拽结束（手指）y

    self.dragStartTimer = 0 --被拖拽开始时间
    self.dragEndTimer = 0 --被拖拽结束时间

    self.dragOffsetY = 0 --在拖拽周期内的y方向位移
    self.dragTimer = 0 --被拖拽周期


    self.dragSpeedMax = 40 --被拖拽的速度 这个值可以设定    
    self.dragSpeedMin = 30 --被拖拽的速度 这个值可以设定 最小速度用于 调节手感 滑动力度



    self.dragSpeed = 0 -- 被拖拽后的初始速度                     
    self.dragAccelerationSpeed = 3 --加速度的值
    self.dragAccelerationSpeedUsing = 0 --当前应用的加速度值

    self.cloudYSudu = 0.3

    self.startScheduler = false --是否开始计时器

    self.schedulerInstance = nil
    
    self.schedulerObj = nil

    --控制地图引动的变量声明end


    --     800 1136
    --    根据不同分辨率定义偏移和运动位移的处理   768  1024 
    
--    self.offsetX = (MainValue.winSize.width - 768) * 0.5        
--    self.offsetY = -(MainValue.winSize.height - 1024) * 0.5
    
--    if MainValue.winSize.height > 1024 then
--        self.offsetY = 
--    else
--        self.offsetY = (MainValue.winSize.height - 1024) * 0.5
--    end

    --可以传进来初始化的数据来加载默认地图素材   总共  36 片 最多
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()

    self.dragSprite = cc.Sprite:create()    
    self.dragSprite:setAnchorPoint(0.5,0)
    self.dragSprite:setPositionX(VisibleRect:bottom().x)
    self:addChild(self.dragSprite)

    self.mapComingSpr = MapComingSpr.new()
    self.mapComingSpr:retain()
    self.mapComingSpr:initUI()

    self.oldDragSpriteY = self.dragSprite:getPositionY()

    self.storeCellByRowNumAry = {}
    self.storeCellByRowNumAryName = {}
    
    -- {"1":{cellS0,cellS1,cellS2},"2":{cellS0,cellS1,cellS2}}   "1"  标示行号   {cellS0,cellS1,cellS2} 根据下标代表对应列的实际显示地图块单元

    self.initStartRowNum = 0 --需要根据当前的地图id来计算得到
    self.dragUp = true --是否是向上拖拽

    self.initStartPstRowNum = 0 --用于处理实际的图片的加载位置
    self.rowSumPerAloneMap = 4 --每张地图的行数
    
    self.lvSum = 8 --1.5 --总共8张地图   !!!!当时8张地图时候修改  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
    self.maxRowCanUse = (self.rowSumPerAloneMap * self.lvSum - 1)   --  31 -- --总共8张地图   !!!!当时8张地图时候修改   self.lvSum * self.rowSumPerAloneMap   --最大行数 8*1024 = 8192  注意给出的地图有问题当前 !!!!!!!!!!!!!!!    0 到  27 总共 7张地图目前  !!!!!!!!!!!!!!!! 供给循环
    
    self.mapIdFromServer = 0 --当前所在地图数
    
    self.cashMapNum = 2 --上下各缓冲地图单个大张两张
--    self.cashMapNum = 1 --上下各缓冲地图单个大张两张
    
    

    self.mapAloneHeight = 1024 --单张地图的高度
    self.cellWidth = 256 --异步加载的每个单元的宽度
    self.cellHeight = 256  --异步加载的每个单元的高度 

   

    self.maxCol = 3  --列 3*256  = 768

    self.currentRow = 0 --当前已经加载的行数    

    self.tarLineNum = 0 --是根据当前的行号和历史行号对比大小来处理是否加载新的图片
    self.tarOldLineNum = 0

    self.mapTotalHeight = self.lvSum * self.mapAloneHeight + 1024 --地图总的高度  7028

    self.mapTotalWidth = self.maxCol * self.cellWidth  --地图中的宽度

    self.dragSprite:setContentSize(self.mapTotalWidth,self.mapTotalHeight) --存放地图的拖拽层容器设定容积

    self.dragSpriteMapDot = cc.Layer:create()
    self.dragSpriteMapDot:setContentSize(self.mapTotalWidth,self.mapTotalHeight)
    self.dragSpriteMapDot:setAnchorPoint(0,0)    
    
    self.dragSprite:addChild(self.dragSpriteMapDot,1)
    
--    local x , y = VisibleRect:bottom().x
    
    self.mapComingSpr:setPosition(cc.p(VisibleRect:center().x ,(self.maxRunRow - 4) * 256  - 765 + MainValue.winSize.height ))
    self.dragSprite:addChild(self.mapComingSpr,1) 
    -- TODO:::
    for rowPst = self.maxRunRow ,1,-1 do      
        self.storeCellByRowNumAry[rowPst] = {}
        self.storeCellByRowNumAryName[rowPst] = {}
    end 


    --初始化当前所在地图的地图碎片加载 start

    self.tarMapId = self:getMaxMissionsMapID()

    self.mapIdFromServer = self.tarMapId
    self.tarOldPageNum = self.tarMapId

--    cclog("reallyCurMapId--,%f",self.tarMapId)

    local tarMapIdMultiple = math.floor(self.tarMapId / self.lvSum) --总共7张地图  self.lvSum == 7 

    self.initStartPstRowNum = (self.tarMapId - 1) * self.rowSumPerAloneMap   --!!!!!!!!!!!!!!!!!!!

    self.tarLineNum = self.initStartPstRowNum
    self.tarOldLineNum = self.initStartPstRowNum

    local initDragSpriteY = - self.initStartPstRowNum * 256

--    print("DragSprite-pst-------init--------：：：",(initDragSpriteY + self.offsetY))


--    self.dragSprite:setPosition(cc.p(0,initDragSpriteY+ self.offsetY))
    self.dragSprite:setPositionY(initDragSpriteY)
    


    self.oldDragSpriteY = self.dragSprite:getPositionY()
    if self.tarMapId % self.lvSum == 0 then
        self.tarMapId = self.lvSum
    else
        self.tarMapId = self.tarMapId - self.lvSum * tarMapIdMultiple
    end
    
    
    local maxCreatRow = self.initStartPstRowNum + (self.cashMapNum + 1) * self.rowSumPerAloneMap   --+ 4 + 4 + 4
    local minCreatRow = self.initStartPstRowNum - (self.rowSumPerAloneMap - 1) - (self.cashMapNum - 1) * self.rowSumPerAloneMap -- - 4
    
    if maxCreatRow > self.maxRunRow then
        maxCreatRow = self.maxRunRow
    end
    if minCreatRow < 1 then
        minCreatRow = 1
    end
     if self.dragSprite:getPositionY() >= 0 then --下边界的处理
        self.dragSprite:setPositionY(- self.sideOffsetValue)
     end
     
     
     
     
    if self.dragSprite:getPositionY() <= -((self.maxRunRow - self.rowSumPerAloneMap) * 256) then --上边界的处理
        self.dragSprite:setPositionY(-((self.maxRunRow - self.rowSumPerAloneMap) * 256))
    end
     
     
    
--    MainValue.mxUIManager:getMapManager():setLoadFileNum(self.loadFileNum)
--    首先统计出来加载的总数量end


--    for row = minCreatRow, maxCreatRow , 1 do
    for row = 1, 32 , 1 do --每页四行 总共8页缓存  32 行
    
        --这里的 row 的之要根据当亲的 map id 来处理 TODO::: 注意上下都加载多两张地图的处理    
        --        print(self.initStartPstRowNum)
        --        print("Step -------- row",row)
        local setRowNum = -1 --循环地图转化后的 rowNum与地图的名字匹配用
        
        if row <= self.maxRowCanUse + 1 then
            -- (3 - 11)
            local tarRowPst = row
            local setRowName = self.maxRowCanUse - (tarRowPst - 1)
            
            local col = 0
            while col <= 2 do
                self:addImgAsyncFun(row,setRowName , col)
                col = col + 1
            end
        else
        
            local setBs = math.floor((row /(self.maxRowCanUse+1)))
            local setMod = row %(self.maxRowCanUse+1)
            local setRowName
            if setMod ~= 0 then
                setRowName = row -  (self.maxRowCanUse+1) * setBs
                setRowName = self.maxRowCanUse - setRowName + 1
            else
                setRowName = row -  (self.maxRowCanUse+1) * setBs
                if setRowName == 0 then
                    setRowName = 0                    
                else
                    setRowName = self.maxRowCanUse - setRowName
                end
            end
            
            local col = 0
            while col <= 2 do
                self:addImgAsyncFun(row,setRowName , col)
                col = col + 1
            end
            --            print("当前应该显示第7张地图 总第多少行  setPstRowPar end---------------")
        end               
    end


--     if true then return end

--    print("-----------------------sdfsdf--------------------------sdfsdf---------------------------------sdfsdf----------------sdfsdf")

    for row = minCreatRow, maxCreatRow , 1 do
        --    for row = 1, 40 , 1 do
        --这里的 row 的之要根据当亲的 map id 来处理 TODO::: 注意上下都加载多两张地图的处理    
        --        print(self.initStartPstRowNum)
        --        print("Step -------- row",row)
        local setRowNum = -1 --循环地图转化后的 rowNum与地图的名字匹配用

        if row <= self.maxRowCanUse + 1 then
            -- (3 - 11)
            local tarRowPst = self.maxRowCanUse - (self.maxRowCanUse - row)
            local setRowName = self.maxRowCanUse - (tarRowPst - 1)

--            for col = 0, self.maxCol - 1 do
--                self:addImgAsyncFun(row,setRowName , col)                
--            end
            local col = 0
            while col <= 2 do
                self:addImgAsyncFun(row,setRowName , col)
                col =col +1
            end
        else

            local setBs = math.floor((row /(self.maxRowCanUse+1)))
            local setMod = row %(self.maxRowCanUse+1)
            local setRowName
            if setMod ~= 0 then
                setRowName = row -  (self.maxRowCanUse+1) * setBs
                setRowName = self.maxRowCanUse - setRowName + 1
            else
                setRowName = row -  (self.maxRowCanUse+1) * setBs
                if setRowName == 0 then
                    setRowName = 0                    
                else
                    setRowName = self.maxRowCanUse - setRowName
                end
            end
--            for col = 0, self.maxCol - 1 do                               
--                self:addImgAsyncFun(row,setRowName, col)
--            end
            local col = 0
            while col <= 2 do
                self:addImgAsyncFun(row,setRowName , col)
                col =col +1
            end
            --            print("当前应该显示第7张地图 总第多少行  setPstRowPar end---------------")
        end               
    end
--    self:scrollViewDidScroll()
    local function checkRun(dt)
        if self.dragSpriteIsRun then
                  
            if self.dragOffsetY > 0 then --runUp
                if self.dragSpeed <= 0 then
                    self.dragSpriteIsRun = false
                    self.dragEnable = true
                    self.dragSpeed = 0
                    self.oldDragSpriteY = self.dragSprite:getPositionY()
                    self.schedulerInstance:unscheduleScriptEntry(self.schedulerObj)
                    self:scrollViewDidScroll()
                    return
                end
            
                --顺向加速
                self.dragSpeed = self.dragSpeed - dt * 50
--                print("顺向加速--------::",self.dragSpeed)
--            cclog("顺向速--------::",self.dragSpeed)
                self.oldDragSpriteY = self.oldDragSpriteY + self.dragSpeed *dt* 60
                
            elseif self.dragOffsetY < 0 then --runDown
                if self.dragSpeed >= 0 then
                    self.dragSpriteIsRun = false
                    self.dragEnable = true
                    self.dragSpeed = 0
                    self:scrollViewDidScroll()
                    self.oldDragSpriteY = self.dragSprite:getPositionY()
                    self.schedulerInstance:unscheduleScriptEntry(self.schedulerObj)
                    return
                end
--            初始时负数
                self.dragSpeed = self.dragSpeed + dt * 50
--            cclog("逆向速--------::",self.dragSpeed)
--                     print("逆向加速--------::",self.dragSpeed)
                self.oldDragSpriteY = self.oldDragSpriteY + self.dragSpeed *dt* 60
            end         

            self.oldDragSpriteCloudY = self.oldDragSpriteY * self.cloudYSudu
            self.dragSprite:setPosition(cc.p(self.dragSprite:getPositionX(),self.oldDragSpriteY))
            self.dragSpriteCloud:setPositionY(self.oldDragSpriteCloudY)
            if self.dragSprite:getPositionY() >= 0 then --self.offsetY then --下边界的处理
                self.dragSprite:setPositionY(0)
                self.dragSpriteCloud:setPositionY(0)
                self.dragSpriteIsRun = false
                
                
                self.oldDragSpriteY = self.dragSprite:getPositionY()
                
                self.oldDragSpriteCloudY= self.oldDragSpriteY * self.cloudYSudu
                self.schedulerInstance:unscheduleScriptEntry(self.schedulerObj)
                
                if not self.dragSpriteIsEasingRun then
                
                    local function callFun()
                        self.dragSpriteIsEasingRun = false
                        self.dragEnable = true
                        self:scrollViewDidScroll()
                    end
                    
                    self.dragSpriteIsEasingRun = true
                    local easingAction = cc.MoveTo:create(0.3,cc.p(self.dragSprite:getPositionX(),  -self.sideOffsetValue))
                    local easingSe = cc.Sequence:create(cc.EaseIn:create(easingAction,0.3),cc.CallFunc:create(callFun))
                    self.dragSprite:runAction(easingSe)
                end
            end
            
            self.updatePageFun(self.dragSprite:getPositionY())
            
            if self.dragSprite:getPositionY() <= -((self.maxRunRow - self.rowSumPerAloneMap) * 256) then --上边界的处理
                self.dragSprite:setPositionY(-((self.maxRunRow - self.rowSumPerAloneMap) * 256))
                self.dragSpriteCloud:setPositionY(self.dragSprite:getPositionY()* self.cloudYSudu)
                self.dragSpriteIsRun = false
                
                self.oldDragSpriteY = self.dragSprite:getPositionY()
                self.oldDragSpriteCloudY= self.oldDragSpriteY * self.cloudYSudu
                self.schedulerInstance:unscheduleScriptEntry(self.schedulerObj)
                
                
                if not self.dragSpriteIsEasingRun then
                    local  function callFun()
                        self.dragSpriteIsEasingRun = false
                        self.dragEnable = true
                        self:scrollViewDidScroll()
                        self.dragSprite:setPositionY(-((self.maxRunRow - self.rowSumPerAloneMap) * 256- self.sideOffsetValue))
                        self.dragSpriteCloud:setPositionY(self.dragSprite:getPositionY()* self.cloudYSudu)
                    end
                    self.dragSpriteIsEasingRun = true
                    local easingAction = cc.MoveTo:create(0.3,cc.p(self.dragSprite:getPositionX(), -((self.maxRunRow - self.rowSumPerAloneMap) * 256- self.sideOffsetValue) ))
                    local easingSe = cc.Sequence:create(cc.EaseIn:create(easingAction,0.3),cc.CallFunc:create(callFun))
                    self.dragSprite:runAction(easingSe)
                end                
            end
          
        end
--        self:scrollViewDidScroll()
    end


    self.schedulerInstance = cc.Director:getInstance():getScheduler()    
    local function onTouchBegan(touch, event)       
    
        if touch == nil or event == nil then
            return false
        end
    
--        print("self.loadNum---self.loadNum---self.loadNum---self.loadNum---self.loadNum::;",self.loadNum)
        if self.dragSpriteIsRun and self.loadNum == 0 then
            if self.dragSpriteIsEasingRun then
--                print("running---running---running---running---running")
                return false
            end
            
            self.dragSpriteIsRun = false
            
            self.dragEnable = true
            --                print("run stop")
            self:scrollViewDidScroll()  --2015-1-13
            self.dragSpeed = 0
            self.oldDragSpriteY = self.dragSprite:getPositionY()
            self.oldDragSpriteCloudY = self.oldDragSpriteY * self.cloudYSudu
            self.schedulerInstance:unscheduleScriptEntry(self.schedulerObj)
            
        end
        
        if self.dragEnable then
            self.startScheduler = false
           -- self.dragEnable = false                         -- 不限制拖拽
            self.dragStartPstY = touch:getLocation().y
            self.dragStartTimer = os.clock()
            return true
        end
        return false
    end

    local function onTouchMoved(touch, event)
        local offsetY = touch:getLocation().y - self.dragStartPstY 
        local newY =   self.oldDragSpriteY + offsetY
        
        self.dragSprite:setPosition(cc.p(self.dragSprite:getPositionX(),self.dragSprite:getPositionY() + offsetY))  
        if newY >= 0 then --下边界的处理
            self.dragSprite:setPositionY(0)
            self.dragSpriteCloud:setPositionY(0)
        elseif newY<=-((self.maxRunRow - self.rowSumPerAloneMap) * 256) then --上边界的处理
            self.dragSprite:setPositionY(-((self.maxRunRow - self.rowSumPerAloneMap) * 256 ) )
            self.dragSpriteCloud:setPositionY(self.dragSprite:getPositionY()*self.cloudYSudu)
            --            print("aaaaaa="..self.dragSpriteCloud:getPositionY())
        else
            self.dragSprite:setPosition(cc.p(self.dragSprite:getPositionX(),newY))
            self.dragSpriteCloud:setPositionY(self.dragSprite:getPositionY()*self.cloudYSudu)
        end
    end

    local function onTouchEnded(touch, event)
        -- local locationInNode = self.ftueBackGround:convertToNodeSpace(touch:getLocation())
        -- self.dragEnable = true
        self.oldDragSpriteY = self.dragSprite:getPositionY()
        self.dragEndPstY = touch:getLocation().y
        self.dragOffsetY = self.dragEndPstY - self.dragStartPstY    
        if self.dragOffsetY > 0 then
            self.dragUp = true
        elseif self.dragOffsetY < 0 then
            self.dragUp = false
        end
        self.dragStartPstY = 0
        self.dragEndTimer = os.clock()       

        self.dragTimer = self.dragEndTimer - self.dragStartTimer --单位秒  s

        self.dragSpeed = math.abs(self.dragOffsetY)/self.dragTimer  * 0.01                   

        --        print("初始速度---------------------------------------------------------------------------------------------",self.dragSpeed)
        self.dragSpriteIsRun  = true

        if self.dragSpeed > self.dragSpeedMax then
            self.dragSpeed = self.dragSpeedMax
        elseif self.dragSpeed < self.dragSpeedMin then --根据此调整手感 用力力度和滑动处理！！！！！！！！！！
            if self.dragSpeed < 15 then
                self.dragSpeed = 0
                self.dragEnable = true
                self.dragSpriteIsRun  = false
                self:scrollViewDidScroll()  --静止后再加载
                return
            end
            self.dragSpeed = self.dragSpeedMin
        end      


        if self.dragSprite:getPositionY() >= 0 then --下边界的处理
            self.dragSprite:setPositionY(0)
            self.dragSpriteCloud:setPositionY(0)
            self.dragSpriteIsRun = false
            
            if not self.dragSpriteIsEasingRun then
                local  function callFun()
                    self.dragSpriteIsEasingRun = false
                    self.dragEnable = true
                    self.dragSprite:setPositionY(- self.sideOffsetValue)
                    self.dragSpriteCloud:setPositionY(- self.sideOffsetValue*self.cloudYSudu)
                end
                self.dragSpriteIsEasingRun = true
                local easingAction = cc.MoveTo:create(0.3,cc.p(self.dragSprite:getPositionX(), -self.sideOffsetValue))
                local easingSe = cc.Sequence:create(cc.EaseIn:create(easingAction,0.3),cc.CallFunc:create(callFun))
                self.dragSprite:runAction(easingSe)
            end
        end
        if self.dragSprite:getPositionY() <= -((self.maxRunRow - self.rowSumPerAloneMap) * 256) then --上边界的处理
            self.dragSprite:setPositionY(-((self.maxRunRow - self.rowSumPerAloneMap) * 256))
            self.dragSpriteCloud:setPositionY(self.dragSprite:getPositionY() * self.cloudYSudu)
            self.dragSpriteIsRun = false

            if not self.dragSpriteIsEasingRun then
                local  function callFun()
                    self.dragSpriteIsEasingRun = false
                    self.dragEnable = true
                    self.dragSprite:setPositionY(-((self.maxRunRow - self.rowSumPerAloneMap) * 256- self.sideOffsetValue))
                    self.dragSpriteCloud:setPositionY(self.dragSprite:getPositionY()* self.cloudYSudu)
                end
                self.dragSpriteIsEasingRun = true
                local easingAction = cc.MoveTo:create(0.3,cc.p(self.dragSprite:getPositionX(), -((self.maxRunRow - self.rowSumPerAloneMap) * 256- self.sideOffsetValue) ))
                local easingSe = cc.Sequence:create(cc.EaseIn:create(easingAction,0.3),cc.CallFunc:create(callFun))
                self.dragSprite:runAction(easingSe)
            end
        end
        
        
        
        
        



        if self.dragSpriteIsRun then
           if self.dragUp then
                self.dragSpeed  =  math.abs(self.dragSpeed)
                self.dragAccelerationSpeedUsing = self.dragAccelerationSpeed
           else
                self.dragSpeed  = - math.abs(self.dragSpeed)
                self.dragAccelerationSpeedUsing = -self.dragAccelerationSpeed
           end
            self.schedulerObj = self.schedulerInstance:scheduleScriptFunc(checkRun, 0, false)
        end

    end



    local listenerSelf = cc.EventListenerTouchOneByOne:create()

    listenerSelf:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
    listenerSelf:registerScriptHandler(onTouchMoved,cc.Handler.EVENT_TOUCH_MOVED )
    listenerSelf:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED )

    local eventDispatcher = self.dragSprite:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenerSelf, self.dragSprite)

end


function MapSprite:setBgY(offY)

--if true then
--return
--end
       
-- 最上边界和 最下 边界的问题
    if offY > -self.sideOffsetValue then
        return
    elseif offY < -((self.maxRunRow - self.rowSumPerAloneMap) * 256 + self.sideOffsetValue) then
        return 
    end



   if self.dragEnable then
        self.dragEnable = false
        self.dragSpriteIsEasingRun = true
--        print("DragSprite-pst-------setBgY--------：：：",offY)
        local  function callFun()
            self.dragSprite:setPositionY(offY)
            self.oldDragSpriteY = offY
            self:scrollViewDidScroll()
            self.dragSpriteIsEasingRun = false
            self.dragEnable = true
        end
    
        local easingAction = cc.MoveTo:create(0.3,cc.p(self.dragSprite:getPositionX(), offY))
        local easingSe = cc.Sequence:create(easingAction,cc.CallFunc:create(callFun))
        self.dragSprite:runAction(easingSe)   
    end
    
end


function MapSprite:addImgAsyncFun(setPstRowPar , rowPar , colPar)
    
    --print("---"..setPstRowPar.."---"..rowPar.."---"..colPar)
  
   
    local callFun = function()
    
        self.loadNum = self.loadNum - 1
--        print("self.loadNum---------------------110-----------------------::",self.loadNum)
        if self.loadNum == 0 then
           self.dragEnable = true
        else
           self.dragEnable = false
        end
    end
    
    if setPstRowPar >= 1 then      
        
        local tarMapCell = self:isAlreadyStoreByRowAndCol(rowPar,colPar,setPstRowPar)
--        print("rowPar:: "..rowPar.." ::colPar:: "..colPar.." ::setPstRowPar:: "..setPstRowPar)
        if tarMapCell~=nil then
--            print("CUN ZAI---------------- rowPar:: "..rowPar.." ::colPar:: "..colPar.." ::setPstRowPar:: "..setPstRowPar)
--            if true then return end
--            local pstX = VisibleRect:left().x + (self.cellWidth / 2) + self.cellWidth * colPar 
            local pstX = 0
            if colPar == 0 then
                pstX = VisibleRect:bottom().x -self.cellWidth +(768 -MainValue.winSize.width)*0.5
            elseif colPar ==1 then
                pstX = VisibleRect:bottom().x +(768 -MainValue.winSize.width)*0.5
            elseif colPar == 2 then
                pstX = VisibleRect:bottom().x +self.cellWidth +(768 -MainValue.winSize.width)*0.5
            end 
            local pstY = VisibleRect:bottom().y - self.cellHeight * 0.5 + self.cellHeight * setPstRowPar 
            tarMapCell:setPosition(pstX,pstY)
            
        else
        
--            print("NO EXIT rowPar:: "..rowPar.." ::colPar:: "..colPar.." ::setPstRowPar:: "..setPstRowPar)
            self.loadNum = self.loadNum + 1
            
            local tmpMapCell = MapCell:new(rowPar,colPar,setPstRowPar,callFun)
            self:storeMapCell(tmpMapCell)
            
            local pstX = 0
             if colPar == 0 then
                pstX = VisibleRect:bottom().x -self.cellWidth +(768 -MainValue.winSize.width)*0.5
             elseif colPar ==1 then
                pstX = VisibleRect:bottom().x +(768 -MainValue.winSize.width)*0.5
             elseif colPar == 2 then
                pstX = VisibleRect:bottom().x +self.cellWidth  +(768 -MainValue.winSize.width)*0.5
             end 
            
            
            local pstY = VisibleRect:bottom().y - self.cellHeight * 0.5 + self.cellHeight * setPstRowPar
            
            tmpMapCell:setPosition(pstX,pstY)
            self.dragSprite:addChild(tmpMapCell,0)
        end
    end

end



--初始化当前所在地图的地图碎片加载 end


function MapSprite:scrollViewDidScroll()
    
    local y = math.abs(self.dragSprite:getPositionY()) --得到当前拖拽层的y方向坐标
        
    if self.dragSprite:getPositionY() >= 0 then --下边界的处理
        self.dragSprite:setPositionY(0)
        self.dragSpriteCloud:setPositionY(0)
        y = 0
        
        if not self.dragSpriteIsEasingRun then
            local  function callFun()
                self.dragSpriteIsEasingRun = false
                self.dragEnable = true
                self.dragSprite:setPositionY(-self.sideOffsetValue)
                self.dragSpriteCloud:setPositionY(-self.sideOffsetValue* self.cloudYSudu)
            end
    
            self.dragSpriteIsEasingRun = true
            local easingAction = cc.MoveTo:create(0.3,cc.p(self.dragSprite:getPositionX(),  -self.sideOffsetValue))
            local easingSe = cc.Sequence:create(cc.EaseIn:create(easingAction,0.3),cc.CallFunc:create(callFun))
            self.dragSprite:runAction(easingSe)
        end
    end
    
    if self.dragSprite:getPositionY() <= -((self.maxRunRow - self.rowSumPerAloneMap) * 256) then --上边界的处理
    
        self.dragSprite:setPositionY(-((self.maxRunRow - self.rowSumPerAloneMap) * 256))
        self.dragSpriteCloud:setPositionY(self.dragSprite:getPositionY()* self.cloudYSudu)
        if not self.dragSpriteIsEasingRun then
            local  function callFun()
                self.dragSpriteIsEasingRun = false
--                cclog("sdfsdf22221")
                self.dragSprite:setPositionY(-((self.maxRunRow - self.rowSumPerAloneMap) * 256- self.sideOffsetValue))
                self.dragSpriteCloud:setPositionY(self.dragSprite:getPositionY()* self.cloudYSudu)
                self.dragEnable = true
            end
            self.dragSpriteIsEasingRun = true
            local easingAction = cc.MoveTo:create(0.3,cc.p(self.dragSprite:getPositionX(), -((self.maxRunRow - self.rowSumPerAloneMap) * 256- self.sideOffsetValue)))
            local easingSe = cc.Sequence:create(cc.EaseIn:create(easingAction,0.3),cc.CallFunc:create(callFun))
            self.dragSprite:runAction(easingSe)
            self.dragSpriteCloud:setPositionY(self.dragSprite:getPositionY() * self.cloudYSudu)
            --            print("ccccc="..self.dragSpriteCloud:getPositionY())
        end
    end
    
    self.mapIdFromServer = math.floor(math.abs(self.dragSprite:getPositionY())/1024) + 1
    --print("self.mapIdFromServer----------::",self.mapIdFromServer)
    if self.mapIdFromServer ~= self.tarOldPageNum then
        self.tarOldPageNum = self.mapIdFromServer        
    end
   
    
    self.initStartPstRowNum = math.floor(y / self.cellHeight)        
    self.tarLineNum = math.floor(y / self.cellHeight)
    
   
    if self.tarLineNum ~= self.tarOldLineNum then
        self.tarOldLineNum = self.tarLineNum
        
        local rowmax = self.initStartPstRowNum +(self.cashMapNum+1) * self.rowSumPerAloneMap  -- + 4 + 4 + 4
        if rowmax > self.maxRunRow then
            rowmax = self.maxRunRow
        end                
                
--        print("curretnStopPst--:",self.initStartPstRowNum,"-rowMaxPst-:",rowmax,"-rowMinPst-:",(self.initStartPstRowNum-7)) 
               
        local rowmin =  self.initStartPstRowNum - 3 - (self.cashMapNum - 1) * self.rowSumPerAloneMap -- - 4
        
        local step = 0
        local startIndex
        local endIndex
        if self.dragUp then
            step = -1
            startIndex = rowmax
            endIndex = rowmin
        else
            startIndex = rowmin
            endIndex = rowmax
            step = 1
        end 
        
--        print("startIndex::::::"..startIndex.."::::::endIndex::::::"..endIndex)
       
       local row = startIndex
       if step == 1 then -- 向下运动
            while row < endIndex do
                local setRowNum = -1 --循环地图转化后的 rowNum与地图的名字匹配用
                if row <= self.maxRowCanUse + 1 then
                
                    local tarRowPst = self.maxRowCanUse - (self.maxRowCanUse - row)
                    local setRowName = self.maxRowCanUse - (tarRowPst - 1)
                    local col = 0
                    while col <= 2 do
                        self:addImgAsyncFun(row,setRowName , col)
                        col =col +1
                    end
                else
                    local setBs = math.floor((row /(self.maxRowCanUse+1)))
                    local setMod = row %(self.maxRowCanUse+1)
                    local setRowName
                    if setMod ~= 0 then
                        setRowName= row -  (self.maxRowCanUse + 1) * setBs
                        setRowName = self.maxRowCanUse - setRowName + 1
                    else
                        setRowName= row -  (self.maxRowCanUse+1) * setBs
                        if setRowName==0 then
                            setRowName = 0                    
                        else
                            setRowName = self.maxRowCanUse - setRowName
                        end
                    end
                    
                    local col = 0
                    while col <= 2 do
                        self:addImgAsyncFun(row,setRowName , col)
                        col =col +1
                    end
                end 
                row = row + step
            end
        elseif step == -1 then  -- 向上运动
           while row-1 >= endIndex do
                local setRowNum = -1 --循环地图转化后的 rowNum与地图的名字匹配用
                if row <= self.maxRowCanUse + 1 then

                    local tarRowPst = self.maxRowCanUse - (self.maxRowCanUse - row)
                    local setRowName = self.maxRowCanUse - (tarRowPst - 1)
                    local col = 0
                    while col <= 2 do
                        self:addImgAsyncFun(row,setRowName , col)
                        col =col +1
                    end
                else
                    local setBs = math.floor((row /(self.maxRowCanUse+1)))
                    local setMod = row %(self.maxRowCanUse+1)
                    local setRowName
                    if setMod ~= 0 then
                        setRowName= row -  (self.maxRowCanUse + 1) * setBs
                        setRowName = self.maxRowCanUse - setRowName + 1
                    else
                        setRowName= row -  (self.maxRowCanUse+1) * setBs
                        if setRowName==0 then
                            setRowName = 0                    
                        else
                            setRowName = self.maxRowCanUse - setRowName
                        end
                    end
                    
                    local col = 0
                    while col <= 2 do
                        self:addImgAsyncFun(row,setRowName , col)
                        col =col +1
                    end
                    
                end
                row = row +step
           end
           
       end
       
    end
    
end



function MapSprite:isAlreadyStore(mapCellPar)
    local isExit = false    
    --    self.storeCellByRowNumAry = {}
    -- {"1":{cellS0,cellS1,cellS2},"2":{cellS0,cellS1,cellS2}}   "1"  标示行号   {cellS0,cellS1,cellS2} 根据下标代表对应列的实际显示地图块单元

    if self.storeCellByRowNumAry == nil or table.maxn(self.storeCellByRowNumAry) == 0 then
        return isExit
    else        
        local mapCellParRowPst = mapCellPar:getRowPstNum()
        local mapCellParCol = mapCellPar:getColNum()
        
        local aryNameLen = table.maxn(self.storeCellByRowNumAryName)
        
        local row = 1
        while row <= aryNameLen do
            if row == mapCellParRowPst then
            local aryNameRowLen = table.maxn(self.storeCellByRowNumAryName[row])          
                if aryNameRowLen ~= 0  and self.storeCellByRowNumAryName[row] ~= nil and self.storeCellByRowNumAryName[row][mapCellParCol] ~= nil then
                    isExit = true
                    break                
                end 
            end    
            row = row + 1
        end          
    end 
    return isExit
end

function MapSprite:isAlreadyStoreByRowAndCol(rowNum,colNumPar,setPstRowPar)
    local isExsitMapCell = nil
    
    --    self.storeCellByRowNumAry = {}
    -- {"1":{cellS0,cellS1,cellS2},"2":{cellS0,cellS1,cellS2}}   "1"  标示行号   {cellS0,cellS1,cellS2} 根据下标代表对应列的实际显示地图块单元
    if self.storeCellByRowNumAryName == nil or table.maxn(self.storeCellByRowNumAryName) == 0 then
        return isExsitMapCell
    else
        local aryNameLen = table.maxn(self.storeCellByRowNumAryName)
        
        local rowPst = 1
        while rowPst <= aryNameLen do
            
            local aryNameLenRowLen = table.maxn(self.storeCellByRowNumAryName[rowPst]) 
            local colNumI = 0
            
            while colNumI<= 2 do
                if aryNameLenRowLen ~= 0  and self.storeCellByRowNumAryName[rowPst]~=nil and self.storeCellByRowNumAryName[rowPst][colNumI] ~= nil then
                
                    local tarName
--                    if setPstRowPar > 16 then
--                        setPstRowPar = setPstRowPar - 16
--                    end
                    
                    if setPstRowPar > 32 then
                        setPstRowPar = setPstRowPar - 32
                    end
                    
                        tarName = tostring("1_"..setPstRowPar.."_"..colNumPar..".jpg")
                    
                    if tarName == self.storeCellByRowNumAryName[rowPst][colNumI] then
                        isExsitMapCell = self.storeCellByRowNumAry[rowPst][colNumI]
                        break
                    end
                end 
                colNumI = colNumI +1
            end
            if isExsitMapCell ~= nil then
                break;
            end
            rowPst = rowPst +1
        end
        
    end 
    
    return isExsitMapCell
end

function MapSprite:storeMapCell(mapCellPar)

    if mapCellPar:getRowPstNum() >=1 then
        self.storeCellByRowNumAry[mapCellPar:getRowPstNum()][mapCellPar:getColNum()] = mapCellPar
        self.storeCellByRowNumAryName[mapCellPar:getRowPstNum()][mapCellPar:getColNum()] = mapCellPar.name
    end
end

function MapSprite:initUpDatePageFun(updatePage)
    self.updatePageFun = updatePage
end

function MapSprite:getDragSpriteY()
    return self.dragSprite:getPositionY()
end

function MapSprite:addCloudToDragSprite(cloud)
    if cloud~=nil and cloud:getParent()~=nil then
        cloud:getParent():removeChild(cloud)
    end
    self.dragSpriteCloud = cloud
    -- self.dragSpriteCloud:setPositionY(0)

    print(self.dragSprite:getPositionY());
    self.oldDragSpriteCloudY = self.dragSprite:getPositionY() * self.cloudYSudu;
    self.dragSpriteCloud:setPositionY(self.oldDragSpriteCloudY)
    self:addChild(self.dragSpriteCloud)
    

end

function MapSprite:addSpriteToDragSprite(userHeadFrameSp,isLevelDotPar)
    if isLevelDotPar then
        if userHeadFrameSp~=nil and userHeadFrameSp:getParent()~=nil then
            userHeadFrameSp:getParent():removeChild(userHeadFrameSp)
        end
        self.dragSpriteMapDot:addChild(userHeadFrameSp,1)
    else
        
        if userHeadFrameSp~=nil and userHeadFrameSp:getParent()~=nil then
            userHeadFrameSp:getParent():removeChild(userHeadFrameSp)
        end
        
        self.dragSpriteMapDot:addChild(userHeadFrameSp,2)
    end
end

function MapSprite:getCurrentMapId()
    return self.mapIdFromServer
end

--当前最大关卡所在地图id
function MapSprite:getMaxMissionsMapID()
    local al = MainValue.dataManager.levelManager:getMaxLevel();
    local max_lv = al;
    local maxPageNum  = math.ceil(max_lv/10);
    return maxPageNum;
end

return MapSprite