MapCell = class("MapCell",function ()
    return cc.Layer:create()
end)

function MapCell:ctor(ddddcc,rowNumPar,colNumPar,rowPstNumPar,callFunPar)

     
    
    self.rowPstNum = rowPstNumPar
    if rowPstNumPar > 32 then
        rowPstNumPar = rowPstNumPar-32
    end
    
    self.name = tostring("1_"..rowPstNumPar.."_"..colNumPar..".jpg")
    
    self.callFu = callFunPar
    
    self.rowNum = rowNumPar
    
    self.colNum = colNumPar
    
    self.currentRowNum = -1
    
    
    local function callback(texturePar)
        self.callFu()
        self.texture = texturePar     
        self.cellSprite = cc.Sprite:createWithTexture(self.texture)   
        self:addChild(self.cellSprite)
        --        
    end   
   
   
   
    local imgName = string.format("map/background/1_%d_%d.jpg",rowNumPar ,colNumPar)
    
--    print("MapCell addImgAsyncFun --imgName::"..imgName)
    cc.Director:getInstance():getTextureCache():addImageAsync(imgName,callback)

    return self
end

function MapCell:getRowNum()
    return self.rowNum
end

function MapCell:getRowPstNum()
    return self.rowPstNum
end

function MapCell:getColNum()
    return self.colNum
end

function MapCell:GC()
    self.callFu = nil
    if self.texture~=nil then
        cc.Director:getInstance():getTextureCache():removeTexture(self.texture)
        self.texture = nil
--        self:release()
    end
end

