require "ui/playGamePanel/frontprops/FrontPropsPanelCell"
require "data/DataManager"
require "BuyFlowValue"
require("data/buydata/BuyFlowData") 
FrontPropsPanel = class("FrontPropsPanel",function ()
    return cc.Layer:create();
end)
function FrontPropsPanel:ctor(closePlayGamePanelFunPar)
--  选中道具需要花费的coin
    self.needCois = 0
    self.closePlayGamePanelFun = closePlayGamePanelFunPar
--  当前按下时间累加处理
    self.tarTotalTimer = 0
--  标记tips是否已经显示
    self.tipsAlreadyShow = false
    self.oldSelectedPropsId = 0
        
    self.schedulerName = nil
-- 被选中的 前置道具id数组供给huangqihui游戏内调用 2015-1-6
    self.selectedPropIdsAry = {}
    
-- 被选中的 前置道具id数组标记是金钱的使用还是剩余数量的使用           1剩余数量的使用            2标示金钱的使用   0既不减去数量又不减cash的 ftue
  
    self.selectedPropIdsSignAry = {}
--    点击开始时间戳
    self.startClickTimer = 0
--    点击结束时间戳
    self.endClickTimer = 0
    
    self.selectedPropId = 0  
--  数据
    self.cellAryDatas = nil
--  处理三个显示前置道具的空壳子
    self.cellAry  = {}
    
    self.cellClickRecAry  = {cc.rect(-55,-55,110,110),cc.rect(110,-55,110,110),cc.rect(266,-55,110,110)}
    
    for cellI = 1 , 3 do
        local propCell = FrontPropsPanelCell.new()
        propCell:setAnchorPoint(0.5,0.5)
        if cellI == 1 then
            propCell:setPosition(12,-6)
        elseif cellI ==2 then
            propCell:setPosition(164,-6)
        else
            propCell:setPosition(317,-6)
        end
        
        table.insert(self.cellAry,propCell)
        self:addChild(propCell)
    end
    
    local function onWorldTimerHandler(spendsTimes)
    
--        self.tarTotalTimer = self.tarTotalTimer + spendsTimes
--        
--        if self.tarTotalTimer > 0.8 then
--            if not self.tipsAlreadyShow then
--                self.tipsAlreadyShow = true
--                --TODO:::              显示tips 根据当前的 propid 显示tips的内容 
--
-- --                print("-------------------------------------------------------------------",self.tarTotalTimer)
--                                
--            end
--        end
    end
    
    local function onTouchBgBegan(touch, event)
        self.startClickTimer = os.clock()
        local clickRectContainsPoint = false
        local locationInNode = self:convertToNodeSpace(touch:getLocation())
        self.selectedPropId = 0
        
        for rectI = 1,#(self.cellClickRecAry) do
            local rect = self.cellClickRecAry[rectI]
            if cc.rectContainsPoint(rect, locationInNode) then
                -- print("可以点击locationInNode".."locationInNode::x::"..locationInNode.x.."::locationInNode.y::"..locationInNode.y)                
--                并且要已经解锁的才能点击
                local tarPropDataObj = self.cellAryDatas[rectI]  
                if tonumber(tarPropDataObj.lv) > MainValue.dataManager.levelManager:getMaxLevel() then
                
                else
                    clickRectContainsPoint = true
                    self.selectedPropId = rectI
                end     
                break                     
            end
        end
        
--        if clickRectContainsPoint and self.schedulerName == nil then
--            self.tarTotalTimer = 0
--            self.oldSelectedPropsId = 0
--            self.tipsAlreadyShow = false
--            self.schedulerName = cc.Director:getInstance():getScheduler():scheduleScriptFunc(onWorldTimerHandler, 0, false)
--        end
        
--        print("clickName::;",tarId)
        return clickRectContainsPoint
    end    
    
    local function onTouchBgMoved(touch, event)
            
        local locationInNode = self:convertToNodeSpace(touch:getLocation())    
        self.selectedPropId = 0
        for rectI = 1,#(self.cellClickRecAry) do
            local rect = self.cellClickRecAry[rectI]
            if cc.rectContainsPoint(rect, locationInNode) then
                self.selectedPropId = rectI
                break                     
            end
        end
        
        if self.oldSelectedPropsId~=self.selectedPropId then
            self.tarTotalTimer = 0
            self.tipsAlreadyShow = false
            self.oldSelectedPropsId = self.selectedPropId
        end
        
--        if self.selectedPropId == 0 then
-- --        tips的消失
--        else --tips的消失
--        
--        end
        
--        print(":::self.selectedPropId-----------------------:::",self.selectedPropId)
                
    end
    
    local function onTouchBgEnded(touch, event)
    
        if self.schedulerName ~= nil then
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.schedulerName)
            self.schedulerName = nil
        end
        
        self.endClickTimer = os.clock()
        local pressTimelong = self.endClickTimer - self.startClickTimer
--        print("点击到松开的时间长度",pressTimelong)
        if pressTimelong <= 0.8 then
--        处理选中和取消
--            print(":::self.sel处理选中和取消ectedPropId-----------------------:::",self.selectedPropId)
--            self:makeSelectedOrCancle(self.selectedPropId)
        else
--      做 tip显示和消失 再onworldTimerHandler 中做
           
        end   
        
        self:makeSelectedOrCancle(self.selectedPropId)
        
        MainValue.mxFTUEManager:removeFtue();
                     
--        单击是否是出tips 以 0.8s时间为间隔分界                      
    end
    
--    local function onTouchBgCancled(touch, event)
--            
--    
--    end    
    
    self.thisLayerEventListener = cc.EventListenerTouchOneByOne:create()
    self.thisLayerEventListener:setSwallowTouches(false)
    
    self.thisLayerEventListener:registerScriptHandler(onTouchBgBegan,cc.Handler.EVENT_TOUCH_BEGAN)
    self.thisLayerEventListener:registerScriptHandler(onTouchBgMoved,cc.Handler.EVENT_TOUCH_MOVED)
    self.thisLayerEventListener:registerScriptHandler(onTouchBgEnded,cc.Handler.EVENT_TOUCH_ENDED)
--    self.thisLayerEventListener:registerScriptHandler(onTouchBgCancled,cc.Handler.EVENT_TOUCH_CANCELLED)

    self.eventDispatcher = self:getEventDispatcher()
    self.eventDispatcher:addEventListenerWithSceneGraphPriority(self.thisLayerEventListener, self)
    
    return self
    
end

function FrontPropsPanel:makeSelectedOrCancle(selectedPropIdIndexPar)
    local tarPropDataObj = self.cellAryDatas[selectedPropIdIndexPar]        
    local tarSelectedId = tarPropDataObj.id   
    local isExsitIndex = self:isExsitId(tarSelectedId)  
    
    local tarGoodsNum = MainValue.dataManager.goodsManager:getGoodsNumber(tonumber(tarSelectedId)) --当前道具的库存数量
    --  得到当前总的cash数量
    local totalCash = MainValue.dataManager.userManager:getCash()
        
    local isSelected = -1 -- -1是不操作      0是删除   1是数量还有的添加  2是金钱还有的添加
    
    if self:isExsitId(tarSelectedId) == 0 then --如果还没有被选择
--  添加选择
--  判断库存数量
        if MainValue.mxFTUEManager:hasFtue() then
           isSelected = 1
        elseif tarGoodsNum ~= 0 then
           isSelected = 1
        else
--      MainValue.isShowPlayGamePanel = true
        
--        记录显示了 playGamePanel 
        if BuyFlowValue.outBuyAry == nil or table.maxn(BuyFlowValue.outBuyAry) == 0 then
            BuyFlowValue.outBuyAry = {}
--            local buyFlowDataCls = 
            local tmpBuyFlowData = BuyFlowData.new(BuyFlowValue.playGamePanel)
            tmpBuyFlowData:setGoodsId(tarSelectedId)
            BuyFlowValue.outBuyAry[1] = tmpBuyFlowData
        end
        

--        消失playGamePanel
        if self.closePlayGamePanelFun~=nil then
            self.closePlayGamePanelFun()
        end
        
        
--        MainValue.isShowPlayGamePanelSelectedId = tarSelectedId
        
        --[[
            self.needCois = self.needCois + tonumber(tarPropDataObj.cash)
            
            if self.needCois > totalCash then --弹出购买cash界面
            
                local shop = require("ui.storeUI.StoreUI")
                local shopUI = shop.create()
                shopUI:appearAlone()
                isSelected = -1
            else
                isSelected = 2 --                
            end
           --]]
        end
--        table.insert(self.selectedPropIdsAry,tarSelectedId)
--        self.cellAry[self.selectedPropId]:setSelected()
    else
        isSelected = 0
        
--  删除选择
        self.needCois = self.needCois - tonumber(tarPropDataObj.cash)        
--        table.remove(self.selectedPropIdsAry,isExsitIndex)
--        self.cellAry[self.selectedPropId]:setSelectedCancle()
--  从已经选择的数组中移除     
    end
    
    
--    local tmpBuyResultUI = require("ui.buyresultui.BuyResultUI")
--    local tarUI = tmpBuyResultUI.new()
--    
--    tarUI:appear()
--    
--    if true then
--        return
--    end
   
    if isSelected == 1 then --1是数量还有的添加    
    
        if MainValue.mxFTUEManager:hasFtue() then
            table.insert(self.selectedPropIdsAry,tarSelectedId)
            table.insert(self.selectedPropIdsSignAry,0)       
        else
            table.insert(self.selectedPropIdsAry,tarSelectedId)
            table.insert(self.selectedPropIdsSignAry,1)   
            MainValue.dataManager.goodsManager:subGoods(tonumber(tarSelectedId),1);
           -- 
           MainValue.statisticsManager:consumeBuyPreItem( tarSelectedId, 1, 0, 0, MainValue.SELECTED_LEVEL, MainValue.dataManager.userManager:getHeart(), 0, MainValue.dataManager.userManager:getCash(), -1 )  
        end
        self.cellAry[self.selectedPropId]:setSelected()
    elseif isSelected == 2 then --  2 是金钱还有的添加
    
            local cashNum = 0
            for cellDataI = 1,#(self.cellAryDatas) do
                if self.cellAryDatas[cellDataI].id == tarSelectedId then
                    cashNum = self.cellAryDatas[cellDataI].cash
                    break
                end
            end   
    
    
        MainValue.dataManager.userManager:subCash(tonumber(cashNum))
               
        table.insert(self.selectedPropIdsSignAry,2)
        table.insert(self.selectedPropIdsAry,tarSelectedId)
        self.cellAry[self.selectedPropId]:setSelected()        
        
    elseif isSelected == 0 then --0是删除
        local delTypeCashOrNum  = self.selectedPropIdsSignAry[isExsitIndex]
        if delTypeCashOrNum == 1 then --回复数量
            MainValue.dataManager.goodsManager:addGoods(tonumber(tarSelectedId),1)
        elseif delTypeCashOrNum == 2 then --回复金钱
            local cashNum = 0
            for cellDataI = 1,#(self.cellAryDatas) do
                if self.cellAryDatas[cellDataI].id == self.cellAryDatas[self.selectedPropId].id then
                    cashNum = self.cellAryDatas[cellDataI].cash
                    break
                end
            end            
            MainValue.dataManager.userManager:addCash(tonumber(cashNum))
        elseif delTypeCashOrNum == 0 then --ftue 的
        
        end
        
        table.remove(self.selectedPropIdsAry,isExsitIndex)
        table.remove(self.selectedPropIdsSignAry,isExsitIndex)
        self.cellAry[self.selectedPropId]:setSelectedCancle()
                
    elseif isSelected == -1 then --  -1是不操作
    
    end
    
end

function FrontPropsPanel:isExsitId(tarSelectedIdPar)
	local isExsitIndex = 0
    for i = 1,table.maxn(self.selectedPropIdsAry) do
        local tarid = self.selectedPropIdsAry[i]
        if tarid == tarSelectedIdPar then
            isExsitIndex = i
    	   break
	   end
	end
    return isExsitIndex
end



function FrontPropsPanel:setData(getFrontPropsAryPar)
    --初始化数据
    self.cellAryDatas = getFrontPropsAryPar
    self:initUI()
end

function FrontPropsPanel:initUI()

     for celI = 1 ,#(self.cellAryDatas) do
        if celI <= 3 then
            self.cellAry[celI]:intiUI(self.cellAryDatas[celI])
        end
     end
       
end

function FrontPropsPanel:recoverNum()
    if self.selectedPropIdsAry ~= nil and table.maxn(self.selectedPropIdsAry) > 0 then
        for index = 1,table.maxn(self.selectedPropIdsAry) do
            MainValue.dataManager.goodsManager:addGoods(tonumber(self.selectedPropIdsAry[index]),1)
        end
    end    
end


function FrontPropsPanel:getTarSelectedIds()
    return self.selectedPropIdsAry
end

function FrontPropsPanel:GC()
    if self.schedulerName ~= nil then
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.schedulerName)
        self.schedulerName = nil
    end
    
end