FrontPropsPanelCell = class("FrontPropsPanelCell",function ()
   return cc.Layer:create();
end)

function FrontPropsPanelCell:ctor()
    self:setAnchorPoint(0.5,0.5)
    return self
end


function FrontPropsPanelCell:intiUI(dataPar)
--dataPar.id
--dataPar.lv
--dataPar.costType
--dataPar.name
--dataPar.type
--dataPar.useType
--dataPar.cash
--dataPar.coin
    self.lv = dataPar.lv

    self.bg = cc.Sprite:createWithSpriteFrameName("ui/ui/bgPan1.png") --背景图片
    self.bg:setPosition(0,0)
    self:addChild(self.bg)
        
    self.shaderSp = cc.Sprite:createWithSpriteFrameName("ui/ui/dailyTouying.png") --背景图片
    self.shaderSp:setPosition(0,-39)
    self:addChild(self.shaderSp)
    
    
    local propsUrl = string.format("ui/prop/big/%s.png",dataPar.id)    
    self.goodPic = cc.Sprite:create(propsUrl)
    self.goodPic:setScale(0.85)
    self.goodPic:setPositionY(10)
    self:addChild(self.goodPic)
    
    self.CoinBg = cc.Sprite:createWithSpriteFrameName("ui/ui/frontPropPriceBg.png") --对应的金币图标背景
    self.CoinBg:setPosition(-2,-93)
--    self.priceIcon:setScale(0.7)
--    self:addChild(self.CoinBg)
    
  
    
    self.priceIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/iconCoin.png") --对应的金币图标
    self.priceIcon:setPosition(-36,-95)
    self.priceIcon:setScale(0.65)
--    self:addChild(self.priceIcon)
    
    self.priceNum = FacFont:getFontsBmp(FontType.FontRed,dataPar.cash)
--    cc.Label:setAnchorPoint(point_table)    
    self.priceNum:setAnchorPoint(0,0.5)
    self.priceNum:setPosition(0,-85)
    
--    self:addChild(self.priceNum)
    
    self.lockIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/iconLock.png") --锁的动画
    self.lockIcon:setPositionX(-2)
    self.lockIcon:setPositionY(3)
    self:addChild(self.lockIcon)

    self.selectedIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/iconTickL.png") -- 选中的图标
    self.selectedIcon:setPositionX(10)
    self.priceIcon:setScale(0.9)
    self.selectedIcon:setPositionY(-35)
    self:addChild(self.selectedIcon)
    
    
    self.addCasnBtn = ccui.Button:create("ui/ui/btnPlus2_1.png", "ui/ui/btnPlus2_2.png", "", 1)
    self.addCasnBtn:setPosition(36, -40)
    self.addCasnBtn:setTouchEnabled(false)
    self:addChild(self.addCasnBtn);
    
    
    self.tarGoodsNum = MainValue.dataManager.goodsManager:getGoodsNumber(tonumber(dataPar.id)) --当前道具的库存数量
    self.num = FacFont:getFontsBmp(FontType.FontWhite,self.tarGoodsNum)
    self.num:setScale(0.8)
    self.num:setPosition(0,-44)
    
    self:addChild(self.num)
    
    
    
    
    self.goodPic:setVisible(false)
    self.priceIcon:setVisible(false)
    self.priceNum:setVisible(false)
    self.lockIcon:setVisible(false)
    self.selectedIcon:setVisible(false)   
    self.shaderSp:setVisible(false)  
    self.num:setVisible(false)  
    self.addCasnBtn:setVisible(false)
    self:updateShowState()
    
end

function FrontPropsPanelCell:updateShowState()

    if tonumber(self.lv) <= MainValue.dataManager.levelManager:getMaxLevel() then  -- <= 6 then 
--    解锁了
--        self.CoinBg:setVisible(true)
--        self.priceIcon:setVisible(true)
--        self.priceNum:setVisible(true)
        self.lockIcon:setVisible(false)
        self.selectedIcon:setVisible(false)
        self.goodPic:setVisible(true)
        self.shaderSp:setVisible(true)
        if self.tarGoodsNum > 0 then  
            self.num:setVisible(true) 
        end
        if self.tarGoodsNum < 1 then
            self.addCasnBtn:setVisible(true)
        end
        
    else
--    没有被解锁
--        self.CoinBg:setVisible(false)
--        self.priceIcon:setVisible(false)
--        self.priceNum:setVisible(false)
        self.lockIcon:setVisible(true)
        self.goodPic:setVisible(false)
        self.shaderSp:setVisible(false)  
        self.selectedIcon:setVisible(false)
        self.num:setVisible(false) 
        self.addCasnBtn:setVisible(false)
    end        
end

function FrontPropsPanelCell:setSelected()
    self.selectedIcon:setVisible(true)
--    self.CoinBg:setVisible(false)
--    self.priceIcon:setVisible(false)
--    self.priceNum:setVisible(false)
    self.addCasnBtn:setVisible(false);
    self.num:setVisible(false) 
end

function FrontPropsPanelCell:setSelectedCancle()
    self.selectedIcon:setVisible(false)
    self.addCasnBtn:setVisible(true);
--    self.priceIcon:setVisible(true)
--    self.priceNum:setVisible(true)
--    self.CoinBg:setVisible(true)
    if self.tarGoodsNum > 0 then  
        self.num:setVisible(true) 
    end
--    self.num:setVisible(true) 
end


function FrontPropsPanelCell:GC()
   
end