


local quitLevelPopup = nil;
local QuitLevelPopup = class("QuitLevelPopup", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/QuitLevelPopup.json");
end);

function QuitLevelPopup:disCallBackFun()
    quitLevelPopup:removeFromParent(true);
end

function QuitLevelPopup.create()
    quitLevelPopup = QuitLevelPopup.new()

    quitLevelPopup:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);

 --   local temp = quitLevelPopup:getChildByName("QuitPanelBg")
    local closebtn = tolua.cast(quitLevelPopup:getChildByName("btnClose"), "ccui.Button")

    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )

        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createUIAction():UIDisappear(quitLevelPopup,quitLevelPopup.disCallBackFun);
        end
    end
    closebtn:addTouchEventListener(touchEvent);
    
    
    local textTitle = quitLevelPopup:getChildByName("TextTitle");
    local text = FacFont:getFontsBmp(FontType.FontRed, "Quit the level");
    quitLevelPopup:addChild(text);
    text:setPosition(textTitle:getPosition());
    textTitle:removeFromParent();
    
    local textDes = quitLevelPopup:getChildByName("TextDes");
    text = FacFont:getFontsBmp(FontType.FontRed, "Do you want to quit the level?");
    quitLevelPopup:addChild(text);
    text:setPosition(textDes:getPosition());
    textDes:removeFromParent();
    
    local btnNo = quitLevelPopup:getChildByName("BtnNo");
    local button_Label = btnNo:getChildren()[1];
    text = FacFont:getFontsBmp(FontType.FontRed, "No");
    btnNo:addChild(text);
    text:setPosition(button_Label:getPosition());
    button_Label:removeFromParent();
    
    local btnYes = quitLevelPopup:getChildByName("BtnYes");
    button_Label = btnYes:getChildren()[1];
    text = FacFont:getFontsBmp(FontType.FontRed, "Yes");
    btnYes:addChild(text);
    text:setPosition(button_Label:getPosition());
    button_Label:removeFromParent();

    return quitLevelPopup;
end

function QuitLevelPopup:init()
    MainValue.actionManager:createUIAction():UIAppear(quitLevelPopup);
end

return QuitLevelPopup