local SettingPortal = class("SettingPortal",function()
    return cc.Layer:create();
end)

function SettingPortal:ctor()
    self.setBtn = nil;
    
    self.isInGame = false;
end

function SettingPortal.create()
    local temp = SettingPortal.new()
    temp:init();
    return temp;
end

function SettingPortal:init()
    self.setBtn = ccui.Button:create("ui/ui/btnSetting1.png","ui/ui/btnSetting2.png","",1);
    self:addChild(self.setBtn)
    
    local function onSetting(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
        
            if self.isInGame and not MainValue.mxGameManager:getCanClickGameUI() then
                return;
            end
            
            if MainValue.mxUIManager.mapManager:isInMap() and MainValue.mxUIManager.mapManager:getIsTouch() == false then
                return;
            end
            
            
--            local playable = ad.isPreloaded(advertising.AppLovin_image.index)
--            local playing = ad.show(advertising.AppLovin_image.index)

            
            local SettingPanelCls = require("ui.setting.SettingPanel");
            local settingPanel = SettingPanelCls.create(self.isInGame);
            settingPanel:appearAlone();
        end    
    end
    self.setBtn:addTouchEventListener(onSetting);
end

function SettingPortal:isIngame(isIngame)
    self.isInGame = isIngame;
end

return SettingPortal;