require "ui.threeStar.ThreeStar"
require "ui.panelManager.PanelManager"
require "ui.friendRank.FriendRankPanel"


CheatPanel = class("CheatPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/PlayGamePanel.json");
end);

function CheatPanel:ctor(versionPar,serverAddressPar,gameIdPar,UIdPar,updateVersion,updateStatus, updateFiles, updateMessage)
    
    self.version =  versionPar
    self.serverAddress = serverAddressPar
    self.gameId = gameIdPar
    self.UId = UIdPar
    self.updateStatus = updateStatus
    self.updateFiles = updateFiles
    self.updateMessage = updateMessage
    self.updateVersion = updateVersion;
    
    local txtWidth = 0;
    self.versionTxt = FacFont:getFontsBmp(FontType.FontRed, self.version)--,0, "L")
    self.versionTxt:setPosition(txtWidth, 250);
    self:addChild(self.versionTxt)
    
    self.uidTxt = FacFont:getFontsBmp(FontType.FontRed, self.UId)--,0, "L")
    self.uidTxt:setPosition(txtWidth, 200);
    self:addChild(self.uidTxt)
    
    self.gameIdTxt = FacFont:getFontsBmp(FontType.FontRed, self.gameId)--,0, "L")
    self.gameIdTxt:setPosition(txtWidth, 150);
    self:addChild(self.gameIdTxt)

    self.serverAddressTxt = FacFont:getFontsBmp(FontType.FontRed, self.serverAddress)--,0, "L")
    self.serverAddressTxt:setPosition(txtWidth, 100);
    self:addChild(self.serverAddressTxt)
    
    self.fenjiexianTxt = FacFont:getFontsBmp(FontType.FontRed, "----------------------------")--,0, "L")
    self.fenjiexianTxt:setPosition(txtWidth, 50);
    self:addChild(self.fenjiexianTxt)
    
    self.updateVersionTxt = FacFont:getFontsBmp(FontType.FontRed, self.updateVersion)--,0, "L")
    self.updateVersionTxt:setPosition(txtWidth, 0);
    self:addChild(self.updateVersionTxt)
    
    self.updateStatusTxt = FacFont:getFontsBmp(FontType.FontRed, self.updateStatus)--,0, "L")
    self.updateStatusTxt:setPosition(txtWidth, -50);
    self:addChild(self.updateStatusTxt)
    
    self.updateFilesTxt = FacFont:getFontsBmp(FontType.FontRed, self.updateFiles)--,0, "L")
    self.updateFilesTxt:setPosition(txtWidth, -100);
    self:addChild(self.updateFilesTxt)
    
    self.updateMessageTxt = FacFont:getFontsBmp(FontType.FontRed, self.updateMessage)--,0, "L")
    self.updateMessageTxt:setPosition(txtWidth, -150);
    self:addChild(self.updateMessageTxt)
    
    
    
    self:init()
    return self
end


function CheatPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);
--
    local closebtn = self:getChildByName("btnClose");
--
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:disapper();
        end
    end

    closebtn:addTouchEventListener(touchEvent);
--
--    local titleLab = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, tostring("Level " .. self.level))
--    self:addChild(titleLab);
--    titleLab:setPosition(3, 403);
--
    local btnPlay = self:getChildByName("btnPlay");
    btnPlay:setVisible(false);
--    local playLab = FacFont:getFontsBmp(FontType.FontWhite, "Play");
--    btnPlay:addChild(playLab);
--    playLab:setPosition(157, 69);
--    
--
--    -- touchEvent 触摸事件回调方法
--    local function btnPlayTouchEvent( sender, eventType )
--        if eventType == ccui.TouchEventType.ended then
--            MainValue.actionManager:createJellyAction():run(sender,40);
--            self:onPlay();
--        end
--    end
--
--    btnPlay:addTouchEventListener(btnPlayTouchEvent);
--
--    local _panelStar = self:getChildByName("panelStar")
--    self.curLvData = MainValue.mxGameManager:getStarsStatus();
--    self.needHeart = MainValue.mxGameManager:getNeedHearts();
--    
--    if self.needHeart == 0 then
--        local imgHeart = btnPlay:getChildByName("imgHeart");
--        imgHeart:setVisible(false);
--        playLab:setPositionX(136);
--    end
--
--    self.threeStar = ThreeStar.create(2, self.curLvData)
--    self.threeStar:setPositionY(40)
--    _panelStar:addChild(self.threeStar)
--
--    local _oldScore = nil;
--    local _oldStarNum = nil;
--    _oldScore, _oldStarNum = MainValue.dataManager.levelManager:getLevel(level); -- [[获取历史最好成绩]]
--    self.threeStar:setData(_oldStarNum)
--
--    local needStar = self:getNeedStars();
--
--    if needStar > 0 then
--        self.heartIcon = cc.Sprite:create("ui/ui/iconHeartPlus.png");
--        self.heartIcon:setPosition(-30 + (needStar * 140),40);
--        _panelStar:addChild(self.heartIcon);
--
--        if _oldStarNum >= needStar then
--            self.heartIcon:setOpacity(400);
--        end
--    end
--
--    self.rankPanel = FriendRankPanel.create();
--    self.rankPanel:setData(self.level);
--    MainValue.mxUIManager.layer:addChild(self.rankPanel);
--    self.rankPanel:appear();
--    
--    self.frontPropsPanel:setPosition(-160,-100)
--    self:addChild(self.frontPropsPanel)
--    self.frontPropsPanel:retain()
--    
--    self.flyHeartIcon = cc.Sprite:create("ui/ui/iconHeart2.png");
--    self.flyHeartIcon:setScale(0.8);
--    self:addChild(self.flyHeartIcon);
--    self.flyHeartIcon:setVisible(false);
--    
--    local function updataRank()
--        if self.rankPanel ~= nil then
--            self.rankPanel:disappear();
--        end
--
--        self.rankPanel = FriendRankPanel.create();
--        self.rankPanel:setData(level);
--        self:addChild(self.rankPanel);
--
--        self.rankPanel:appear();
--    end
--
--    self.callBack = updataRank;
--    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_FRIENDS, updataRank);
end

--[[获取奖励心所需星星数]]
function CheatPanel:getNeedStars()
--    for i = 1, table.getn(self.curLvData) do
--        if self.curLvData[i].heart == 1 then 
--            return self.curLvData[i].star;
--        end
--    end
--    
--    return 0;
end

function CheatPanel:onPlay()
--    MainValue.mxFTUEManager:removeFtue();
--    if self.needHeart == 0 then
--        self:startToPlay();
--    else
--        if MainValue.dataManager.userManager:getHeart() >= 1 then
--            MainValue.dataManager.userManager:subHeart(1);
--            self.flyHeartIcon:setVisible(true);
--            
--            local function heartFlyOver()
--                self.isPlay = true;
--                self:disapper();
--            end
--            
--            local ac1 = cc.Sequence:create(cc.EaseIn:create(cc.MoveTo:create(0.3,cc.p(-59, -263)), 0.3),cc.CallFunc:create(heartFlyOver));
--            self.flyHeartIcon:runAction(ac1);
--        else
--            local notEnoughLifes = require("ui/NotEnoughLife")
--            local notEnoughLife = notEnoughLifes.create()
--            notEnoughLife:appearAlone()
--        end
--    end
end

function CheatPanel:startToPlay()
--    self.isPlay = true;
--    self:disapper();
end

function CheatPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete);
    
--    self.rankPanel:appear();
end

function CheatPanel:appearComplete()
--    if MainValue.SELECTED_LEVEL == 11 then
--        MainValue.mxFTUEManager:showFtueById(3);
--    end
--    
--    local pointHeart = self:convertToNodeSpace(cc.p(MainValue.winSize.width / 2 - 56, MainValue.winSize.height - 44))
--    self.flyHeartIcon:setPosition(pointHeart);
end

function CheatPanel:disapper()

--    local tarTable = self.frontPropsPanel:getTarSelectedIds()
--    if table.maxn(tarTable) ~= 0  and self.isPlay then
--        MainValue.mxGameManager:palyGameSetFrontProps(self.frontPropsPanel:getTarSelectedIds());
--    end
--    
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_UP , self.disapperComplete)
--    self.rankPanel:disappear();
end

function CheatPanel:disapperComplete()
--    MainValue.eventDispatcher:removeEventListener(MainValue.eventDispatcher.eventType.EVENT_FRIENDS, self.callBack);

--    if self.isPlay then
--    
--        local function enterGame()
--            MainStatus:onExitMap();
--           
--        --TODO:::  --传给游戏内部选中的前置道具ids
--            MainValue.mxGameManager:enterGame();
--            MainValue.mxLoadingManager:removeLoading();
--        end;
--        MainValue.mxLoadingManager:addLoading();
--        MainValue.mxLoadingManager:loadGame(MainValue.SELECTED_LEVEL,enterGame);
--        
--    end
end

return CheatPanel